SystemOrganization addCategory: #'RPackage-Core'!
SystemOrganization addCategory: #'RPackage-SystemIntegration'!
SystemOrganization addCategory: #'RPackage-Tests'!

TestCase subclass: #RPackageTestCase
	instanceVariableNames: 'announcerForTest oldSystemAnnouncer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

RPackageTestCase subclass: #RPackageImportFromPackageInfoTest
	instanceVariableNames: 'emptyOrganizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageImportFromPackageInfoTest methodsFor: 'utilities' stamp: 'cyrilledelaunay 5/18/2011 14:01'!
XPackageName

	^ #X! !

!RPackageImportFromPackageInfoTest methodsFor: 'utilities' stamp: 'cyrilledelaunay 5/18/2011 14:01'!
XSubcategoryName

	^ 'X-Subcategory'! !

!RPackageImportFromPackageInfoTest methodsFor: 'utilities' stamp: 'cyrilledelaunay 5/18/2011 14:12'!
classInXSubcategoryName

	^#ClassInXSubcategory! !

!RPackageImportFromPackageInfoTest methodsFor: 'setup' stamp: 'PavelKrivanek 7/18/2012 12:51'!
cleanClassesPackagesAndCategories

	|mCPackage|
	Smalltalk globals removeClassNamed: self classInXSubcategoryName.
	Smalltalk organization removeCategory: self XPackageName asString.
	Smalltalk organization removeCategory: self XSubcategoryName.
	mCPackage := self allManagers 
							detect: [:each | each packageName = self XPackageName] 
							ifNone: [nil].
	PackageOrganizer default unregisterPackage: (PackageOrganizer default packagesDictionary at: self XPackageName).
	mCPackage ifNotNil: [mCPackage unregister].
			! !

!RPackageImportFromPackageInfoTest methodsFor: 'private' stamp: 'cyrilledelaunay 5/18/2011 13:56'!
createMethodNamed: methodName inClass: aClass inCategory: aCategoryName 

	^ aClass compile: (methodName, ' ^nil') classified: aCategoryName.! !

!RPackageImportFromPackageInfoTest methodsFor: 'private' stamp: 'cyrilledelaunay 5/18/2011 13:56'!
createNewClassNamed: aName inCategory: aCategoryName
	
	| cls |
	cls := Object subclass: aName asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: aCategoryName.
	^ cls! !

!RPackageImportFromPackageInfoTest methodsFor: 'private' stamp: 'PavelKrivanek 7/18/2012 12:55'!
createNewMCPackageNamed: aSymbol

	PackageInfo registerPackageName: aSymbol.
	MCWorkingCopy forPackage: (MCPackage new name: aSymbol)! !

!RPackageImportFromPackageInfoTest methodsFor: 'private' stamp: 'cyrilledelaunay 5/18/2011 13:56'!
createNewTraitNamed: aName inCategory: aCategoryName
	
	| trait |
	trait := Trait named: aName asSymbol
			uses: {}
			category: aCategoryName.
	^ trait! !

!RPackageImportFromPackageInfoTest methodsFor: 'utilities' stamp: 'cyrilledelaunay 5/18/2011 14:02'!
createXPackage

	self createNewMCPackageNamed: self XPackageName! !

!RPackageImportFromPackageInfoTest methodsFor: 'utilities' stamp: 'cyrilledelaunay 5/18/2011 14:03'!
createXSubCategory

	Smalltalk globals organization addCategory: self XSubcategoryName.
	! !

!RPackageImportFromPackageInfoTest methodsFor: 'utilities' stamp: 'cyrilledelaunay 5/18/2011 14:15'!
createXSubCategoryClass

	^ self createNewClassNamed:  self classInXSubcategoryName inCategory:  self XSubcategoryName.
	! !

!RPackageImportFromPackageInfoTest methodsFor: 'accessing' stamp: 'cyrilledelaunay 5/18/2011 13:50'!
emptyOrganizer

	^ emptyOrganizer! !

!RPackageImportFromPackageInfoTest methodsFor: 'setup' stamp: 'StephaneDucasse 6/3/2012 23:25'!
setUp 
	super setUp.
	emptyOrganizer := self packageOrganizerClass new debuggingName: 'RPackageImportsFromPackageInfo Package Organizer'.
	! !

!RPackageImportFromPackageInfoTest methodsFor: 'setup' stamp: 'GuillermoPolito 4/27/2012 13:27'!
tearDown
	self cleanClassesPackagesAndCategories.
	super tearDown.
	! !

!RPackageImportFromPackageInfoTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:02'!
testImportExtensionFromParentPackageRegisterExtensionInParentPackage

	"
	When importing from PackageInfo :
	test that when a package extend a class from a sub-category of this package, the extension method is well registered as extension method of this package "
	"self run: #testImportExtensionFromParentPackageRegisterExtensionInParentPackage"
	|tmpClass XPackage|
	[self createXPackage.
	self createXSubCategory.
	tmpClass := self createXSubCategoryClass.
	self createMethodNamed:  #stubMethod inClass: tmpClass inCategory: '*',self XPackageName asString.
	self emptyOrganizer importFromPackageInfo: (PackageOrganizer default packagesDictionary at: self XPackageName asString).
	self emptyOrganizer importFromPackageInfo: (PackageOrganizer default packagesDictionary at: self XSubcategoryName).
	XPackage := self emptyOrganizer packageNamed: self XPackageName.
	"this test does not work because we have two different organizers: one from emptyOrganizer and one reached by the propagation of event"
	"self assert: ((tmpClass>>#stubMethod) packageFromOrganizer: self emptyOrganizer)  = XPackage."
	self assert: (XPackage includesExtensionSelector:  #stubMethod ofClass: tmpClass).   
	] 

	ensure: [
		emptyOrganizer = nil
	] 	   ! !

RPackageTestCase subclass: #RPackageIncrementalTest
	instanceVariableNames: 'createdClasses createdPackages createdCategories'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageIncrementalTest commentStamp: 'StephaneDucasse 5/15/2010 20:21' prior: 0!
The tests takes as fixture the following situation (which is constructed partially)
For tests that do not need to check the incremental construction.


P1 
	A1DefinedInP1>>methodDefinedInP1
	B1DefinedInP1	
	A2DefinedInP2>>methodDefinedInP1  (was *P2)
	
P2
	A2DefinedInP2>>methodDefinedInP2
	B2DefinedInB2	

P3
	A3DefinedInP3	
	A2DefinedInP2>>methodDefinedInP3  (was *P2*)!

RPackageIncrementalTest subclass: #RPackageCompleteSetupButForModificationTest
	instanceVariableNames: 'p1 p2 p3 a1 b1 a2 a3 b2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageCompleteSetupButForModificationTest methodsFor: 'setup' stamp: '2010-11-26T09:22:00+01:00'!
setUp
	super setUp.
	p1 := self createNewPackageNamed: self p1Name.
	p2 := self createNewPackageNamed: self p2Name.
	p3 := self createNewPackageNamed: self p3Name.
	
	a1 :=  self createNewClassNamed: #A1DefinedInP1 inPackage: p1.
	b1 := self createNewClassNamed: #B1DefinedInP1 inPackage: p1.
	a2 := self createNewClassNamed: #A2DefinedInP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2DefinedInP2 inPackage: p2.
	a3 := self createNewClassNamed: #A3DefinedInP3 inPackage: p3.
	
	a1 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#methodDefinedInP1).
	a1 compileSilently: 'anotherMethodDefinedInP1 ^ #anotherMethodDefinedInP1'.
	p1 addMethod: (a1>>#anotherMethodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).

	a2 class compileSilently: 'classSideMethodDefinedInP3 ^ #classSideMethodDefinedInP3'.
	p3 addMethod: (a2 class>>#classSideMethodDefinedInP3)

! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-22T07:53:00+01:00'!
testAddMethod
	"self debug: #testAddMethod"
	
	self assert: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	
	a1 compileSilently: 'zork ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#zork).
	self assert: (p1 includesSelector: #zork ofClass: a1).
	
	self assert: (p3 includesSelector: #classSideMethodDefinedInP3 ofClass: a2 class)
	! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-22T07:59:00+01:00'!
testBasicRemoveClass
	"we remove a class we check that it is not in the package anymore"
	"self debug: #testBasicRemoveClass"	

	|  size |
	size := p1 definedClasses size. 
	self assert: size = 2.
	self assert: (p1 includesClass: a1).
	self assert: (p1 includesClass: a1 class).
	p1 removeClassDefinition: a1.
	self assert: p1 definedClasses size = (size - 1).
	self assert: (p1 includesClass: b1).
	self assert: (p1 includesClass: b1 class).
	self deny: (p1 includesClass: a1).
	self deny: (p1 includesClass: a1 class).
	p1 removeClassDefinition: b1.
	self assert: p1 definedClasses size = (size - 2).
	self deny: (p1 includesClass: b1).
	self deny: (p1 includesClass: b1 class).

! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test starting situation' stamp: '2010-04-24T22:31:00+01:00'!
testExtensionMethodOfClass
	"self debug: #testExtensionMethodOfClass"
	
	"P1 
		A1DefinedInP1>>methodDefinedInP1
		B1DefinedInP1	
		A2DefinedInP2>>methodDefinedInP1  (was *P2)
	
	P2
		A2DefinedInP2>>methodDefinedInP2
		B2DefinedInB2	

	P3
		A3DefinedInP3	
		A2DefinedInP2>>methodDefinedInP3  (was *P2*)"
		
	self assert: a2 methodDict keys size = 3.
	"the class contains methods defined by several packages 
	however when looking with a package view we only see the package 
	extension."
		
	self assert: (p2 extensionMethodsForClass: a2) size = 0.
	self assert: (p1 extensionMethodsForClass: a1) size = 0.
	"show that extensionMethodsForClass: does works for methods of class
	defined in the package"
	
	self assert: (p1 extensionMethodsForClass: a2) size = 1.
	self assert: (p3 extensionMethodsForClass: a2) size = 1.! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-24T22:28:00+01:00'!
testRemoveMethod
	"self debug: #testRemoveMethod"
	
	p1 removeMethod: a1 >> #methodDefinedInP1.
	self deny: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-24T22:27:00+01:00'!
testRemoveMethodDoesNotRemoveFromClass
	"we remove a method so it is not in the package but also not from the class anymore"
	"self debug: #testRemoveMethodDoesNotRemoveFromClass"
	
	p1 removeMethod:  a1 >> #methodDefinedInP1.
	self deny: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	self assert: (a1 selectors includes: #methodDefinedInP1)! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test addition' stamp: '2010-04-24T22:28:00+01:00'!
testRemoveShouldRaiseErrorWhenMethodIsNotInPackage
	"self debug: #testRemoveShouldRaiseErrorWhenMethodIsNotInPackage"
	
	self should: [p2 removeMethod: a2>>#methodDefinedZork] raise: Error! !

!RPackageCompleteSetupButForModificationTest methodsFor: 'test starting situation' stamp: '2010-04-22T07:52:00+01:00'!
testStartingSituation
	"self debug: #testStartingSituation"
	
	self deny: (p2 includesClass: b1).
	self assert: (p2 includesClass: b2).
	"a locally defined class not extended by other packages"
	
	self assert: (p2 includesClass: a2).  
	"a locally defined class extended by other packages"
	
	self assert: (p1 definesOrExtendsClass: a2).
	self deny: (p1 includesClass: a2).! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-06-13T15:41:00+01:00'!
createNewClassNamed: aName
	^ self createNewClassNamed: aName inCategory: 'RPackageTest'! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-11-26T09:16:00+01:00'!
createNewClassNamed: aName inCategory: cat
	
	| cls |
	cls := Object subclass: aName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: cat.
	createdClasses add: cls.
	createdCategories add: cat.
	^ cls! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-03-11T13:28:00+01:00'!
createNewClassNamed: aName inPackage: p
	
	| cls |
	cls := self createNewClassNamed: aName.
	p addClassDefinition: cls.
	^ cls! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: 'EstebanLorenzano 7/27/2012 19:53'!
createNewPackageNamed: aName

	| pack |
	self removePackage: aName.
	pack := self packageClass named: aName.
	createdPackages add: pack.
	^ pack! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: 'StephaneDucasse 5/9/2011 16:47'!
createNewTraitNamed: aName
	^ self createNewTraitNamed: aName inCategory: 'RPackageTest'! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: 'cyrilledelaunay 5/10/2011 11:39'!
createNewTraitNamed: aName inCategory: cat
	
	| cls |
	cls := Trait named: aName
			uses: {}
			category: cat.
	createdClasses add: cls.
	createdCategories add: cat.
	^ cls! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: 'StephaneDucasse 5/9/2011 17:48'!
createNewTraitNamed: aName inPackage: p
	
	| cls |
	cls := self createNewTraitNamed: aName.
	p addClassDefinition: cls.
	^ cls! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-11-26T09:18:00+01:00'!
p1Name
	^ 'RPackageTestP1'! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-11-26T09:23:00+01:00'!
p2Name
	^ 'RPackageTestP2'

! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-11-26T09:23:00+01:00'!
p3Name
	^ 'RPackageTestP3'

! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: '2010-06-13T17:18:00+01:00'!
removeClassNamedIfExists: aClassNameSymbol
	Smalltalk at: aClassNameSymbol asSymbol ifPresent: [:c| c removeFromSystem]! !

!RPackageIncrementalTest methodsFor: 'utility' stamp: 'StephaneDucasse 6/3/2012 22:46'!
removePackage: aName
	self packageClass organizer basicUnregisterPackageNamed: aName.
	! !

!RPackageIncrementalTest methodsFor: 'setup' stamp: 'GuillermoPolito 4/27/2012 13:24'!
setUp
	super setUp.
	createdClasses := OrderedCollection new.
	createdPackages := OrderedCollection new.
	createdCategories := Set new.
	Author fullName ifNil: [Author fullName: 'RPackage'].! !

!RPackageIncrementalTest methodsFor: 'setup' stamp: 'StephaneDucasse 6/3/2012 22:46'!
tearDown
	
	| logging |
	createdPackages  do: [:each | self removePackage: each name].
	"just remove package from package organizer dictionary"
	
	createdPackages  do: [:each |
		|mCPackage|
		mCPackage := self allManagers 
							detect: [:mcPackage | mcPackage packageName = each packageName asString] 
							ifNone: [nil].
		mCPackage ifNotNil: [mCPackage unregister].
		each extendedClasses do: [ :extendedClass|
			self packageClass organizer
		 		unregisterExtendingPackage: each forClass: extendedClass.]].
	"all ***extending*** classes the packages are also unregistered from PackageOrganizer"									
	(createdClasses reject: [:c| c isObsolete]) do: [:cls| 
		"(RPackage organizer includesPackageBackPointerForClass: cls) 
			ifTrue: [cls package unregisterClass: cls.]. 
		when RPackageOrganizer was not looking at system event we had to do the commented actions"
		logging := false.
		cls removeFromSystem: logging.  
		"not logging so no event are raised"
		"but this also means that the consistency cannot be ensured by internal system announcer too."
		].					
	createdCategories do: [:each | 
		|mCPackage|
		SystemOrganization removeCategory: each.
		 ].
	super tearDown.! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testAddClassAfterMethods
	"self debug: #testAddClassAfterMethods"

	| p1 a1 b1 |
	p1 := self createNewPackageNamed: self p1Name.
	"the class is created but not added to the package for now"
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	self assert: p1 definedClasses size = 0.
	
	"now we add a new method to the class and the to the package: it is considered
	as class extension"
	
	a1 compileSilently: 'newlyAddedToA1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#newlyAddedToA1).
	self assert: (p1 includesSelector: #newlyAddedToA1 ofClass: a1).
	self assert: (p1 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	self deny: (p1 includesDefinedSelector: #newlyAddedToA1 ofClass: a1).
	
	"Now we add the class and this means that the method is not an extension anymore but 
	a defined method"
	
	p1 addClassDefinition: a1.
	self assert: p1 definedClasses size = 1.
	
	self deny: (p1 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	self assert: (p1 includesDefinedSelector: #newlyAddedToA1 ofClass: a1).
	
	
"
	self assert: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	self assert: (p3 includesSelector: #classSideMethodDefinedInP3 ofClass: a2 class)
	"! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testAddClassAfterMethodsAtMetaclassToo
	"self debug: #testAddClassAfterMethodsAtMetaclassToo"

	| p1 a1 b1 |
	p1 := self createNewPackageNamed: self p1Name.
	"the class is created but not added to the package for now"
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	self assert: p1 definedClasses size = 0.
	
	"now we add a new method to the class and the to the package: it is considered
	as class extension"
	
	a1 class compileSilently: 'newlyAddedToA1Class ^ #methodDefinedInP1'.
	p1 addMethod: (a1 class>>#newlyAddedToA1Class).
	self assert: (p1 includesSelector: #newlyAddedToA1Class ofClass: a1 class).
	self assert: (p1 includesExtensionSelector: #newlyAddedToA1Class ofClass: a1 class).
	self deny: (p1 includesDefinedSelector: #newlyAddedToA1Class ofClass: a1 class).
	
	"Now we add the class and this means that the method is not an extension anymore but 
	a defined method"
	
	p1 addClassDefinition: a1.
	self assert: p1 definedClasses size = 1.
	
	self deny: (p1 includesExtensionSelector: #newlyAddedToA1Class ofClass: a1 class).
	self assert: (p1 includesDefinedSelector: #newlyAddedToA1Class ofClass: a1 class).
	
	
"
	self assert: (p1 includesSelector: #methodDefinedInP1 ofClass: a1).
	self assert: (p3 includesSelector: #classSideMethodDefinedInP3 ofClass: a2 class)
	"! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testAddClassDefinitionNoDuplicate
	"self debug: #testAddClassDefinitionNoDuplicate"

	| p a1 b1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	b1 := self createNewClassNamed: #B1InPackageP1 inCategory: self p1Name.
	p addClassDefinition: a1.
	"adding the same class does not do anything - luckily"
	self assert: p definedClasses size = 1.
	p addClassDefinition: b1.
	self assert: p definedClasses size = 2.
! !

!RPackageIncrementalTest methodsFor: 'test method addition removal' stamp: '2010-06-13T15:47:00+01:00'!
testAddRemoveMethod
	"self debug: #testAddRemoveMethod"
	
	| p1 p2 p3 a2   a2Name |
	a2Name := #A2InPackageP2.
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: a2Name inPackage: p2.
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	
	p2 addMethod: (a2>>#methodDefinedInP2).
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).
	
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2Name).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2Name).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2Name).
	
	"removeMethod by default removes from defined methods and not extension"
	p2 removeMethod: (a2>>#methodDefinedInP2).
	self deny: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2Name).
	
	p1 removeMethod: (a2>>#methodDefinedInP1).
	self deny: (p1 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2Name).
	self deny: (p1 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2Name).! !

!RPackageIncrementalTest methodsFor: 'test method addition removal' stamp: '2010-06-13T15:46:00+01:00'!
testAddRemoveSelector
	"self debug: #testAddRemoveSelector"
	
	| p1 p2 p3 a2   a2Name |
	a2Name := #A2InPackageP2.
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: a2Name inPackage: p2.
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addSelector: #methodDefinedInP2 ofClassName: a2Name.
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addSelector: #methodDefinedInP1 ofClassName: a2Name.
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addSelector: #methodDefinedInP3 ofClassName: a2Name.
	
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2Name).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2Name).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2Name).
	
	p2 removeSelector: #methodDefinedInP2 ofClassName:  a2Name.
	self deny: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2Name).
	
	p1 removeSelector: #methodDefinedInP1 ofClassName:  a2Name.
	self deny: (p1 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2Name).
	self deny: (p1 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2Name).! !

!RPackageIncrementalTest methodsFor: 'test method addition removal' stamp: '2010-06-13T15:47:00+01:00'!
testAddRemoveSelectorOfMetaclass
	"self debug: #testAddRemoveSelectorOfMetaclass"
	
	| p1 p2 p3 a2   a2Name a2class |
	a2Name := #A2InPackageP2.
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: a2Name inPackage: p2.
	a2class := a2 class.
	a2class compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addSelector: #methodDefinedInP2 ofMetaclassName: a2Name.
	a2class compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addSelector: #methodDefinedInP1 ofMetaclassName: a2Name.
	a2class compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addSelector: #methodDefinedInP3 ofMetaclassName: a2Name.
	
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofMetaclassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofMetaclassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofMetaclassName: a2Name).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofMetaclassName: a2Name).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofMetaclassName: a2Name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofMetaclassName: a2Name).
	
	p2 removeSelector: #methodDefinedInP2 ofMetaclassName:  a2Name.
	self deny: (p2 includesDefinedSelector: #methodDefinedInP2 ofMetaclassName: a2Name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofMetaclassName: a2Name).
	
	p1 removeSelector: #methodDefinedInP1 ofMetaclassName:  a2Name.
	self deny: (p1 includesDefinedSelector: #methodDefinedInP3 ofMetaclassName: a2Name).
	self deny: (p1 includesExtensionSelector: #methodDefinedInP3 ofMetaclassName: a2Name).! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testBogusClassAddition
	"self debug: #testBogusClassAddition"

	| p a1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinitionName: a1 name.
	self assert: p definedClasses size = 1.
	self assert: (p includesClass: a1).
	self should: [p addClassDefinitionName: a1 class name] raise: Error.
! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testClassAddition
	"self debug: #testClassAddition"

	| p a1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	self assert: (p includesClass: a1).
	self assert: (p includesClass: a1 class)
! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testClassDefinitionRemoval
	"self debug: #testClassDefinitionRemoval"

	| p a1 b1|
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	b1 := self createNewClassNamed: #B1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	p addClassDefinition: b1.
	self assert: p definedClasses size = 2.
	self assert: (p includesClass: a1).
	self assert: (p includesClass: b1).
	p removeClassDefinition: a1.
	self assert: p definedClasses size = 1.
	self deny: (p includesClass: a1).
	self assert: (p includesClass: b1).
	p removeClassDefinition: b1 class.
	self deny: (p includesClass: b1).
! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:19:00+01:00'!
testClassDefinitionRemovalName
	"self debug: #testClassDefinitionRemovalName"

	| p a1 b1|
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	b1 := self createNewClassNamed: #B1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinitionName: a1 name.
	p addClassDefinitionName: b1 name.
	self assert: p definedClasses size = 2.
	self assert: (p includesClass: a1).
	self assert: (p includesClass: b1).
	p removeClassDefinitionName: a1 name.
	self assert: p definedClasses size = 1.
	self deny: (p includesClass: a1).
	self assert: (p includesClass: b1).
	self should: [p removeClassDefinitionName: b1 class name] raise: Error.
	p removeClassDefinitionName: b1  name.
	self deny: (p includesClass: b1).
! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-06-13T15:47:00+01:00'!
testClasses
	"self debug: #testClasses"
	
	| p1 p2 a2  b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (a2>>#methodPackagedInP1).
	b2 class compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (b2 class>>#methodPackagedInP1).
	
	self assert: p1 classes size = 2.
	self assert: p2 classes size = 2.! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:20:00+01:00'!
testDefinedClassesAndDefinedClassNames
	"self debug: #testDefinedClassesAndDefinedClassNames"

	| p a1 b1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	self assert: (p definedClasses  includes: a1).
	self assert: (p definedClassNames includes: a1 name).
	
	b1 := self createNewClassNamed: #B1InPackageP1 inCategory: self p1Name.
	p addClassDefinition: b1.
	self assert: p definedClasses size = 2.
	self assert: (p definedClasses includes: b1).
	self assert: (p definedClassNames includes: b1 name).
	! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-25T17:38:00+01:00'!
testExtensionClassNames
	"self debug: #testExtensionClassNames"
	
	| p1 p2  a2 b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	self deny: (p1 includesClass: a2).
	self assert: (p2 includesClass: b2).
	self assert: (p2 includesClass: a2).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addSelector: #methodDefinedInP1 ofClassName: a2 name.
	
	self assert: p1 extensionSelectors size = 1.
	self assert: p1 extensionMethods size = 1.
	self assert: (p1 extendedClassNames includes: #A2InPackageP2).
	self deny: (p1 includesClass: a2).
	"method extension class are not included in packages"
	
	b2 compile: 'firstMethodInB2PackagedInP1 ^ 1'.
	p1 addSelector: #firstMethodInB2PackagedInP1 ofClassName: b2 name.
	
	self assert: p1 extensionSelectors  size = 2.
	self assert: p1 extensionMethods  size = 2.
	self assert: (p1 extendedClassNames includes: #B2InPackageP2).
	self deny: (p1 includesClass: b2).
	
	b2 compileSilently: 'secondMethodInB2PackagedInP1 ^ 2'.
	p1 addSelector: #secondMethodInB2PackagedInP1 ofClassName: b2 name.
	
	self assert: p1 extensionSelectors  size = 3.
	self assert: p1 extensionMethods  size = 3.
	self assert: p1 extendedClasses size = 2.
	self assert: (p1 extendedClassNames includes: #B2InPackageP2).
	self deny: (p1 includesClass: b2).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-06-13T15:47:00+01:00'!
testExtensionClasses
	"self debug: #testExtensionClasses"
	
	| p1 p2 a2  b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	self deny: (p1 includesClass: a2).
	self assert: (p2 includesClass: a2).
	
	a2 compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (a2>>#methodPackagedInP1).
	
	self assert: p1 extendedClasses size = 1.
	self assert: (p1 extendedClasses  includes: a2).
	self assert: p1 extendedClassNames size = 1.
	self assert: (p1 extendedClassNames  includes: a2 name).
	
	b2 class compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (b2 class>>#methodPackagedInP1).
	
	self assert: p1 extendedClasses size = 2.
	self assert: (p1 extendedClasses  includes: b2 class).
	"extensionClasses returns or metaclasses while extensionClassNames returns class names (but not metaclass names)"

	self assert: p1 extendedClassNames size = 2.
	self assert: (p1 extendedClassNames  includes: b2 name).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-25T17:45:00+01:00'!
testExtensionClassesWithCompiledMethod
	"self debug: #testExtensionClassesWithCompiledMethod"
	
	| p1 p2  a2 b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	self deny: (p1 includesClass: a2).
	self assert: (p2 includesClass: b2).
	self assert: (p2 includesClass: b2).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	self assert: p1 extensionMethods size = 1.
	self assert: p1 extensionSelectors size = 1.
	self assert: p1 extendedClasses size = 1.
	self deny: (p1 includesClass: a2).
	"method extension class are not included in packages"
	
	b2 compile: 'firstMethodInB2PackagedInP1 ^ 1'.
	p1 addMethod: (b2>>#firstMethodInB2PackagedInP1).
	
	self assert: p1 extensionSelectors  size = 2.
	self assert: p1 extensionMethods  size = 2.
	self assert: p1 extendedClasses size = 2.
	self deny: (p1 includesClass: b2).
	
	b2 compileSilently: 'secondMethodInB2PackagedInP1 ^ 2'.
	p1 addMethod: (b2>>#secondMethodInB2PackagedInP1).
	
	self assert: p1 extensionSelectors  size = 3.
	self assert: p1 extensionMethods  size = 3.
	self assert: p1 extendedClasses size = 2.
	self deny: (p1 includesClass: b2).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-25T17:13:00+01:00'!
testExtensionMethods
	"self debug: #testExtensionMethods"
	
	| p1 p2 a2  b2 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	self assert: p1 extensionSelectors  size = 1.
	self deny: (p1 includesClass: a2).
	"method extension class are not included in packages"
	
	b2 compileSilently: 'firstMethodInB2PackagedInP1 ^ 1'.
	p1 addMethod: (b2>>#firstMethodInB2PackagedInP1).
	self assert: p1 extensionSelectors  size = 2.
	! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-03-11T14:35:00+01:00'!
testIncludeClass
	"self debug: #testIncludeClass"
	
	| p1 p2 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	
	self deny: (p1 includesClass: a2).
	p1 addMethod: (a2>>#methodPackagedInP1).
	self deny: (p1 includesClass: a2).
	"We should declare the class explictly. Adding a method does not declare
	the class as defined. The reason is that like that the client controls the granularity 
	and moment of class registration."
	
	p1 addClassDefinition: a2.
	self assert: (p1 includesClass: a2).
	self assert: (p1 includesClassNamed: a2 name).
	
	! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-21T09:29:00+01:00'!
testIncludeClassMore
	"self debug: #testIncludeClassMore"
	
	| p1 p2 p3 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).
	
	self assert: (p2 includesClass: a2).
	self deny: (p1 includesClass: a2).
	self deny: (p3 includesClass: a2).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-21T09:29:00+01:00'!
testIncludeSelectorOfClass
	"self debug: #testIncludeSelectorOfClass"
	
	| p1 p2 p3 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).
	
	"includesSelector checks both in defined and extension so we test both"
	self assert: (p2 includesSelector: #methodDefinedInP2 ofClass: a2).
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2 name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofClassName: a2 name).
	
	self deny: (p2 includesSelector: #methodDefinedInP3 ofClass: a2).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2 name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2 name).
	
	self deny: (p2 includesSelector: #methodDefinedInP1 ofClass: a2).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2 name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2 name).! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-21T09:29:00+01:00'!
testIncludeSelectorOfMetaClass
	"self debug: #testIncludeSelectorOfMetaClass"
	
	| p1 p2 p3 a2  a2class |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2class := a2 class.
	a2class compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2class>>#methodDefinedInP2).
	a2class compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2class>>#methodDefinedInP1).
	a2class compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2class>>#methodDefinedInP3).
	
	"includesSelector checks both in defined and extension so we test both"
	self assert: (p2 includesSelector: #methodDefinedInP2 ofClass: a2class).
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofMetaclassName: a2 name).
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClass: a2class).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP2 ofMetaclassName: a2 name).
	
	self deny: (p2 includesSelector: #methodDefinedInP3 ofClass: a2).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofMetaclassName: a2 name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP3 ofMetaclassName: a2 name).
	
	self deny: (p2 includesSelector: #methodDefinedInP1 ofMetaclassName: a2).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofMetaclassName: a2 name).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClass: a2 class).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2 name).
	self deny: (p3 includesDefinedSelector: #methodDefinedInP1 ofClass: a2).
! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: 'StephaneDucasse 4/24/2011 20:25'!
testIncludesMethodOfClassInPresenceOfOtherPackageExtensions
	"self debug: #testIncludesMethodOfClassInPresenceOfOtherPackageExtensions"
	
	| p1 p2 p3 a2  a2name |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.
	a2name := #A2InPackageP2.
	a2 := self createNewClassNamed: a2name inPackage: p2.
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2name).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	self assert: (p1 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2name).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2name).
		
	self assert: (p2 includesDefinedSelector: #methodDefinedInP2 ofClassName: a2name).
	self deny: (p2 includesDefinedSelector: #methodDefinedInP3 ofClassName: a2name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2name).
	self deny: (p2 includesDefinedSelector: #methodDefinedInP1 ofClassName: a2name).
	self deny: (p2 includesExtensionSelector: #methodDefinedInP1 ofClassName: a2name).
	
	
	! !

!RPackageIncrementalTest methodsFor: 'test extension' stamp: '2010-04-25T17:46:00+01:00'!
testIncludesOrTouches
	"self debug: #testIncludesOrTouches"
	
	| p1 p2 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	self deny: (p1 includesClass: a2).
	self assert: (p2 includesClass: a2).
	
	a2 compileSilently: 'methodPackagedInP1 ^ #methodPackagedInP1'.
	p1 addMethod: (a2>>#methodPackagedInP1).
	
	self assert: p1 extensionMethods size = 1.
	self assert: p1 extensionSelectors size = 1.
	self deny: (p1 includesClass: a2).
	self assert: (p1 definesOrExtendsClass: a2).
	self assert: (p2 includesClass: a2).! !

!RPackageIncrementalTest methodsFor: 'test method addition removal' stamp: '2010-03-11T16:50:00+01:00'!
testMethodAddition
	"self debug: #testMethodAddition"

	| p1 a1 methodRef |
	p1 := self createNewPackageNamed: 'P1'.
	a1 := self createNewClassNamed: #A1DefinedInP1 inPackage: p1.
	a1 compileSilently: 'foo ^ 10'.
	p1 addMethod:  (a1>>#foo).
	self assert: (p1 includesSelector: #foo ofClass: a1).
	! !

!RPackageIncrementalTest methodsFor: 'test package belonging' stamp: '2010-04-25T17:33:00+01:00'!
testPackageOfClassForClassesNotDefinedInPackageButJustExtendingIt
	"self debug: #testPackageOfClassForClassesNotDefinedInPackageButJustExtendingIt"
	
	| p1 p2 a2  |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.

	a2 := self createNewClassNamed: #A2InPackageP2 inPackage: p2.
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	self assert: a2 package = p2.
	p1 extensionMethods do: 
		[:each | self deny: each methodClass package = p1 ].
	"the package of a class which is extended inside a package p, is not p
	but the package where the class was defined"! !

!RPackageIncrementalTest methodsFor: 'test package belonging' stamp: '2010-03-11T16:46:00+01:00'!
testPackageOfClassForDefinedClasses
	"self debug: #testPackageOfClassForDefinedClasses"
	
	| p a1 b1 |
	p := self createNewPackageNamed: 'P1'.
	a1 := self createNewClassNamed: #A1InPAckageP1 inPackage: p.
	b1 := self createNewClassNamed: #B1InPAckageP1 inPackage: p.

	self assert: a1 package = p.
	self assert: b1 package = p.
! !

!RPackageIncrementalTest methodsFor: 'test registration' stamp: 'StephaneDucasse 6/3/2012 22:47'!
testPrivateClassRegisterUnregister
	"Verify that when we register a class, the package organizer register it."
	"self debug: #testPrivateClassRegisterUnregister"

	| p a1 b1 |
	p := self createNewPackageNamed: 'P1'.
	a1 := self createNewClassNamed: #A1InPackageP1.
	p definedClassNames add: #A1InPackageP1.
		"ugly but necessary to test registerClass: independantly from addClassDefinition:"
		"No event should be raised."
	p registerClass: a1.
	self assert: (self packageClass organizer packageOf: a1) = p.
	p definedClassNames remove: #A1InPackageP1.
	p unregisterClass: a1.
	self assert: (self packageClass organizer packageOf: a1) isDefault.
	
	p definedClassNames add: #A1InPackageP1.
		"ugly but necessary to test registerClass: independant from addClassDefinition:"
	p registerClassName: a1 name.
	self assert: (self packageClass organizer packageOf: a1) = p.
	p definedClassNames remove: #A1InPackageP1.
	p unregisterClassName: a1 name.
	self assert: (self packageClass organizer packageOf: a1) isDefault
	! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:20:00+01:00'!
testRemoveClassAfterMethods
	"self debug: #testRemoveClassAfterMethods"

	| p1 a1 b1 |
	p1 := self createNewPackageNamed: self p1Name.
	"the class is created but not added to the package for now"
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	p1 addClassDefinition: a1.
	self assert: p1 definedClasses size = 1.
	a1 compileSilently: 'newlyAddedToA1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#newlyAddedToA1).
	
	"now we add a new method to the class and the to the package: it is considered
	as defined"
	self deny: (p1 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	self assert: (p1 includesDefinedSelector: #newlyAddedToA1 ofClass: a1).
	
	p1 removeClassDefinition: a1.
	self assert: p1 definedClasses size = 0.
	
	self assert: (p1 includesSelector: #newlyAddedToA1 ofClass: a1).
	self assert: (p1 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	self deny: (p1 includesDefinedSelector: #newlyAddedToA1 ofClass: a1).
	
	"Now we add the class and this means that the method is not defined anymore but an extension "
	! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: 'GuillermoPolito 8/5/2012 13:34'!
testRemoveClassRemovesExtensions
	"self debug: #testRemoveClassRemovesExtensions"

	| p1 p2 a1 b1 |
	p1 := self createNewPackageNamed: self p1Name.
	p2 := self createNewPackageNamed: self p2Name.
	"the class is created but not added to the package for now"
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	p1 addClassDefinition: a1.
	self assert: p1 definedClasses size = 1.
	a1 compileSilently: 'newlyAddedToA1 ^ #methodDefinedInP1'.
	p2 addMethod: (a1>>#newlyAddedToA1).
	
	self assert: (p2 includesSelector: #newlyAddedToA1 ofClass: a1).
	self assert: (p2 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	
	a1 removeFromSystem.
	
	self deny: (p2 includesSelector: #newlyAddedToA1 ofClass: a1).
	self deny: (p2 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	self deny: (p2 includesDefinedSelector: #newlyAddedToA1 ofClass: a1).! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: 'GuillermoPolito 8/5/2012 13:15'!
testRemoveExtensionMethodRemovesExtensionsFromRPackage
	"self debug: #testRemoveClassRemovesExtensions"

	| p1 p2 a1 b1 |
	p1 := self createNewPackageNamed: self p1Name.
	p2 := self createNewPackageNamed: self p2Name.
	"the class is created but not added to the package for now"
	a1 := self createNewClassNamed: #A1InPackageP1 inCategory: self p1Name.
	p1 addClassDefinition: a1.
	self assert: p1 definedClasses size = 1.
	a1 compileSilently: 'newlyAddedToA1 ^ #methodDefinedInP1'.
	p2 addMethod: (a1>>#newlyAddedToA1).
	
	self assert: (p2 includesSelector: #newlyAddedToA1 ofClass: a1).
	self assert: (p2 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	
	a1 removeSelector: #newlyAddedToA1.
	
	self deny: (p2 includesSelector: #newlyAddedToA1 ofClass: a1).
	self deny: (p2 includesExtensionSelector: #newlyAddedToA1 ofClass: a1).
	self deny: (p2 includesDefinedSelector: #newlyAddedToA1 ofClass: a1).! !

!RPackageIncrementalTest methodsFor: 'test class addition removal' stamp: '2010-11-26T09:20:00+01:00'!
testUniqueClassInDefinedClassesUsingAddClassDefinition
	"self debug: #testUniqueClassInDefinedClassesUsingAddClassDefinition"

	| p a1 |
	p := self createNewPackageNamed: self p1Name.
	a1 := self createNewClassNamed: #A1InPAckageP1 inCategory: self p1Name.
	self assert: p definedClasses size = 0.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	p addClassDefinition: a1.
	self assert: p definedClasses size = 1.
	p addClassDefinition: a1 class.
	self assert: p definedClasses size = 1.

! !

RPackageIncrementalTest subclass: #RPackageObsoleteTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageObsoleteTest methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 8/3/2012 14:21'!
testAnnouncementClassRemovedIsRaisedOnRemoveFromSystem
	"self debug: #testAnnouncementClassRemovedIsRaisedOnRemoveFromSystem"
	| notRun foo | 
	notRun := false.
	SystemAnnouncer uniqueInstance weak 
		on: ClassRemoved do: [:ann | notRun := true].
	foo := self createNewClassNamed: #FooForTest2.
	self deny: notRun.
	foo removeFromSystem.
	self assert: notRun. ! !

!RPackageObsoleteTest methodsFor: 'as yet unclassified' stamp: 'EstebanLorenzano 7/27/2012 19:40'!
testMethodPackageFromObsoleteClass
	"self debug: #testMethodPackageFromObsoleteClass"
	
	| pack method foo | 
	[
	pack := self createNewPackageNamed: 'P1'.
	foo := self createNewClassNamed: #FooForTest inPackage: pack.
	foo compile: 'bar ^42'.
	method := foo>>#bar.

	foo obsolete.
	self assert: (method packageFromOrganizer: pack organizer) equals: foo package.
	] ensure: [ 
		foo ifNotNil: [ 
			foo setName: foo originalName.
			foo removeFromSystem.
			].
		Smalltalk globals removeKey: #FooForTest  ifAbsent:  [].
	]! !

!RPackageObsoleteTest methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 5/29/2012 13:25'!
testMethodPackageOfRemovedClass
	"self debug: #testMethodPackageOfRemovedClass"
	
	| pack method foo | 
	pack := self createNewPackageNamed: 'P1'.
	foo := self createNewClassNamed: #FooForTest2 inPackage: pack.
	foo compileSilently: 'bar ^42'.
	method := foo>>#bar.
	foo removeFromSystem.
	self deny: (pack includesClassNamed: #FooForTest2 )
	
	! !

RPackageIncrementalTest subclass: #RPackageReadOnlyCompleteSetupTest
	instanceVariableNames: 'p1 p2 p3 a1 b1 a2 a3 b2 p4'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageReadOnlyCompleteSetupTest commentStamp: 'StephaneDucasse 4/13/2011 17:10' prior: 0!
The tests takes as fixture the following situation and exercises the readonly queries.
We should be able to use a test resources to speed it up.

P1 
	A1DefinedInP1
	A1DefinedInP1>>methodDefinedInP1
	B1DefinedInP1	
	A2DefinedInP2>>methodDefinedInP1
	
P2
	A2DefinedInP2
	A2DefinedInP2>>methodDefinedInP2
	B2DefinedInB2	

P3
	A3DefinedInP3	
	A2DefinedInP2>>methodDefinedInP3 !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'expectedfailures' stamp: '2010-04-20T21:50:00+01:00'!
expectedFailures

	^ #(testClassNamesAndExtensionSelectorsDo testClassNamesAndExtensionSelectorsDo testClassesAndExtensionMethodsDo testClassesAndExtensionMethodsDo)! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'setup' stamp: 'StephaneDucasse 5/9/2011 16:43'!
setUp

	super setUp.
	p1 := self createNewPackageNamed: self p1Name.
	p2 := self createNewPackageNamed: self p2Name.
	p3 := self createNewPackageNamed: self p3Name.
	
	a1 :=  self createNewClassNamed: #A1DefinedInP1 inPackage: p1.
	b1 := self createNewClassNamed: #B1DefinedInP1 inPackage: p1.
	a2 := self createNewClassNamed: #A2DefinedInP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2DefinedInP2 inPackage: p2.
	a3 := self createNewClassNamed: #A3DefinedInP3 inPackage: p3.
	
	a1 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#methodDefinedInP1).
	a1 compileSilently: 'anotherMethodDefinedInP1 ^ #anotherMethodDefinedInP1'.
	p1 addMethod: (a1>>#anotherMethodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).

	a2 class compileSilently: 'classSideMethodDefinedInP3 ^ #classSideMethodDefinedInP3'.
	p3 addMethod: (a2 class>>#classSideMethodDefinedInP3).
	
! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test tag class' stamp: 'StephaneDucasse 7/26/2011 00:24'!
testAddTag
	"self debug: #testAddTag"
	
	self assert: p1 tags isEmpty.
	p1 addClassTag: #baz. 
	self assert: (p1 tags includes: #baz).
	self assert: (p1 tags size = 1).
	
	p1 addClassDefinitionName: #A1DefinedInP1 toClassTag: #foo.
	p1 addClassDefinitionName: #B1DefinedInP1 toClassTag: #foo.
	self assert: (p1 tags includes: #foo).
	self assert: (p1 tags size = 2).
	self assert: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).
	
	p1 addClassTag: #foo. 
	self assert: (p1 tags includes: #baz).
	self assert: (p1 tags includes: #foo).
	self assert: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test tag class' stamp: 'StephaneDucasse 7/25/2011 23:42'!
testAddTagsToAClass
	"self debug: #testAddTagsToAClass"
	
	self assert: p1 tags isEmpty.
	p1 addClassDefinitionName: #A1DefinedInP1 toClassTag: #foo.
	self assert: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 1).
	p1 addClassDefinitionName: #B1DefinedInP1 toClassTag: #foo.
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).

	p1 addClassDefinitionName: #B1DefinedInP1 toClassTag: #zork.
	self assert: ((p1 classesForClassTag: #zork) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).
	self assert: ((p1 classesForClassTag: #zork) size = 1).! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test compiled method' stamp: 'StephaneDucasse 4/13/2011 17:09'!
testClassIsExtendedInPackage
	"self debug: #testClassIsExtendedInPackage"
	
	self deny: ((Smalltalk globals at: #A1DefinedInP1) isExtendedInPackage: p1).
	self assert: (p1 includesClass: (Smalltalk globals at: #A1DefinedInP1)).
	self deny: (p1 extendsClass: (Smalltalk globals at: #A1DefinedInP1)).
	self assert: ((Smalltalk globals at: #A2DefinedInP2) isExtendedInPackage: p1).
	self deny: (p1 includesClass: (Smalltalk globals at: #A2DefinedInP2)).
	self assert: (p1 extendsClass: (Smalltalk globals at: #A2DefinedInP2)).
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test slice' stamp: '2010-04-20T21:53:00+01:00'!
testClassNamesAndExtensionSelectorsDo2
	"self debug: #testClassNamesAndExtensionSelectorsDo2"
	

	self assert: (String streamContents: [:stream |
		{p1 . p2 .p3} do: [:p |
			p classNamesAndExtensionSelectorsDo: [:aClassName :selector |
				stream nextPutAll: aClassName  ; nextPutAll: ' ' ; nextPutAll:  selector asString; cr ]]])
		= 'A2DefinedInP2 methodDefinedInP1
A2DefinedInP2 methodDefinedInP3
A2DefinedInP2_class classSideMethodDefinedInP3
'.
! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test slice' stamp: '2010-04-20T21:42:00+01:00'!
testClassesAndExtensionMethodsDo
	"self debug: #testClassesAndExtensionMethodsDo"
	
	| block |

	self assert: (String streamContents: [:stream |
		block := [ :aClass :selectors |
				stream nextPutAll: aClass name ; nextPutAll: ' '.
				selectors do: [ :selector | stream nextPutAll: selector asString].
				stream cr.].
		{p1 . p2 . p3} do: [ :p |
			p classExtensionSlicesDo: block.
			p metaclassExtensionSlicesDo: block.]]) 
		= 'A2DefinedInP2 methodDefinedInP1
A2DefinedInP2 methodDefinedInP3
A2DefinedInP2 classSideMethodDefinedInP3
'! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test compiled method' stamp: '2010-04-20T21:49:00+01:00'!
testCompiledMethodIsDefinedInPackage
	"self debug: #testCompiledMethodIsDefinedInPackage"
	
	self assert: (((Smalltalk at: #A1DefinedInP1) >> #methodDefinedInP1) isDefinedInPackage: p1).
	self deny: (((Smalltalk at: #A2DefinedInP2) >> #methodDefinedInP1) isDefinedInPackage: p1).
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test compiled method' stamp: '2010-03-16T17:44:00+01:00'!
testCompiledMethodIsExtensionInPackage
	"self debug: #testCompiledMethodIsExtensionInPackage"
	
	self deny: (((Smalltalk at: #A1DefinedInP1) >> #methodDefinedInP1) isExtensionInPackage: p1).
	self assert: (((Smalltalk at: #A2DefinedInP2) >> #methodDefinedInP1) isExtensionInPackage: p1).
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test compiled method' stamp: 'StephaneDucasse 6/3/2012 22:47'!
testCompiledMethodPackageFromOrganizer
	"self debug: #testCompiledMethodPackageFromOrganizer"
	| method |
	method := (Smalltalk at: #A1DefinedInP1) >> #methodDefinedInP1.
	self assert: (method packageFromOrganizer: self packageClass organizer) = p1.
	method := (Smalltalk at: #A2DefinedInP2) >> #methodDefinedInP1.
	self assert: (method packageFromOrganizer: self packageClass organizer) = p1! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T15:57:00+01:00'!
testDefinedSelectorsForClass
	"self debug: #testDefinedSelectorsForClass"
	
	self assert: (p1 definedSelectorsForClass: a1) size = 2. 
	self assert: (p1 definedMethodsForClass: a1) size = 2. 
	self assert: ((p1 definedSelectorsForClass: a1) includes: #methodDefinedInP1).
	self assert: ((p1 definedSelectorsForClass: a1) includes: #anotherMethodDefinedInP1).
	self assert: ((p1 definedMethodsForClass: a1) includes: ((Smalltalk at: #A1DefinedInP1)>>#methodDefinedInP1)).
	self assert: (p1 definedSelectorsForClass: Object) isEmpty. 
	self assert: (p1 definedSelectorsForClass: Object class) isEmpty. 
! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test tag class' stamp: 'StephaneDucasse 7/25/2011 22:30'!
testEmpty
	"self debug: #testEmpty"
	
	self assert: p1 tags isEmpty.
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test accessing' stamp: '2010-04-21T17:07:00+01:00'!
testExtendingPackagesOfClass
	"since a class can be extended by several packages, we want the list of packages that extend
	the class"
	
	"self debug: #testExtendingPackagesOfClass"
		
	| packages |
	packages := a2 extendingPackages.
	"a2 is extended by p1 and p3"
	self assert: packages size = 2. 
	self assert: (packages includes: p1).
	self deny: (packages includes: p2).
	self assert: (packages includes: p3).
	
	packages := a1 extendingPackages.
	self assert: packages isEmpty. ! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test accessing' stamp: '2010-10-27T15:49:00+01:00'!
testExtensionMethods
	"a package can extend several classes, either the class or  the meta-class side. 'extensionMethods' should list all the methods involved in shuch extensions. P3 extend a2 and a2 class"
	
	"self debug: #testExtendingPackagesOfClass"
		
	|package extensionMethods cpt |
	package := p3.
	self shouldnt: [extensionMethods := package extensionMethods] raise: Error.
	"self assert: (extensionMethods size = 2)."
	self assert: (extensionMethods includes: (a2>>#methodDefinedInP3)).
	self assert: (extensionMethods includes: (a2 class>>#classSideMethodDefinedInP3)).	

	cpt := 0.
	package metaclassExtensionSlicesDo: [:className :listOfSelectors |
		((className = a2 name) and: [listOfSelectors includes: #classSideMethodDefinedInP3])
			ifTrue: [cpt := cpt + 1].
		].	
	self assert: cpt = 1.
	
	cpt := 0.
	package classExtensionSlicesDo: [:className :listOfSelectors |
		((className = a2 name) and: [listOfSelectors includes: #methodDefinedInP3])
			ifTrue: [cpt := cpt + 1].
		].	
	self assert: cpt = 1.! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-20T22:05:00+01:00'!
testExtensionSelectorsForClass
	"self debug: #testExtensionSelectorsForClass"
	
	self assert: (p1 extensionSelectorsForClass: a2) size = 1. 
	self assert: ((p1 extensionSelectorsForClass: a2) includes: #methodDefinedInP1).
	self assert: ((p1 extensionMethodsForClass: a2) includes: (Smalltalk at: #A2DefinedInP2) >> #methodDefinedInP1).
	self assert: (p1 extensionSelectorsForClass: Object) isEmpty.
	self assert: (p1 extensionSelectorsForClass: Object class) isEmpty! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-03-13T13:48:00+01:00'!
testMetaclassHasExtensions
	"self debug: #testMetaclassHasExtensions"

	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClassName: a2  name).
	self assert: (p3 includesExtensionSelector: #methodDefinedInP3 ofClass: a2).
	self assert: (p3 includesExtensionSelector: #classSideMethodDefinedInP3 ofMetaclassName: a2 name).
	self assert: (p3 includesExtensionSelector: #classSideMethodDefinedInP3 ofClass: a2 class)

	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T16:38:00+01:00'!
testMethods
	"self debug: #testMethods"
	
	| m1 m3 |
	m1 := p1 methods.
	self assert: m1 size = 3. 
	self assert: (m1 includes: a1>>#methodDefinedInP1).
	self assert: (m1 includes: a1>>#anotherMethodDefinedInP1). 
	self assert: (m1 includes: a2>>#methodDefinedInP1).
	m3 := p3 methods.
	self assert: m3 size = 2.
	self assert: (m3 includes: a2>>#methodDefinedInP3).
	self assert: (m3 includes: a2 class>>#classSideMethodDefinedInP3)! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T15:57:00+01:00'!
testMethodsForClass
	"self debug: #testMethodsForClass"
	
	self assert: (p1 methodsForClass: a1) size = 2. 
	self assert: ((p1 methodsForClass: a1) includes: ((Smalltalk at: #A1DefinedInP1)>>#methodDefinedInP1)).
	self assert: ((p1 methodsForClass: a1) includes: ((Smalltalk at: #A1DefinedInP1)>>#anotherMethodDefinedInP1)).
	self assert: (p1 methodsForClass: b1) isEmpty. 
	self assert: (p1 methodsForClass: Object) isEmpty. 
	self assert: (p1 methodsForClass: Object class) isEmpty. 

	self assert: (p3 methodsForClass: a2) size = 1.
	self assert: ((p3 methodsForClass: a2) includes: ((Smalltalk at: #A2DefinedInP2)>>#methodDefinedInP3)).
	self assert: (p3 methodsForClass: a2 class) size = 1.
	self assert:  ((p3 methodsForClass: a2 class) includes: ((Smalltalk at: #A2DefinedInP2) class>>#classSideMethodDefinedInP3))	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test accessing' stamp: '2010-04-21T17:08:00+01:00'!
testPackagesOfClass
	"since a class can be extended by several packages, we want the complete list of packages that define or extend
	the class"
	"self debug: #testPackagesOfClass"
		
	| packages extending |
	packages := a2 packages.
	"a2 is extended by p1 and p3"
	extending := a2 extendingPackages.
	self assert: extending size = 2. 
	self assert: (extending includes: p1).
	self assert: (extending includes: p3).
	
	self assert: packages size = 3. 
	self assert: (packages includes: p1).
	self assert: (packages includes: p2).
	self assert: (packages includes: p3).
	
	
	
	
	
	
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test tag class' stamp: 'StephaneDucasse 7/26/2011 00:12'!
testRemoveTag
	"self debug: #testRemoveTag"
	
	self assert: p1 tags isEmpty.
	p1 addClassDefinitionName: #A1DefinedInP1 toClassTag: #foo.
	self assert: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 1).
	p1 addClassDefinitionName: #B1DefinedInP1 toClassTag: #foo.
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).
	
	self shouldnt: [ (p1 removeClassTag: #bar)] raise: Error.
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).
	p1 removeClassTag: #foo.
	self deny: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 0).! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test tag class' stamp: 'StephaneDucasse 7/26/2011 00:19'!
testRemoveTaggedClasses
	"self debug: #testRemoveTaggedClasses"
	
	p1 addClassDefinitionName: #A1DefinedInP1 toClassTag: #foo.
	p1 addClassDefinitionName: #B1DefinedInP1 toClassTag: #foo.
	
	p1 addClassDefinitionName: #B1DefinedInP1 toClassTag: #zork.
	self assert: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 2).
	
	self deny: ((p1 classesForClassTag: #zork) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #zork) includes: #B1DefinedInP1).
	
	"now when we remove a class"
	"from an existing tags list"
	p1 removeClassDefinitionName: #A1DefinedInP1 fromClassTag: #foo.
	self deny: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 1).
	
	"from a nonexisting tag list"
	self shouldnt: [p1 removeClassDefinitionName: #B1DefinedInP1 fromClassTag: #taz] raise: Error.
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #zork) includes: #B1DefinedInP1).
	
	"with a class not registered to a tag list"
	self shouldnt: [p1 removeClassDefinitionName: #Tagada fromClassTag: #foo] raise: Error.
	self deny: ((p1 classesForClassTag: #foo) includes: #A1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) includes: #B1DefinedInP1).
	self assert: ((p1 classesForClassTag: #foo) size = 1).
	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T16:13:00+01:00'!
testSelectors
	"self debug: #testSelectors"
	
	self assert: (p1 selectors) size = 2. 
	self assert: ((p1 selectors) includes: #methodDefinedInP1).
	self assert: ((p1 selectors) includes: #anotherMethodDefinedInP1). 

	self assert: p3 selectors size = 2.
	self assert: (p3 selectors includes: #methodDefinedInP3).
	self assert:  (p3 selectors includes: #classSideMethodDefinedInP3)	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: '2010-04-21T15:58:00+01:00'!
testSelectorsForClass
	"self debug: #testSelectorsForClass"
	
	self assert: (p1 selectorsForClass: a1) size = 2. 
	self assert: ((p1 selectorsForClass: a1) includes: #methodDefinedInP1).
	self assert: ((p1 selectorsForClass: a1) includes: #anotherMethodDefinedInP1).
	self assert: (p1 selectorsForClass: b1) isEmpty. 
	self assert: (p1 selectorsForClass: Object) isEmpty. 
	self assert: (p1 selectorsForClass: Object class) isEmpty. 

	self assert: (p3 selectorsForClass: a2) size = 1.
	self assert: ((p3 selectorsForClass: a2) includes: #methodDefinedInP3).
	self assert: (p3 selectorsForClass: a2 class) size = 1.
	self assert:  ((p3 selectorsForClass: a2 class) includes: #classSideMethodDefinedInP3)	! !

!RPackageReadOnlyCompleteSetupTest methodsFor: 'test situation' stamp: 'StephaneDucasse 4/13/2011 20:52'!
testStartingSituation
	"self debug: #testStartingSituation"

.	self deny: (p2 includesClass: b1).
	self assert: (p2 includesClass: b2).
	"a locally defined class not extended by other packages"
	
	self assert: (p2 includesClass: a2).  
	"a locally defined class extended by other packages"
	
	self assert: (p1 definesOrExtendsClass: a2).
	self deny: (p1 includesClass: a2).
! !

RPackageIncrementalTest subclass: #RPackageTraitTest
	instanceVariableNames: 'p4 p5 a1 b1 a2 b2 a3 t1 t2 p6'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageTraitTest methodsFor: 'setup' stamp: 'StephaneDucasse 5/9/2011 16:42'!
p4Name

	^ 'RPackageTestP4'! !

!RPackageTraitTest methodsFor: 'setup' stamp: 'StephaneDucasse 5/9/2011 16:43'!
p5Name

	^ 'RPackageTestP5'! !

!RPackageTraitTest methodsFor: 'setup' stamp: 'cyrilledelaunay 5/10/2011 12:50'!
p6Name

	^ 'RPackageTestP6'! !

!RPackageTraitTest methodsFor: 'setup' stamp: 'cyrilledelaunay 5/13/2011 12:55'!
setUp

	super setUp.
	
	p4 := self createNewPackageNamed: self p4Name.  
	p5 := self createNewPackageNamed: self p5Name. 
	p6 := self createNewPackageNamed: self p6Name.  
	
	a1 :=  self createNewClassNamed: #A1DefinedInP1 inPackage: p4.
	
	"a1 defines two normal = local methods"
	a1 compileSilently: 'localMethodDefinedInP1 ^ #methodDefinedInP1'.
	p4 addMethod: (a1>>#localMethodDefinedInP1).
	a1 compileSilently: 'anotherLocalMethodDefinedInP1 ^ #anotherMethodDefinedInP1'.
	p4 addMethod: (a1>>#anotherLocalMethodDefinedInP1).
	
	t1 := self createNewTraitNamed: #TraitInPackageP4 inPackage: p4.
	t1 compileSilently: 'traitMethodDefinedInP4 ^ #traitMethodDefinedInP4'.
	p4 addMethod: (t1>>#traitMethodDefinedInP4).
	
	"P6 defines a new method extension on T1 (packaged in p4)"
	t1 compileSilently: 'traitMethodExtendedFromP6 ^ #traitMethodExtendedFromP6' classified: ('*',self p6Name). 
	p6 addMethod: (t1>>#traitMethodExtendedFromP6).
	
	t2 := self createNewTraitNamed: #TraitInPackageP5 inPackage: p5.
	t2 compileSilently: 'traitMethodDefinedInP5 ^ #traitMethodDefinedInP5'.
	
	p5 addMethod: (t2 >> #traitMethodDefinedInP5).  
	
	"Here P4 extends T2 from P5 with a new method"
	t2 compileSilently: 'traitMethodExtendedFromP4 ^ #traitMethodExtendedFromP4' classified: ('*',self p4Name). 
	p4 addMethod: (t2 >> #traitMethodExtendedFromP4).
	
	a1 setTraitComposition: (t1 + t2) asTraitComposition.
	
	"a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).

	a2 class compileSilently: 'classSideMethodDefinedInP3 ^ #classSideMethodDefinedInP3'.
	p3 addMethod: (a2 class>>#classSideMethodDefinedInP3)."
	! !

!RPackageTraitTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 22:47'!
testPackageOfClassMethodFromTraitExtensionIsExtendingPackage
	"The package of a method defined in atrait but package in another package than the extended trait is the 
	package containing the extension."
	
	"The package of a method in A1 (which is coming from the trait T1 used by A1) is the package of T1"
	self assert: ((a1>>#traitMethodExtendedFromP4) packageFromOrganizer: self packageClass organizer) = p4.
	"The package of a method in A1 (which is coming from the trait T1 used by A1 but extended in package T2) is the package of T2"
	self assert: ((a1>>#traitMethodExtendedFromP6) packageFromOrganizer: self packageClass organizer) = p6.! !

!RPackageTraitTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 23:26'!
testPackageOfClassMethodFromTraitIsTraitPackage

	"test that a class method coming from a trait is packaged in the trait package"
	self assert: ((a1>>#traitMethodDefinedInP4) packageFromOrganizer: self packageClass organizer) = p4.
	self assert: ((a1>>#traitMethodDefinedInP5) packageFromOrganizer: self packageOrganizerClass default) = p5.! !

!RPackageTraitTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 23:26'!
testPackageOfClassMethodIsClassPackage
	"The package of a local method (not defined in a trait) is the package of its class"
	
	self assert: ((a1>>#localMethodDefinedInP1) packageFromOrganizer: self packageClass organizer) = p4.
	self assert: ((a1>>#anotherLocalMethodDefinedInP1) packageFromOrganizer: self packageOrganizerClass default) = p4.
	self assert: ((a1>>#anotherLocalMethodDefinedInP1) packageFromOrganizer: self packageClass organizer) = p4.! !

!RPackageTraitTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 23:26'!
testPackageOfTraitMethodIsTraitPackage
	"The package of a trait method is the package of its trait."

	self assert: ((a1 >> #traitMethodDefinedInP5) packageFromOrganizer: self packageClass organizer) = p5.
	self assert: ((a1 >> #traitMethodDefinedInP5)packageFromOrganizer: self packageOrganizerClass default) = p5.
	self assert: ((a1>>#traitMethodDefinedInP4) packageFromOrganizer: self packageClass organizer) = p4.! !

!RPackageTraitTest methodsFor: 'tests' stamp: 'StephaneDucasse 5/10/2011 10:24'!
testStartingSituation
	"self debug: #testStartingSituation"


.	self deny: (p5 includesClass: a1).
	self assert: (p4 includesClass: a1).
	self assert: (p4 includesClass: t1).
	self assert: (p4 definesOrExtendsClass: a1).
	self assert: (p5 includesClass: t2).! !

RPackageTestCase subclass: #RPackageMCSynchronisationTest
	instanceVariableNames: 'emptyOrganizer oldAnnouncer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-SystemIntegration'!

!RPackageMCSynchronisationTest commentStamp: '<historical>' prior: 0!
I had some problems using the 'ensure:' method. There was some conflicts with the organizer used for the test when trying to clean the classes, categories and packages generated for the test. 
There is something I don't get with this method. Therefore I choosed to clean by default all possible generated classes, categories and packages after each test using the tearDown method.

For now, all that was in the 'ensure:' methods has been commented.
Look for example at:
    testAddMethodInClassicCategoryAddMethodToTheParentPackageOfItsClass
and try to uncomment it!

!RPackageMCSynchronisationTest methodsFor: 'utilities' stamp: 'GuillermoPolito 5/29/2012 12:31'!
addXCategory
	Smalltalk globals organization addCategory: 'XXXXX'.! !

!RPackageMCSynchronisationTest methodsFor: 'utilities' stamp: 'StephaneDucasse 4/29/2011 21:44'!
addXYCategory

	self addXCategory.
	self addYCategory.
			! !

!RPackageMCSynchronisationTest methodsFor: 'utilities' stamp: 'StephaneDucasse 4/29/2011 21:50'!
addXYZCategory

	self addXCategory.
	self addYCategory.
	self addZCategory.
			! !

!RPackageMCSynchronisationTest methodsFor: 'utilities' stamp: 'StephaneDucasse 4/24/2011 23:26'!
addYCategory

	Smalltalk globals organization addCategory: 'YYYYY'.
			! !

!RPackageMCSynchronisationTest methodsFor: 'utilities' stamp: 'StephaneDucasse 4/29/2011 21:44'!
addZCategory

	Smalltalk globals organization addCategory: 'ZZZZZ'.
			! !

!RPackageMCSynchronisationTest methodsFor: 'utilities' stamp: 'StephaneDucasse 6/2/2012 19:40'!
allManagers

	^ MCWorkingCopy allManagers! !

!RPackageMCSynchronisationTest methodsFor: 'setup' stamp: 'StephaneDucasse 6/2/2012 19:45'!
cleanClassesPackagesAndCategories

		|mCPackage|
		Smalltalk removeClassNamed: 'NewClass'.
		Smalltalk removeClassNamed: 'RPackageNewStubClass'.
		Smalltalk removeClassNamed: 'RPackageOldStubClass'.
		Smalltalk removeClassNamed: 'Foo'.
		Smalltalk removeClassNamed: 'FooOther'.
		Smalltalk removeClassNamed: 'NewTrait'.
		Smalltalk removeClassNamed: 'ClassInYPackage'.
		Smalltalk removeClassNamed: 'ClassInZPackage'.
		Smalltalk organization removeCategory: 'Zork'.
		Smalltalk organization removeCategory: 'XXXXX'.
		Smalltalk organization removeCategory: 'XXXX'.
		Smalltalk organization removeCategory: 'YYYYY'.
		Smalltalk organization removeCategory: 'ZZZZZ'.
		Smalltalk organization removeCategory: 'FooPackage-Core'.
		Smalltalk organization removeCategory: 'FooPackage-Other'.
		Smalltalk organization removeCategory: 'FooPackage'.
		Smalltalk organization removeCategory: 'OriginalCategory'.
		Smalltalk organization removeCategory: 'NewCategoryName'.
		Smalltalk organization removeCategory: 'Y'.
		mCPackage := (self allManagers detect: [:each | each packageName = 'OriginalCategory'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
		mCPackage := (self allManagers detect: [:each | each packageName = 'XXXXX'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
		mCPackage := (self allManagers detect: [:each | each packageName = 'XXXX'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
		mCPackage := (self allManagers detect: [:each | each packageName = 'YYYYY'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
		mCPackage := (self allManagers detect: [:each | each packageName = 'YYYY'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
		mCPackage := (self allManagers detect: [:each | each packageName = 'Yyyyy'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].	
		mCPackage := (self allManagers detect: [:each | each packageName = 'YyYyY'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
		mCPackage := (self allManagers detect: [:each | each packageName = 'Y'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
		mCPackage := (self allManagers detect: [:each | each packageName = 'ZZZZZ'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].	
		mCPackage := (self allManagers detect: [:each | each packageName = 'Zzzzz'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
		mCPackage := (self allManagers detect: [:each | each packageName = 'FooPackage-Core'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
		mCPackage := (self allManagers detect: [:each | each packageName = 'FooPackage-Other'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
		mCPackage := (self allManagers detect: [:each | each packageName = 'FooPackage'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
		mCPackage := (self allManagers detect: [:each | each packageName = 'Zork'] ifNone: [nil]) .
		mCPackage ifNotNil: [mCPackage unregister].
			! !

!RPackageMCSynchronisationTest methodsFor: 'private' stamp: 'cyrille.delaunay 11/25/2010 13:17'!
createMethodNamed: methodName inClass: aClass inCategory: aCategoryName 

	^ aClass compile: (methodName, ' ^nil') classified: aCategoryName.! !

!RPackageMCSynchronisationTest methodsFor: 'private' stamp: 'cyrille.delaunay 11/25/2010 13:17'!
createMethodNamed: methodName inClassSideOfClass: aClass inCategory: aCategoryName 

	^ aClass classSide compile: (methodName, ' ^nil') classified: aCategoryName.! !

!RPackageMCSynchronisationTest methodsFor: 'private' stamp: 'StephaneDucasse 7/29/2010 23:46'!
createNewClassNamed: aName
	
	| cls |
	cls := Object subclass: aName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'RPackageTest'.
	^ cls! !

!RPackageMCSynchronisationTest methodsFor: 'private' stamp: 'cyrille.delaunay 11/22/2010 10:56'!
createNewClassNamed: aName inCategory: aCategoryName
	
	| cls |
	cls := Object subclass: aName asSymbol
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: aCategoryName.
	^ cls! !

!RPackageMCSynchronisationTest methodsFor: 'private' stamp: 'cyrille.delaunay 11/26/2010 15:31'!
createNewTraitNamed: aName inCategory: aCategoryName
	
	| trait |
	trait := Trait named: aName asSymbol
			uses: {}
			category: aCategoryName.
	^ trait! !

!RPackageMCSynchronisationTest methodsFor: 'accessing' stamp: 'RPackage 1/20/2011 13:17'!
emptyOrganizer 

	^ emptyOrganizer! !

!RPackageMCSynchronisationTest methodsFor: 'announcer handling' stamp: 'EstebanLorenzano 7/27/2012 17:57'!
initializeAnnouncers
	super initializeAnnouncers.
	
	oldAnnouncer := MCWorkingCopy announcer.
	MCWorkingCopy announcer: announcerForTest.! !

!RPackageMCSynchronisationTest methodsFor: 'announcer handling' stamp: 'EstebanLorenzano 7/27/2012 17:50'!
restoreAnnouncers
	super restoreAnnouncers.
	MCWorkingCopy announcer: oldAnnouncer.! !

!RPackageMCSynchronisationTest methodsFor: 'setup' stamp: 'EstebanLorenzano 7/27/2012 20:24'!
setUp 
	super setUp.
	
	emptyOrganizer := self organizer debuggingName: 'MCSynchronisation Package Organizer'; yourself.
	emptyOrganizer registerPackage: (self packageClass named: 'as yet unclassified').

	Author fullName 
		ifNil: [ Author fullName: 'Tester' ].! !

!RPackageMCSynchronisationTest methodsFor: 'setup' stamp: 'EstebanLorenzano 7/27/2012 18:01'!
tearDown
	MCWorkingCopy removeDependent: self emptyOrganizer.
	self cleanClassesPackagesAndCategories.
	super tearDown.! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on categories' stamp: 'GuillermoPolito 5/26/2012 22:48'!
testAddCategoryCreatesPackage
	"test that when we add a category that does not yet correspond to an existing package, a new package is created"
	"self debug: #testAddCategoryCreatesPackage"
	
	self addXCategory.
	self assert: (self organizer includesPackageNamed: #XXXXX)! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on categories' stamp: 'GuillermoPolito 5/26/2012 22:48'!
testAddCategoryIsAlreadyAPackageDoesNotCreatePackage
	"test that when we add a category corresponding to an existing package, we do not create a second package"
	"self debug: #testAddCategoryIsAlreadyAPackageDoesNotCreatePackage"
	
	|tmpPackage|
	self addXCategory.
	tmpPackage := self organizer packageNamed: #XXXXX.
	self addXCategory.
	self assert: tmpPackage =  (self organizer packageNamed: #XXXXX)
		! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 22:48'!
testAddClassAddItIntoPackage
	"self debug: #testAddCategoryCreatesPackage"

	|tmpPackage class|
	self addXCategory.
	self assert: (self organizer includesPackageNamed: #XXXXX).
	tmpPackage := self organizer packageNamed: #XXXXX.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self assert: (tmpPackage definesClass: class). 
	self assert: (class package = tmpPackage)! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 22:48'!
testAddClassInNotCreatedPackage
	"test that when we add a class in an existing category, it does not create a new package"
	"self debug: #testAddClassInNotCreatedPackage"
	
	|tmpPackage class|
	self addXCategory.
	self assert: (self organizer includesPackageNamed: #XXXXX).
	tmpPackage := self organizer packageNamed: #XXXXX.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self assert: (self organizer packageNamed: #XXXXX) = tmpPackage. 
	self assert: (class package = tmpPackage)! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 22:49'!
testAddClassUpdateTheOrganizer
	"test that when we add a class, the organizer 'classPackageMapping' dictionary is updated, so that the class is linked to its package and so that we can access its parent package"
	"self debug: #testAddClassUpdateTheOrganizer"
	|tmpPackage class|
	self addXCategory.
	self assert: (self organizer includesPackageNamed: #XXXXX).
	tmpPackage := self organizer packageNamed: #XXXXX.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self assert: (self organizer packageOf: class) = tmpPackage. 
		! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on MCPackages' stamp: 'GuillermoPolito 5/26/2012 22:49'!
testAddMCPackageCreatesAPackage
	"test that when we create a MCPackage, a corresponding package is created"
	
	MCWorkingCopy forPackage: (MCPackage new name: #Zork).
	self assert: (self organizer includesPackageNamed: #Zork).
		
					  ! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on MCPackages' stamp: 'GuillermoPolito 5/26/2012 22:49'!
testAddMCPackageForCategoryAlreadyExistingDoesNotCreateAPackage
	"test that when we create a MCPackage and that a category of this name already exists, no package is created"
	"self debug: #testAddMCPackageForCategoryAlreadyExistingDoesNotCreateAPackage"
	"self run: #testAddMCPackageForCategoryAlreadyExistingDoesNotCreateAPackage"	
	
	|tmpPackage|
	Smalltalk globals organization addCategory: 'Zork'.
	tmpPackage := self organizer packageNamed: #Zork.
	MCWorkingCopy forPackage: (MCPackage new name: #Zork).
	self assert: tmpPackage = (self organizer packageNamed: #Zork).
		
		
					  ! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 22:51'!
testAddMethodByUsingATraitDoesNotAddTheMethodToThePackage
	"test that when a method is added to a class bu using a trait, this method is not imported in the parent package of the class"
	"self debug: #testAddMethodByUsingATraitDoesNotAddTheMethodToThePackage"
	
	|XPackage YPackage class trait|
	self addXCategory.
	self addYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage := self organizer packageNamed: #YYYYY.
	trait := self createNewTraitNamed: 'NewTrait' inCategory: 'YYYYY'.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass:  trait inCategory: 'trait category'.
	
	self assert: (XPackage methods isEmpty ).
	self deny: (YPackage methods isEmpty ).
	class addToComposition: trait.
	self assert: (YPackage includesDefinedSelector: #stubMethod ofClass: trait).
	self assert: (XPackage methods isEmpty).
		! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 22:52'!
testAddMethodInClassicCategoryAddMethodToTheParentPackageOfItsClass
	"test that when we add a method to a  class in a classic category (*not beginning with *), this method is added to the parent package of the class"
	
	|tmpPackage class|
	self addXCategory.
	self assert: (self organizer includesPackageNamed: #'XXXXX').
	tmpPackage := self organizer packageNamed: #XXXXX.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass:  class inCategory: 'classic category'.
	self assert: (class package includesDefinedSelector: #stubMethod ofClass: class).
	self assert: ((class >> #stubMethod) packageFromOrganizer: self organizer ) = class package.! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 22:52'!
testAddMethodInClassicCategoryAddMethodToTheParentPackageOfItsTrait
	"test that when we add a method to a  trait in a classic category (*not beginning with *), this method is added to the parent package of the class"
	
	|tmpPackage trait|
	self addXCategory.
	self assert: (self organizer includesPackageNamed: #'XXXXX').
	tmpPackage := self organizer packageNamed: #XXXXX.
	trait := self createNewTraitNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass:  trait inCategory: 'classic category'.
	self assert: (tmpPackage includesClass: trait).
	self assert: (trait package includesDefinedSelector: #stubMethod ofClass: trait).
	self assert: ((trait >> #stubMethod) packageFromOrganizer: self organizer ) = trait package! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 22:53'!
testAddMethodInExtensionCategoryAddMethodToTheExtendingPackage
	"test that when we add a method to a  class in an extension category ( beginning with *), this method is added to the corresponding extending package"
	
	| class firstPackage secondPackage|
	self addXYCategory.		
	firstPackage := self organizer packageNamed: #XXXXX.
	secondPackage := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self assert: (class package = firstPackage).
	self createMethodNamed: 'stubMethod' inClass: class inCategory: '*YYYYY'.
	self assert: (secondPackage includesExtensionSelector: #stubMethod ofClass: class).
	self deny: (firstPackage includesDefinedSelector: #stubMethod ofClass: class).
	self assert: ((class >> #stubMethod) packageFromOrganizer: self organizer) = secondPackage! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 22:54'!
testAddMethodInExtensionCategoryEnlargingPackageNameAddMethodToTheExtendingPackage
	"test that when we add a method  in an extension category ( beginning with*) that enlarge a package name (for example *mondrian-accessing for Mondrian), this method is added to the corresponding extending package"
	
	| class XPackage YPackage|
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self assert: class package = XPackage.
	self createMethodNamed: #newMethod inClass:  class inCategory: '*YYYYY-subcategory'.
	self assert: (YPackage includesExtensionSelector: #newMethod ofClass: class).
	self deny: (XPackage includesDefinedSelector: #newMethod ofClass: class).
	self assert: ((class >> #newMethod) packageFromOrganizer: self organizer ) = YPackage! !

!RPackageMCSynchronisationTest methodsFor: 'expectedfailures' stamp: 'GuillermoPolito 5/26/2012 22:55'!
testAddMethodInExtensionCategoryNotExistingCreateANewPackage
	"test that when we add a method  in an extension category ( beginning with *)that does not refer to an existing categorya new package with the name of this category is added, and that the method is added to this new package"
	| class firstPackage secondPackage|
	self flag: #stef. "this is strange since the setup does not use withOrganizer:do: and now we use it. There are some inconsistencies"
	"not sure this is the behavior expected. Maybe a new package should be created and should contain the method. Actually, this is the reason the test fail :)."
	
	Smalltalk globals organization addCategory: 'XXXXX'.
	Smalltalk globals organization addCategory: 'YYYYY'.
	firstPackage := self organizer packageNamed: #XXXXX.
	secondPackage := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: #newMethod inClass:  class inCategory: '*YYYY'.
	self deny: (secondPackage includesExtensionSelector: #newMethod ofClass: class).
	self deny: (class package includesDefinedSelector: #newMethod ofClass: class).
	self assert: ((self organizer packageNamed: #YYYY) = nil) not.
	self assert: ((class >> #newMethod) packageFromOrganizer: self organizer ) = (self organizer packageNamed: #YYYY).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 22:56'!
testAddMethodInExtensionCategoryNotRespectingCaseAddMethodToTheExtendingPackage
	"test that when we add a method  in an extension category ( beginning with *)thae does not match the case of the corresponding package (for example *packagea for PackageA), this method is added to the corresponding extending package"
	

	| class firstPackage secondPackage|
	self addXYCategory.
	firstPackage := self organizer packageNamed: #XXXXX.
	secondPackage := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass:  class inCategory: '*yyYyY'.
	self assert: (secondPackage includesExtensionSelector: #stubMethod ofClass: class).
	self deny: (firstPackage includesDefinedSelector: #stubMethod ofClass: class).
	self assert: ((class >> #stubMethod) packageFromOrganizer: self organizer ) = secondPackage.! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on traits' stamp: 'GuillermoPolito 5/26/2012 22:58'!
testAddTraitAddItIntoPackage
	"self debug: #testAddCategoryCreatesPackage"

	|tmpPackage trait|
	self addXCategory.
	self assert: (self organizer includesPackageNamed: 'XXXXX').
	tmpPackage := self organizer packageNamed: #XXXXX.
	trait := self createNewTraitNamed: 'NewTrait' inCategory: 'XXXXX'.
	self assert: (tmpPackage definesClass: trait).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on traits' stamp: 'GuillermoPolito 5/26/2012 22:59'!
testAddTraitInNotCreatedPackage
	"test that when we add a trait in an existing category, it does not create a new package"
	
	|tmpPackage trait|
	self addXCategory.
	self assert: (self organizer includesPackageNamed: 'XXXXX').
	tmpPackage := self organizer packageNamed: #XXXXX.
	trait := self createNewClassNamed: 'NewTrait' inCategory: 'XXXXX'.
	self assert: (self organizer packageNamed: #XXXXX) = tmpPackage. 
	self assert: (trait package = tmpPackage)! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on traits' stamp: 'GuillermoPolito 5/26/2012 23:01'!
testAddTraitUpdateTheOrganizer
	"test that when we add a trait, the organizer 'classPackageMapping' dictionary is updated, so that the class is linked to its package and so that we can access its parent package"
	
	|tmpPackage trait|
	self addXCategory.
	self assert: (self organizer includesPackageNamed: 'XXXXX').
	tmpPackage := self organizer packageNamed: #XXXXX.
	trait := self createNewTraitNamed: 'NewTrait' inCategory: 'XXXXX'.
	self assert: (self organizer packageOf: trait) = tmpPackage.! !

!RPackageMCSynchronisationTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 22:50'!
testBasicImportSystemClass
	"self debug: #testBasicImportSystemClass"
	| fooClass fooPackage |
	fooClass :=  Object subclass: #Foo
					instanceVariableNames: ''
					classVariableNames: ''
					poolDictionaries: ''
					category: 'FooPackage'.
	fooClass compileSilently: 'foo ^ 1' classified: 'foo'.
	fooClass compileSilently: 'fooBar ^ 2' classified: 'foo'.
	fooClass compileSilently: 'fooFooBar ^ 3' classified: 'foo'.
	fooClass class compileSilently: 'fooClassSide ^ 1' classified: 'foo'.
	fooClass compileSilently: 'zork ^ 4' classified: '*zork'.
	fooPackage := self packageClass named: #FooPackage.
	fooPackage importCategory.
	self assert: (fooPackage includesDefinedSelector: #foo ofClass: fooClass).
	self assert: (fooPackage includesDefinedSelector: #fooBar ofClass: fooClass).
	self assert: (fooPackage includesDefinedSelector: #fooFooBar ofClass: fooClass).
	self deny: (fooPackage includesDefinedSelector: #zork ofClass: fooClass).
	self assert: (fooPackage includesDefinedSelector: #fooClassSide ofClass: fooClass class).! !

!RPackageMCSynchronisationTest methodsFor: 'tests' stamp: 'GuillermoPolito 5/26/2012 23:09'!
testCategoryMatching
	
	self assert: (self organizer category: 'Compression-Archives' matches: 'Compression').
	self deny: (self organizer category: 'Compression' matches: 'Compression-Archives').
	self assert: (self organizer category: 'Compression' matches: 'Compression').
	self assert: (self organizer category: 'Compression-Arh' matches: 'Compression').
	self deny: (self organizer category: 'XXXX' matches: 'Compression-Archives').! !

!RPackageMCSynchronisationTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 22:50'!
testImportSystallManagershSubCategoryAndAnotherCategory
	"self debug: #testImportSystemClassWithSubCategoryAndAnotherCategory"
	"indeed the user may have created a class in the category Foo-Core, and after created
	a package only named Foo. The classes in category Foo-Core should be added to Foo. But
	some other packages and categories starting with Foo may exist."
	| fooClass fooPackage fooClass2|
	fooClass := self createNewClassNamed: 'Foo' inCategory: 'FooPackage-Core'.
	fooClass compileSilently: 'foo ^ 1' classified: 'foo'.
	fooClass compileSilently: 'fooBar ^ 2' classified: 'foo'.
	fooClass compileSilently: 'fooFooBar ^ 3' classified: 'foo'.
	fooClass class compileSilently: 'fooClassSide ^ 1' classified: 'foo'.
	fooClass compileSilently: 'zork ^ 4' classified: '*zork'.

	fooClass2 := self createNewClassNamed: 'FooOther' inCategory: 'FooPackage-Other'.
	fooClass2 compileSilently: 'fooOther ^ 1' classified: 'what s up'.
	fooClass2 compileSilently: 'fooBarOther ^ 2' classified: 'dr'.
	fooClass2 class compileSilently: 'fooOtherClassSide ^ 1' classified: 'lovely carots'.
	fooClass2 compileSilently: 'zorkZork ^ 4' classified: '*zorkzork'.
	
	fooPackage := self packageClass named: #FooPackage.
	fooPackage importCategory.
	self assert: (fooPackage definedClasses size = 2).
	
	self assert: (fooPackage includesDefinedSelector: #foo ofClass: fooClass).
	self assert: (fooPackage includesDefinedSelector: #fooBar ofClass: fooClass).
	self assert: (fooPackage includesDefinedSelector: #fooFooBar ofClass: fooClass).
	self deny: (fooPackage includesDefinedSelector: #zork ofClass: fooClass).
	self assert: (fooPackage includesDefinedSelector: #fooClassSide ofClass: fooClass class).
	
	self assert: (fooPackage includesDefinedSelector: #fooOther ofClass: fooClass2).
	self assert: (fooPackage includesDefinedSelector: #fooBarOther ofClass: fooClass2).
	self deny: (fooPackage includesDefinedSelector: #zorkZork ofClass: fooClass2).
	self assert: (fooPackage includesDefinedSelector: #fooOtherClassSide ofClass: fooClass2 class).! !

!RPackageMCSynchronisationTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 22:50'!
testImportSystemClassWithSubCategory
	"self debug: #testImportSystemClassWithSubCategory"
	"indeed the user may have created a class in the category Foo-Core, and after created
	a package only named Foo. The classes in category Foo-Core should be added to Foo. But
	some other packages and categories starting with Foo may exist."
	| fooClass fooPackage |
	fooClass :=  Object subclass: #Foo
					instanceVariableNames: ''
					classVariableNames: ''
					poolDictionaries: ''
					category: 'FooPackage-Core'.
	fooClass compileSilently: 'foo ^ 1' classified: 'foo'.
	fooClass compileSilently: 'fooBar ^ 2' classified: 'foo'.
	fooClass compileSilently: 'fooFooBar ^ 3' classified: 'foo'.
	fooClass class compileSilently: 'fooClassSide ^ 1' classified: 'foo'.
	fooClass compileSilently: 'zork ^ 4' classified: '*zork'.
	fooPackage := self packageClass named: #FooPackage.
	fooPackage importCategory.
	self assert: (fooPackage includesDefinedSelector: #foo ofClass: fooClass).
	self assert: (fooPackage includesDefinedSelector: #fooBar ofClass: fooClass).
	self assert: (fooPackage includesDefinedSelector: #fooFooBar ofClass: fooClass).
	self deny: (fooPackage includesDefinedSelector: #zork ofClass: fooClass).
	self assert: (fooPackage includesDefinedSelector: #fooClassSide ofClass: fooClass class).! !

!RPackageMCSynchronisationTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 22:50'!
testImportSystemClassWithSubCategoryAndAnotherCategory
	"self debug: #testImportSystemClassWithSubCategoryAndAnotherCategory"
	"indeed the user may have created a class in the category Foo-Core, and after created
	a package only named Foo. The classes in category Foo-Core should be added to Foo. But
	some other packages and categories starting with Foo may exist."
	
	| fooClass fooPackage fooClass2|
	fooClass :=  Object subclass: #Foo
					instanceVariableNames: ''
					classVariableNames: ''
					poolDictionaries: ''
					category: 'FooPackage-Core'.
	fooClass compileSilently: 'foo ^ 1' classified: 'foo'.
	fooClass compileSilently: 'fooBar ^ 2' classified: 'foo'.
	fooClass compileSilently: 'fooFooBar ^ 3' classified: 'foo'.
	fooClass class compileSilently: 'fooClassSide ^ 1' classified: 'foo'.
	fooClass compileSilently: 'zork ^ 4' classified: '*zork'.
	
	fooClass2 :=  Object subclass: #FooOther
					instanceVariableNames: ''
					classVariableNames: ''
					poolDictionaries: ''
					category: 'FooPackage-Other'.
	fooClass2 compileSilently: 'fooOther ^ 1' classified: 'what s up'.
	fooClass2 compileSilently: 'fooBarOther ^ 2' classified: 'dr'.
	fooClass2 class compileSilently: 'fooOtherClassSide ^ 1' classified: 'lovely carots'.
	fooClass2 compileSilently: 'zorkZork ^ 4' classified: '*zorkzork'.
	
	fooPackage := self packageClass named: #FooPackage.
	fooPackage importCategory.
	self assert: (fooPackage definedClasses size = 2).
	self assert: (fooPackage includesDefinedSelector: #foo ofClass: fooClass).
	self assert: (fooPackage includesDefinedSelector: #fooBar ofClass: fooClass).
	self assert: (fooPackage includesDefinedSelector: #fooFooBar ofClass: fooClass).
	self deny: (fooPackage includesDefinedSelector: #zork ofClass: fooClass).
	self assert: (fooPackage includesDefinedSelector: #fooClassSide ofClass: fooClass class).
	self assert: (fooPackage includesDefinedSelector: #fooOther ofClass: fooClass2).
	self assert: (fooPackage includesDefinedSelector: #fooBarOther ofClass: fooClass2).
	self deny: (fooPackage includesDefinedSelector: #zorkZork ofClass: fooClass2).
	self assert: (fooPackage includesDefinedSelector: #fooOtherClassSide ofClass: fooClass2 class).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 23:03'!
testModifyMethodByChangingCode
	"test that when we modify the code the code of a method, everything work well "
	
	| class firstPackage secondPackage|
	self addXCategory.
	firstPackage := self organizer  packageNamed: #XXXXX.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass:  class inCategory: 'classic category'.

	self assert: (class >> #stubMethod) category = 'classic category'. 
	self assert: (firstPackage includesDefinedSelector: #stubMethod ofClass: class).
	self deny: (firstPackage includesExtensionSelector: #stubMethod ofClass: class).
	self assert: ((class >> #stubMethod) packageFromOrganizer: self organizer ) = firstPackage.
	
	class compile: 'stubMethod ^22222222222'.
	
	"nothing should change"
	self assert: (class >> #stubMethod) category = 'classic category'. 
	self assert: (firstPackage includesDefinedSelector: #stubMethod ofClass: class).
	self deny: (firstPackage includesExtensionSelector: #stubMethod ofClass: class).
	self assert: ((class >> #stubMethod) packageFromOrganizer: self organizer ) = firstPackage.! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 23:04'!
testModifyMethodByMovingFromClassicCategoryToClassicCategoryDoesNothing
	"test that when we move a method from a classic category (not begining with *) to another classic category , nothing is modified"
	
	| class firstPackage secondPackage|
	self addXCategory.
	firstPackage := self organizer packageNamed: #XXXXX.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass:  class inCategory: 'classic category'.

	self assert: (class >> #stubMethod) category = 'classic category'. 
	self assert: (firstPackage includesDefinedSelector: #stubMethod ofClass: class).
	self deny: (firstPackage includesExtensionSelector: #stubMethod ofClass: class).
	self assert: ((class >> #stubMethod) packageFromOrganizer: self organizer ) = firstPackage.
	
	class organization classify: #stubMethod under: 'new category'.
	self assert: (class >> #stubMethod) category = 'new category'. 
	self assert: (firstPackage includesDefinedSelector: #stubMethod ofClass: class).
	self deny: (firstPackage includesExtensionSelector: #stubMethod ofClass: class).
	self assert: ((class >> #stubMethod) packageFromOrganizer: self organizer ) = firstPackage! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 23:05'!
testModifyMethodByMovingFromClassicCategoryToExtensionCategoryMoveItFromParentPackageToExtendingPackage
	"test that when we move a method from a classic category (not begining with *) to an extension category , the method is moved from the parent package of the class to the extending package"
	
	| class firstPackage secondPackage|
	self addXYCategory. 
	firstPackage := self organizer  packageNamed: #XXXXX.
	secondPackage := self organizer  packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass:  class inCategory: 'classic category'.

	self assert: (class >> #stubMethod) category = 'classic category'. 
	self assert: (firstPackage includesDefinedSelector: #stubMethod ofClass: class).
	self deny: (firstPackage includesExtensionSelector: #stubMethod ofClass: class).
	self assert: ((class >> #stubMethod) packageFromOrganizer: self organizer ) = firstPackage.
	
	class organization classify: #stubMethod under: '*yyyyy'.	
	self assert: (class >> #stubMethod) category = '*yyyyy'. 
	self deny: (firstPackage includesDefinedSelector: #stubMethod ofClass: class).
	self assert: (secondPackage includesExtensionSelector: #stubMethod ofClass: class).
	self assert: ((class >> #stubMethod) packageFromOrganizer: self organizer ) = secondPackage.
	
	class organization classify: #stubMethod under: '*yyyyy-suncategory'.
	"class compileSilently: (class>>#stubMethod) getSource classified: '*yyyyy-suncategory'."
	self assert: (class >> #stubMethod) category = '*yyyyy-suncategory'. 
	self assert: ((class >> #stubMethod) packageFromOrganizer: self organizer ) = secondPackage.! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 23:05'!
testModifyMethodByMovingFromExtensionCategoryToClassicCategoryMoveItFromExtendingPackageToParentPackage

	"test that when we move a method from an extension category ( begining with *) to a classic category , the method is moved from the extending package to the parent package of the class"
	
	| class firstPackage secondPackage|
	self addXYCategory.
	firstPackage := self organizer  packageNamed: #XXXXX.
	secondPackage := self organizer  packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass:  class inCategory: '*yyyyy'.

	self assert: (class >> #stubMethod) category = '*yyyyy'. 
	self deny: (firstPackage includesDefinedSelector: #stubMethod ofClass: class).
	self assert: (secondPackage includesExtensionSelector: #stubMethod ofClass: class).
	self assert: ((class >> #stubMethod) packageFromOrganizer: self organizer ) = secondPackage.
	
	class organization classify: #stubMethod under: 'classic category'.
	
	self assert: (class >> #stubMethod) category = 'classic category'. 
	self assert: (firstPackage includesDefinedSelector: #stubMethod ofClass: class).
	self deny: (secondPackage includesExtensionSelector: #stubMethod ofClass: class).
	self assert: ((class >> #stubMethod) packageFromOrganizer: self organizer ) = firstPackage.! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 23:07'!
testModifyMethodByMovingFromExtensionCategoryToExtensionCategoryMoveItFromExtendingPackageToSecondExtendingPackage
	"test that when we move a method from an extension category ( begining with *) to another extending package , the method is moved from the extending package to the other extending package"
	
	| class XPackage YPackage ZPackage|
	self addXYZCategory.
	XPackage := self organizer  packageNamed: #XXXXX.
	YPackage := self organizer  packageNamed: #YYYYY.
	ZPackage := self organizer  packageNamed: #ZZZZZ.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: #newMethod inClass:  class inCategory: '*yyyyy'.

	self assert: (class >> #newMethod) category = '*yyyyy'. 
	self deny: (XPackage includesDefinedSelector: #newMethod ofClass: class).
	self assert: (YPackage includesExtensionSelector: #newMethod ofClass: class).
	self assert: ((class >> #newMethod) packageFromOrganizer: self organizer ) = YPackage.
	
	class organization classify: #newMethod under: '*zzzzz'.
	self assert: (class >> #newMethod) category = '*zzzzz'. 
	self deny: (XPackage includesDefinedSelector: #newMethod ofClass: class).
	self deny: (YPackage includesExtensionSelector: #newMethod ofClass: class).
	self assert: (ZPackage includesExtensionSelector: #newMethod ofClass: class).
	self assert: ((class >> #newMethod) packageFromOrganizer: self organizer ) = ZPackage.! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 23:09'!
testRecategorizeClassInUnknownCategoryRegisterTheClassInANewPackage
	"test that when we recategorize a class in category not yet registered in RPackage, a new rPackage is created with the class inside"
	
	|XPackage YPackage class|
	self addXCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self assert: (self organizer packageOf: class) = XPackage. 
	
	class category: 'YYYYY'.
	YPackage := self organizer packageNamed: #YYYYY.
	self assert: (self organizer packageOf: class) = YPackage. 
	self deny: (self organizer packageOf: class) = XPackage. ! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 23:10'!
testRecategorizeClassRegisterTheClassInTheNewPackage
	"test that when we recategorize a class, the new package in which it is defined include it"
	
	|XPackage YPackage class|
	self addXCategory.
	self addYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage := self organizer packageNamed: #YYYYY.
	
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self assert: (self organizer packageOf: class) = XPackage. 
	
	class category: 'YYYYY'.
	self assert: (self organizer packageOf: class) = YPackage. 
	self deny: (self organizer packageOf: class) = XPackage.		! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 23:33'!
testRecategorizeClassRegisterTheClassMethodsInTheNewPackage

	"test that when we recategorize a class, the new package in which it is defined include all the methods defined in this class (not extensions)"
	
	| addedCount addedCat XPackage YPackage ZPackage class|
	self addXCategory.
	self addYCategory.
	Smalltalk organization addCategory: 'ZZZZZ'.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage := self organizer packageNamed: #YYYYY.
	ZPackage := self organizer packageNamed: #ZZZZZ.
	
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'method1' inClass: class inCategory: 'category'.
	self createMethodNamed: 'method2' inClass: class inCategory: 'category'.
	self createMethodNamed: 'method3' inClass: class inCategory: '*zzzzz'.
	self createMethodNamed: 'method4' inClass: class inCategory: '*yyyyy'.
	
	self assert: (XPackage includesDefinedSelector: #method1 ofClass: class ). 
	self assert: (XPackage includesDefinedSelector: #method2 ofClass: class ).
	self assert: (ZPackage includesExtensionSelector: #method3 ofClass: class ). 
	self assert: (YPackage includesExtensionSelector: #method4 ofClass: class ). 
	
	class category: 'YYYYY'.
	
	self assert: (YPackage includesDefinedSelector: #method1 ofClass: class ). 
	self deny: (XPackage includesDefinedSelector: #method1 ofClass: class ). 
	self deny: (XPackage includesExtensionSelector: #method1 ofClass: class ). 
	self assert: (YPackage includesDefinedSelector: #method2 ofClass: class ).
	self deny: (XPackage includesDefinedSelector: #method2 ofClass: class ). 
	self deny: (XPackage includesExtensionSelector: #method2 ofClass: class ). 
	self deny: (YPackage includesExtensionSelector: #method3 ofClass: class ). 
	self deny: (YPackage includesDefinedSelector: #method3 ofClass: class ). 
	self assert: (ZPackage includesExtensionSelector: #method3 ofClass: class ). 
	"I am not sure about this test. For now it does not pass, but I don't know what is the expecting behavior here."
	"self assert: (YPackage includesExtensionSelector: #method4 ofClass: class ). "! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 23:34'!
testRecategorizeClassUnregisterTheClassFromTheOldPackage
	"test that when we recategorize a class, the old package in which it was defined don't include it anymore"
	

	|XPackage YPackage class|
	self addXCategory.
	self addYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage := self organizer packageNamed: #YYYYY.
	
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self assert: (self organizer packageOf: class) = XPackage. 
	
	class category: 'YYYYY'.
	self deny: (XPackage includesClass: class). 		! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 23:34'!
testRecategorizeClassUnregisterTheClassMethodsFromTheOldPackage
	"test that when we recategorize a class, the old package in which it was defined don't include its defined methods (not extensions) anymore"
	"self debug: #testRecategorizeClassUnregisterTheClassMethodsFromTheOldPackage"
		
	|XPackage YPackage ZPackage class|
	self addXCategory.
	self addYCategory.
	Smalltalk organization addCategory: 'ZZZZZ'.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage := self organizer packageNamed: #YYYYY.
	ZPackage := self organizer packageNamed: #ZZZZZ.
	
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'method1' inClass: class inCategory: 'category'.
	self createMethodNamed: 'method2' inClass: class inCategory: 'category'.
	self createMethodNamed: 'method3' inClass: class inCategory: '*zzzzz'.
	self createMethodNamed: 'method4' inClass: class inCategory: '*yyyyy'.
	
	self assert: (XPackage includesDefinedSelector: #method1 ofClass: class ). 
	self assert: (XPackage includesDefinedSelector: #method2 ofClass: class ).
	self assert: (ZPackage includesExtensionSelector: #method3 ofClass: class ). 
	self assert: (YPackage includesExtensionSelector: #method4 ofClass: class ). 
	
	class category: 'YYYYY'.
	self deny: (XPackage includesDefinedSelector: #method1 ofClass: class ). 
	self deny: (XPackage includesExtensionSelector: #method1 ofClass: class ). 
	self deny: (XPackage includesDefinedSelector: #method2 ofClass: class ). 
	self deny: (XPackage includesExtensionSelector: #method2 ofClass: class ). 
	self deny: (XPackage includesDefinedSelector: #method3 ofClass: class ). 
	self deny: (XPackage includesExtensionSelector: #method3 ofClass: class ). 
	self deny: (XPackage includesDefinedSelector: #method4 ofClass: class ). 
	self deny: (XPackage includesExtensionSelector: #method4 ofClass: class ).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 23:35'!
testRecategorizeClassUpdateTheOrganizer
	"test that when we recategorize a class, the organizer is updated so that the class name point the the new RPackage"
	
	|XPackage YPackage class|
	self addXCategory.
	self addYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	class category: 'YYYYY'.	
	self assert: (self organizer packageOf: class) = YPackage		! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 23:36'!
testRecategorizeClassWithExtensionInTheExtendedPackage
	"test that when we recategorize a class with extension methods in the corresponding extended package, the extension methods become defined methods"

			|XPackage YPackage class|
			self addXCategory.
			self addYCategory.
			XPackage := self organizer packageNamed: #XXXXX.
			YPackage := self organizer packageNamed: #YYYYY.
			
			class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
			self createMethodNamed: #RPackageTestsExtensionMethod inClass: class  inCategory: '*yyyyy'.  
			self assert: (self organizer packageOf: class) = XPackage. 
			self assert: (YPackage extensionSelectors includes: #RPackageTestsExtensionMethod). 
			self deny: ((XPackage definedSelectorsForClass: class) includes: #RPackageTestsExtensionMethod). 
		
			class category: 'YYYYY'.
			self assert: (self organizer packageOf: class) = YPackage. 
			self deny: (self organizer packageOf: class) = XPackage. 
			self deny: ((XPackage definedSelectorsForClass: class) includes: #RPackageTestsExtensionMethod).
			self assert: ((YPackage definedSelectorsForClass: class)  includes: #RPackageTestsExtensionMethod). 
			self deny: (YPackage extensionSelectors includes: #RPackageTestsExtensionMethod). ! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 23:37'!
testRecategorizeClassWithMetaClassMethodsRegisterAllClassMethodsInTheNewPackage

	"test that when we recategorize a class (having methods defined in both instance and class side), the new package in which it is defined include all the methods (from instance and class side) defined in this class (not extensions)"
	
	| addedCount addedCat XPackage YPackage ZPackage class|
	self addXCategory.
	self addYCategory.
	Smalltalk organization addCategory: 'ZZZZZ'.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage := self organizer packageNamed: #YYYYY.
	ZPackage := self organizer packageNamed: #ZZZZZ.
	
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'method1' inClass: class inCategory: 'category'.
	self createMethodNamed: 'method2' inClass: class inCategory: 'category'.
	self createMethodNamed: 'method3' inClass: class inCategory: '*zzzzz'.
	self createMethodNamed: 'method4' inClass: class inCategory: '*yyyyy'.
	self createMethodNamed: 'method5' inClass: class theMetaClass inCategory: 'category'.
	self createMethodNamed: 'method6' inClass: class theMetaClass inCategory: 'category'.
	self createMethodNamed: 'method7' inClass: class theMetaClass inCategory: '*zzzzz'.
	
	self assert: (XPackage includesDefinedSelector: #method1 ofClass: class ). 
	self assert: (XPackage includesDefinedSelector: #method2 ofClass: class ).
	self assert: (ZPackage includesExtensionSelector: #method3 ofClass: class ). 
	self assert: (YPackage includesExtensionSelector: #method4 ofClass: class ).
	self assert: (XPackage includesDefinedSelector: #method5 ofMetaclassName: class name). 
	self assert: (XPackage includesDefinedSelector: #method6 ofMetaclassName: class name). 
	self assert: (ZPackage includesExtensionSelector: #method7 ofMetaclassName: class name ). 
	
	class category: 'YYYYY'.
	
	self assert: (YPackage includesDefinedSelector: #method1 ofClass: class ). 
	self deny: (XPackage includesDefinedSelector: #method1 ofClass: class ). 
	self deny: (XPackage includesExtensionSelector: #method1 ofClass: class ). 
	self assert: (YPackage includesDefinedSelector: #method2 ofClass: class ).
	self deny: (XPackage includesDefinedSelector: #method2 ofClass: class ). 
	self deny: (XPackage includesExtensionSelector: #method2 ofClass: class ). 
	self deny: (YPackage includesExtensionSelector: #method3 ofClass: class ). 
	self deny: (YPackage includesDefinedSelector: #method3 ofClass: class ). 
	self assert: (ZPackage includesExtensionSelector: #method3 ofClass: class ). 
	"lets check metaclass methods"
	self assert: (YPackage includesDefinedSelector: #method5 ofMetaclassName: class name). 
	self assert: (YPackage includesDefinedSelector: #method6 ofMetaclassName: class name). 
	self deny: (XPackage includesDefinedSelector: #method5 ofMetaclassName: class name). 
	self deny: (XPackage includesDefinedSelector: #method6 ofMetaclassName: class name). 
	self assert: (ZPackage includesExtensionSelector: #method7 ofMetaclassName: class name ). 
	"I am not sure about this test. For now it does not pass, but I don't know what is the expecting behavior here."
	"self assert: (YPackage includesExtensionSelector: #method4 ofClass: class ). "		! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 23:37'!
testRemoveAllExtensionMethodsFromMetaAndInstanceSideUpdateOrganizerExtensionsDictionary
	"test that In a class (from the meta  and the instance side ), when we remove all the method extended by the same external package, the class get unregistered from the classExtendingPackagesMapping of the organizer "

	|XPackage  class YPackage|
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage  := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass: class  inCategory: '*yyyyy'. 
	self createMethodNamed: 'stubMethod2' inClass: class theMetaClass  inCategory: '*yyyyy'. 
	
	self assert: (YPackage includesExtensionSelector: #stubMethod ofClass: class). 
	self assert: (YPackage includesExtensionSelector: #stubMethod2 ofClass: class theMetaClass). 
	class removeSelector: #stubMethod.
	"there should be no differences made between class and metaClass:"
	self assert: ((self organizer extendingPackagesOf: class) includes: YPackage). 
	self assert: ((self organizer extendingPackagesOf: class theMetaClass) includes: YPackage). 
	class theMetaClass removeSelector: #stubMethod2.
	"there should be no differences made between class and metaClass:"
	self deny: ((self organizer extendingPackagesOf: class) includes: YPackage). 
	self deny: ((self organizer extendingPackagesOf: class theMetaClass) includes: YPackage). ! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 23:38'!
testRemoveAllExtensionMethodsFromMetaClassUpdateOrganizerExtensionsDictionary
	"test that In a class (from the meta side), when we remove all the method extended by the same external package, the class get unregistered from the classExtendingPackagesMapping of the organizer "

	|XPackage  class YPackage|
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage  := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass: class theMetaClass inCategory: '*yyyyy'. 
	self createMethodNamed: 'stubMethod2' inClass: class theMetaClass  inCategory: '*yyyyy'. 
	
	self assert: (YPackage includesExtensionSelector: #stubMethod ofClass: class theMetaClass). 
	self assert: (YPackage includesExtensionSelector: #stubMethod2 ofClass: class theMetaClass). 
	class theMetaClass removeSelector: #stubMethod.
	"there should be no differences made between class and metaClass:"
	self assert: ((self organizer extendingPackagesOf: class) includes: YPackage). 
	self assert: ((self organizer extendingPackagesOf: class theMetaClass) includes: YPackage). 
	class theMetaClass removeSelector: #stubMethod2.
	"there should be no differences made between class and metaClass:"
	self deny: ((self organizer extendingPackagesOf: class) includes: YPackage). 
	self deny: ((self organizer extendingPackagesOf: class theMetaClass) includes: YPackage). ! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 23:38'!
testRemoveAllExtensionMethodsRemoveTheClassFromExtendedClasses
	"test that In a class, when we remove all the method extended by the same external package, the class get unregistered from the extended classes of the external package "

	|XPackage  class YPackage|
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage  := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass: class  inCategory: '*yyyyy'. 
	self createMethodNamed: 'stubMethod2' inClass: class  inCategory: '*yyyyy'. 
	
	self assert: (YPackage includesExtensionSelector: #stubMethod ofClass: class). 
	self assert: (YPackage includesExtensionSelector: #stubMethod2 ofClass: class). 
	class removeSelector: #stubMethod.
	self assert: (YPackage extendsClass: class). 
	class removeSelector: #stubMethod2.
	self deny: (YPackage extendsClass: class).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 23:38'!
testRemoveAllExtensionMethodsRemoveTheMetaClassFromExtendedClasses
	"test that In a class (from the class side), when we remove all the method extended by the same external package, the class get unregistered from the extended classes of the external package "

	|XPackage  class YPackage|
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage  := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass: class theMetaClass inCategory: '*yyyyy'. 
	self createMethodNamed: 'stubMethod2' inClass: class theMetaClass  inCategory: '*yyyyy'. 
	
	self assert: (YPackage includesExtensionSelector: #stubMethod ofClass: class theMetaClass ). 
	self deny: (YPackage includesExtensionSelector: #stubMethod ofClass: class). 
	self assert: (YPackage includesExtensionSelector: #stubMethod2 ofClass: class theMetaClass ).
	self deny: (YPackage includesExtensionSelector: #stubMethod2 ofClass: class ). 
	class theMetaClass removeSelector: #stubMethod.
	self assert: (YPackage extendsClass: class theMetaClass ). 
	self assert: (YPackage extendsClass: class ). 
	class theMetaClass removeSelector: #stubMethod2.
	self deny: (YPackage extendsClass: class).
	self deny: (YPackage extendsClass: class theMetaClass).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 23:39'!
testRemoveAllExtensionMethodsUpdateOrganizerExtensionsDictionary
	"test that In a class, when we remove all the method extended by the same external package, the class get unregistered from the classExtendingPackagesMapping of the organizer "

	|XPackage  class YPackage|
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage  := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass: class  inCategory: '*yyyyy'. 
	self createMethodNamed: 'stubMethod2' inClass: class  inCategory: '*yyyyy'. 
	
	self assert: (YPackage includesExtensionSelector: #stubMethod ofClass: class). 
	self assert: (YPackage includesExtensionSelector: #stubMethod2 ofClass: class). 
	class removeSelector: #stubMethod.
	self assert: ((self organizer extendingPackagesOf: class) includes: YPackage). 
	class removeSelector: #stubMethod2.
	self deny: ((self organizer extendingPackagesOf: class) includes: YPackage).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on categories' stamp: 'GuillermoPolito 5/26/2012 23:39'!
testRemoveCategoryRemoveThePackage
	"test that when we remove a category, the corresponding RPackage is removed from the organizer"
	
	|XPackage class|
	self addXCategory.
	self assert: (self organizer includesPackageNamed: #XXXXX).
	Smalltalk organization removeCategory: 'XXXXX'.
	self deny: (self organizer includesPackageNamed: #XXXXX).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on categories' stamp: 'GuillermoPolito 5/26/2012 23:40'!
testRemoveCategoryWhenMCPackageExistDoesNotRemoveThePackage
	"test that when we remove a category (usually from the class browser), and that a corresponding MCPackage exist, the RPackage still exist till the MCPackage has been unloaded"
	
	|XPackage class mCPackage|
	"let's create the category and the MCPackage"
	self addXCategory.
	mCPackage := MCWorkingCopy forPackage: (MCPackage new name: 'XXXXX').
	"we make sure that the RPackage has been create (only one time)"
	self assert: (self organizer includesPackageNamed: #XXXXX).
	self assert: (self organizer packages select: [:each | each name = 'XXXXX']) size = 1.
	"we remove the category"
	Smalltalk organization removeCategory: 'XXXXX'.
	"we make sure the RPackage still exist"
	self assert: (self organizer includesPackageNamed: #XXXXX).
	
	"for now, this no longer the expected behavior. See comment in RPackageOrganizer>>update:"
	"mCPackage unregister.
	self deny: (anOrganizer includesPackageNamed: #XXXXX)."	! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 23:40'!
testRemoveClassUnregisterTheClassDefinedMethodsFromItsPackage
	"test that when we remove a class, the class methods defined in the parent package (not extensions) are all removed  from its parent Package"
	
			|XPackage  class|
			self addXCategory.
			XPackage := self organizer packageNamed: #XXXXX.
			class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
			self createMethodNamed: 'stubMethod' inClass: class  inCategory: 'classic category'. 
			
			self assert: (XPackage includesDefinedSelector: #stubMethod ofClass: class). 
			Smalltalk removeClassNamed: 'NewClass'. 
			self deny: (XPackage includesDefinedSelector: #stubMethod ofClass: class). 
			self deny: (XPackage includesExtensionSelector: #stubMethod ofClass: class). 
			self deny: (XPackage includesSelector: #stubMethod ofClass: class). ! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 23:40'!
testRemoveClassUnregisterTheClassExtensionMethodsFromTheCorrespondingPackage
	"test that when we remove a class, the class extension methods are all removed  from theire corresponding parent Package"
	
	|XPackage YPackage class|
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass: class  inCategory: '*yyyyy'. 
	
	self assert: (YPackage includesExtensionSelector: #stubMethod ofClass: class). 
	Smalltalk removeClassNamed: 'NewClass'. 
	self deny: (YPackage includesDefinedSelector: #stubMethod ofClass: class). 
	self deny: (YPackage includesExtensionSelector: #stubMethod ofClass: class). 
	self deny: (YPackage includesSelector: #stubMethod ofClass: class). ! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 23:40'!
testRemoveClassUnregisterTheClassFromItsPackage
	"test that when we remove a class, the class is removed from its parent Package"	

	|XPackage  class|
	self addXCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self assert: (XPackage includesClass: class). 
	Smalltalk removeClassNamed: 'NewClass'. 
	self deny: (XPackage includesClass: class)! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 23:41'!
testRemoveClassUpdateTheorganizer
	"test that when we remove a class, the organizer is updated so that the class is no longer present in the  'classPackageDictionary' dictionary"
	
	|XPackage  class|
	self addXCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self assert: (self organizer includesPackageBackPointerForClass: class). 
	Smalltalk removeClassNamed: 'NewClass'. 
	self deny: (self organizer includesPackageBackPointerForClass: class)! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 23:41'!
testRemoveExtensionMethodDoesNotRemoveExtendingPackage
	"test that when we remove a method that is an extension from an external package, the package is not removed from the the class extending packages if another extension still exist"

	|XPackage  class YPackage|
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage  := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass: class  inCategory: '*yyyyy'. 
	self createMethodNamed: 'stubMethod2' inClass: class  inCategory: '*yyyyy'. 
	
	self assert: (YPackage includesExtensionSelector: #stubMethod ofClass: class). 
	class removeSelector: #stubMethod.
	self assert: ((self organizer extendingPackagesOf: class) includes: YPackage).  ! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 23:42'!
testRemoveExtensionMethodDoesRemoveExtendingPackage
	"test that when we remove a method that is an extension from an external package, the package is  removed from the the class extending packages if no other extension method exist"

	|XPackage  class YPackage|
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage  := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass: class  inCategory: '*yyyyy'. 
	
	self assert: (YPackage includesExtensionSelector: #stubMethod ofClass: class). 
	class removeSelector: #stubMethod.
	self assert: ((self organizer extendingPackagesOf: class) isEmpty).  ! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 23:42'!
testRemoveExtensionMethodRemoveMethodFromItsPackage
	"test that when we remove a method that is an extension from an external package, the method is removed from this package"

	|XPackage  class YPackage|
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage  := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass: class  inCategory: '*yyyyy'. 
	
	self assert: (YPackage includesExtensionSelector: #stubMethod ofClass: class). 
	class removeSelector: #stubMethod.
	self deny: (YPackage includesDefinedSelector: #stubMethod ofClass: class). 
	self deny: (YPackage includesExtensionSelector: #stubMethod ofClass: class). 
	self deny: (YPackage includesSelector: #stubMethod ofClass: class).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on MCPackages' stamp: 'StephaneDucasse 6/2/2012 19:42'!
testRemoveMCPackageRemoveThePackage
	"test that when we remove a MC Package, the corresponding RPackage is removed from the organizer"
	
	|XPackage class|
	MCWorkingCopy forPackage: (MCPackage new name: 'XXXXX').
	self assert: (self organizer includesPackageNamed: #XXXXX).
	(self allManagers detect: [:each | each packageName = 'XXXXX']) unregister.
	"for now, this is no longer the expected behavior. See comment in RPackageOrganizer>>update:"
	"self deny: (anOrganizer includesPackageNamed: #XXXXX)."
	! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 23:44'!
testRemoveMethodComingFromTraitDoesNotRemoveMethodFromTraitPackage
	"test that when we remove a class method coming from a trait, the method is not removed from the parent package of the trait"
	
	|XPackage YPackage class trait|
	self addXCategory.
	self addYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	trait := self createNewTraitNamed: 'NewTrait' inCategory: 'YYYYY'.
	self createMethodNamed: 'stubMethod' inClass: trait  inCategory: 'classic protocol'. 
	class setTraitComposition: (trait) asTraitComposition.
	
	self assert: (YPackage includesDefinedSelector: #stubMethod ofClass: trait). 
	self deny: (XPackage includesDefinedSelector: #stubMethod ofClass: class). 
	class removeSelector: #stubMethod.
	self assert: (YPackage includesDefinedSelector: #stubMethod ofClass: trait). 
	self deny: (XPackage includesDefinedSelector: #stubMethod ofClass: class). ! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 23:44'!
testRemoveMethodRemoveMethodFromItsPackage
	"test that when we remove a method, the method is remod from the package in which the method is defined"
	
	|XPackage  class|
	self addXCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass: class  inCategory: 'classic category'. 
	
	self assert: (XPackage includesDefinedSelector: #stubMethod ofClass: class). 
	class removeSelector: #stubMethod.
	self deny: (XPackage includesDefinedSelector: #stubMethod ofClass: class). 
	self deny: (XPackage includesExtensionSelector: #stubMethod ofClass: class). 
	self deny: (XPackage includesSelector: #stubMethod ofClass: class). ! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on methods' stamp: 'GuillermoPolito 5/26/2012 23:44'!
testRemoveTraitMethod
	"test that when we remove a method from a trait used by a class, the method is removed from the trait package normally"
	
	|XPackage YPackage class trait|
	self addXCategory.
	self addYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	trait := self createNewTraitNamed: 'NewTrait' inCategory: 'YYYYY'.
	self createMethodNamed: 'stubMethod' inClass: trait  inCategory: 'classic protocol'. 
	class setTraitComposition: (trait) asTraitComposition.
	
	self assert: (YPackage includesDefinedSelector: #stubMethod ofClass: trait). 
	self deny: (XPackage includesDefinedSelector: #stubMethod ofClass: class). 
	trait removeSelector: #stubMethod.
	self deny: (YPackage includesDefinedSelector: #stubMethod ofClass: trait). 
	self deny: (XPackage includesDefinedSelector: #stubMethod ofClass: class). ! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on categories' stamp: 'GuillermoPolito 5/26/2012 23:45'!
testRenameCategoryAlsoRenameAllExtensionProtocols
	"test that when we rename a category, all corresponding extension protocols in the system are renamed"
	"self debug: #testRenameCategoryAlsoRenameAllExtensionProtocols"
	
	|XPackage YPackage ZPackage classInY classInZ| 
	self addXCategory.
	self addYCategory.
	self addZCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage := self organizer packageNamed: #YYYYY.
	ZPackage := self organizer packageNamed: #ZZZZZ.
	
	classInY := self createNewClassNamed: 'ClassInYPackage' inCategory: 'YYYYY'.
	classInZ := self createNewClassNamed: 'ClassInZPackage' inCategory: 'ZZZZZ'. 
	
	self createMethodNamed:  'extensionFromXInClassInY'  inClass: classInY   inCategory: '*XXXXX'. 
	self createMethodNamed:  'longNameExtensionFromXInClassInY'  inClass: classInY   inCategory: '*XXXXX-subcategory'.     
	self createMethodNamed:  'extensionFromXInClassInZ'  inClass: classInZ   inCategory: '*XXXXX'.     
	    
	Smalltalk organization renameCategory: 'XXXXX' toBe: 'NewCategoryName'.
	
	self assert: (XPackage name = 'NewCategoryName').
	self assert: (classInY >> #extensionFromXInClassInY) category = '*NewCategoryName'.
	self assert: (classInY >> #longNameExtensionFromXInClassInY) category = '*NewCategoryName'.
	self assert: (classInZ >> #extensionFromXInClassInZ) category = '*NewCategoryName'.! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on categories' stamp: 'GuillermoPolito 5/26/2012 23:45'!
testRenameCategoryChangeTheNameOfThePackage
	"test that when we rename a category, the RPackage corresponding is updated with this new name"
	
	|XPackage| 
	self addXCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	
	Smalltalk organization renameCategory: 'XXXXX' toBe: 'YYYYY'.
	self assert: (XPackage name = 'YYYYY').! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on categories' stamp: 'GuillermoPolito 5/26/2012 23:45'!
testRenameCategoryUpdateTheOrganizer
	"test that when we rename a category, the organizer dictionary is update with this new name, so that we can access the package with this new name as key"

	|XPackage| 
	self addXCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	Smalltalk organization renameCategory: 'XXXXX' toBe: 'YYYYY'.
	self assert: (self organizer packageNamed: 'YYYYY' asSymbol) = XPackage.
	self deny: (self organizer includesPackageNamed: #XXXXX).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 23:45'!
testRenameClassUpdateClassDefinedInTheParentPackage
	"test that when we rename a class, the classes Defined in the parent package includes the new name"
	"self debug: #testRenameClassUpdateClassDefinedInTheParentPackage"
	
	|XPackage  class refactoring|
	self addXCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	
	class := self createNewClassNamed: 'RPackageOldStubClass' inCategory: 'XXXXX'.	
	class rename: 'RPackageNewStubClass'.
	
	self assert: (XPackage includesClassNamed: 'RPackageNewStubClass'). 
	self deny: (XPackage includesClassNamed: 'RPackageOldStubClass').! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 23:46'!
testRenameClassUpdateClassDefinedSelectorsInTheParentPackage
	"test that when we rename a class, the  'classDefinedSelectors' dictionary of the parent package is updated with the new name. There fore we test that we can correctly access the selector from the package by specifying the right name (the new name)"
	
	|XPackage  class refactoring|
	self addXCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	class := self createNewClassNamed: 'RPackageOldStubClass' asSymbol inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass: class  inCategory: 'classic category'.
	
	class rename: 'RPackageNewStubClass'.
	
	self assert: (XPackage includesDefinedSelector: #stubMethod ofClassName: 'RPackageNewStubClass' asSymbol ). 
	self deny: (XPackage includesDefinedSelector: #stubMethod ofClassName: 'RPackageOldStubClass' asSymbol ).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 23:46'!
testRenameClassUpdateClassExtensionSelectorsInTheExtendingPackages
	"test that when we rename a class, the  'classExtensionSelectors' dictionaries of the extending packages  are updated with the new name. Therfore we test that we can correctly access the selectors from the package by specifying the right name (the new name)"

	|XPackage YPackage class refactoring|
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'RPackageOldStubClass' asSymbol inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass: class  inCategory: '*yyyyy'.
	
	class rename: 'RPackageNewStubClass'.
	
	self assert: (YPackage includesExtensionSelector: #stubMethod ofClassName: 'RPackageNewStubClass' asSymbol ). 
	self deny: (YPackage includesExtensionSelector: #stubMethod ofClassName: 'RPackageOldStubClass' asSymbol ).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 23:46'!
testRenameClassUpdateMetaclassDefinedSelectorsInTheParentPackage
	"test that when we rename a class, the  'metaclassDefinedSelectors' dictionary of the parent package is updated with the new name. Ther fore we test that we can correctly access the selector from the package by specifying the right name (the new name)"
	
	|XPackage  class refactoring|
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	class := self createNewClassNamed: 'RPackageOldStubClass' asSymbol inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClassSideOfClass: class  inCategory: 'classic category'.
	
	class rename: 'RPackageNewStubClass'.
	
	self assert: (XPackage  includesDefinedSelector: #stubMethod ofMetaclassName: 'RPackageNewStubClass' asSymbol ). 
	self deny: (XPackage  includesDefinedSelector: #stubMethod ofMetaclassName: 'RPackageOldStubClass' asSymbol ).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 23:47'!
testRenameClassUpdateMetaclassExtensionSelectorsInTheExtendingPackages
	"test that when we rename a class, the  'metaclassExtensionSelectors' dictionaries of the extending packages  are updated with the new name. Ther fore we test that we can correctly access the selectors from the package by specifying the right name (the new name)"
	
	|XPackage YPackage class refactoring|
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'RPackageOldStubClass' asSymbol inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClassSideOfClass: class  inCategory: '*yyyyy'.
	
	class rename: 'RPackageNewStubClass'.
	
	self assert: (YPackage includesExtensionSelector: #stubMethod ofMetaclassName: 'RPackageNewStubClass' asSymbol ). 
	self deny: (YPackage includesExtensionSelector: #stubMethod ofMetaclassName: 'RPackageOldStubClass' asSymbol ).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 23:47'!
testRenameClassUpdateOrganizerClassExtendingPackagesMapping
	"test that when we rename a class, the classExtendingPackages dictionary of the organizer is updated with the new name, so that we can access the packages when specifying the new name"
	
	|XPackage YPackage class refactoring|
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'RPackageOldStubClass' inCategory: 'XXXXX'.
	self createMethodNamed: #stubMethod inClass: class inCategory: '*yyyyy'. 
	
	class rename: 'RPackageNewStubClass'.
	
	self assert: ((self organizer extendingPackagesOfClassNamed: 'RPackageNewStubClass' asSymbol) includes: YPackage). 
	self deny: ((self organizer extendingPackagesOfClassNamed: 'RPackageOldStubClass' asSymbol) includes: YPackage).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on classes' stamp: 'GuillermoPolito 5/26/2012 23:47'!
testRenameClassUpdateOrganizerClassPackageMapping
	"test that when we rename a class, the classPackage dictionary of the organizer is updated with the new name, so that we can access the package when specifying the new name"
	
	|XPackage class refactoring|
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	class := self createNewClassNamed: 'RPackageOldStubClass' inCategory: 'XXXXX'.
	
	class rename: 'RPackageNewStubClass'.
	
	self assert: ((self organizer packageOfClassNamed: 'RPackageNewStubClass' asSymbol) = XPackage). 
	self assert: ((self organizer packageOfClassNamed: 'RPackageOldStubClass' asSymbol) = nil).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on categories' stamp: 'EstebanLorenzano 8/3/2012 15:29'!
testRenameUnknownCategoryCreatesNewRPackage
	"test that when we rename a category that is not registered in RPackage , it does not raise errors and simply create a new package. We need this behaviour as for now, create a new category with the class browser does not emit the corrects events, and therefore RPackage can not be directly updated"
	
	SystemAnnouncer uniqueInstance suspendAllWhile: [
		self addXCategory.
		].
	self deny: (self organizer includesPackageNamed: #XXXXX).
	Smalltalk organization renameCategory: 'XXXXX' toBe: 'YYYYY'.
	self assert: (self organizer includesPackageNamed: #YYYYY).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on protocols' stamp: 'GuillermoPolito 5/26/2012 23:48'!
testReorganizeClassByAddingNewProtocolDoesNothing
	"test that when we reoganized a class by adding a category, nothing change from  RPackage point of vue."
	
	|XPackage YPackage class| 
	self addXCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'newMethod' inClass: class inCategory: 'xxxxx'.  
	class organization addCategory: 'accessing' before: nil.
	
	self assert: (XPackage includesClass: class).
	self assert: (XPackage includesDefinedSelector: #newMethod ofClass: class).
	self assert: (XPackage extensionMethods size = 0).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on protocols' stamp: 'EstebanLorenzano 7/27/2012 20:19'!
testReorganizeClassByRemovingClassicCategoryRemoveMethodsFromTheParentPackage
	"test that when we reoganized a class by removing a classic category (a category not beginning with '*'), the methods from this category are removed from the parent RPackage of the class"
	
	|XPackage YPackage class| 
		
	self addXCategory.
	XPackage := self organizer packageNamed: 'XXXXX'.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass: class  inCategory: 'classic category'.
	class removeCategory: 'classic category'.
	self deny: (XPackage includesDefinedSelector: #stubMethod ofClass: class).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on protocols' stamp: 'GuillermoPolito 5/26/2012 23:49'!
testReorganizeClassByRemovingExtensionCategoryRemoveMethodsFromTheExtendingPackage
	"test that when we reoganized a class by removing an extension category (a category beginning with '*'), all the methods that were inside are removed from the extending package"
	 
	|XPackage YPackage class| 
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage  := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	
	self createMethodNamed: 'stubMethod' inClass: class  inCategory: '*yyyyy'.
	
	class removeCategory: '*yyyyy'.
	
	self deny: (YPackage includesExtensionSelector: #stubMethod ofClass: class).
	self deny: (XPackage includesDefinedSelector: #stubMethod ofClass: class).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on protocols' stamp: 'GuillermoPolito 5/26/2012 23:49'!
testReorganizeClassByRenamingClassicCategoryToExtensionCategoryMoveAllMethodsFromParentPackageToExtendingPackage
	"self debug:#testReoganizeClassByRenamingClassicCategoryToExtensionCategoryMoveAllMethodsFromParentPackageToExtendingPackage"
	"test that when we reoganized a class by renaming a  classic category (a category not beginning with '*') to an extension category, all the methods are moved from the  parent package of the class to the extending package"
	|XPackage YPackage class| 
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage  := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	
	self createMethodNamed: 'stubMethod' inClass: class  inCategory: 'classic category'.
	self createMethodNamed: 'stubMethod2' inClass: class  inCategory: 'classic category'.
	
	class organization renameCategory: 'classic category' toBe: '*yyyyy'.
	
	self assert: (YPackage includesExtensionSelector: #stubMethod ofClass: class).
	self assert: (YPackage includesExtensionSelector: #stubMethod2 ofClass: class).
	self deny: (XPackage includesDefinedSelector: #stubMethod ofClass: class).
	self deny: (XPackage includesDefinedSelector: #stubMethod2 ofClass: class).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on protocols' stamp: 'GuillermoPolito 5/26/2012 23:49'!
testReorganizeClassByRenamingClassicCategoryToExtensionCategoryMoveMethodsFromParentPackageToExtendingPackage
	"test that when we reoganized a class by renaming a  classic category (a category not beginning with '*') to an extension category, all the methods are moved from the  parent package of the class to the extending package"

	|XPackage YPackage class| 
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage  := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass: class  inCategory: 'classic category'.
	class organization renameCategory: 'classic category' toBe: '*yyyyy'.
	self assert: (YPackage includesExtensionSelector: #stubMethod ofClass: class).
	self deny: (XPackage includesDefinedSelector: #stubMethod ofClass: class)! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on protocols' stamp: 'GuillermoPolito 5/26/2012 23:49'!
testReorganizeClassByRenamingExtensionCategoryToAnotherExtensionCategoryAddMethodsToTheNewPackage
	"test that when we reoganized a class by renaming an extension category (a category beginning with '*') to another extension category, all the methods are moved to the new extendingPackage"
	
	|XPackage YPackage ZPackage class| 
	self addXYZCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage  := self organizer packageNamed: #YYYYY.
	ZPackage  := self organizer packageNamed: #ZZZZZ.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass: class  inCategory: '*yyyyy'.
	class organization renameCategory: '*yyyyy' toBe: '*zzzzz'.
	self assert: (ZPackage includesExtensionSelector: #stubMethod ofClass: class).
	self deny: (YPackage includesExtensionSelector: #stubMethod ofClass: class).
	self deny: (XPackage includesDefinedSelector: #stubMethod ofClass: class)! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on protocols' stamp: 'GuillermoPolito 5/26/2012 23:50'!
testReorganizeClassByRenamingExtensionCategoryToClassicCategoryMoveAllMethodsFromExtendingPackageToParentPackage
	"test that when we reoganized a class by renaming an extension category (a category beginning with '*') to a classic category, all the methods are moved from the  extendingPackage to the parent package of the class"
	"self debug: #testReoganizeClassByRenamingExtensionCategoryToClassicCategoryMoveAllMethodsFromExtendingPackageToParentPackage"
	
	|XPackage YPackage class| 
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage  := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	
	self createMethodNamed: 'stubMethod' inClass: class  inCategory: '*yyyyy'.
	self createMethodNamed: 'stubMethod2' inClass: class  inCategory: '*yyyyy'.
	
	class organization renameCategory: '*yyyyy' toBe: 'classic category'.
	
	self deny: (YPackage includesExtensionSelector: #stubMethod ofClass: class).
	self deny: (YPackage includesExtensionSelector: #stubMethod2 ofClass: class).
	self assert: (XPackage includesDefinedSelector: #stubMethod ofClass: class).
	self assert: (XPackage includesDefinedSelector: #stubMethod2 ofClass: class).! !

!RPackageMCSynchronisationTest methodsFor: 'tests - operations on protocols' stamp: 'GuillermoPolito 5/26/2012 23:50'!
testReorganizeClassByRenamingExtensionCategoryToClassicCategoryMoveMethodsFromExtendingPackageToParentPackage
	"test that when we reoganized a class by renaming an extension category (a category beginning with '*') to a classic category, all the methods are moved from the  extendingPackage to the parent package of the class"
	
	|XPackage YPackage class| 
	self addXYCategory.
	XPackage := self organizer packageNamed: #XXXXX.
	YPackage  := self organizer packageNamed: #YYYYY.
	class := self createNewClassNamed: 'NewClass' inCategory: 'XXXXX'.
	self createMethodNamed: 'stubMethod' inClass: class  inCategory: '*yyyyy'.
	class organization renameCategory: '*yyyyy' toBe: 'classic category'.
	self deny: (YPackage includesExtensionSelector: #stubMethod ofClass: class).
	self assert: (XPackage includesDefinedSelector: #stubMethod ofClass: class)! !

!RPackageMCSynchronisationTest methodsFor: 'tests' stamp: 'GuillermoPolito 5/26/2012 23:50'!
testisDefinedAsPackageOrSubPackageInMC
	"test whether a given category is defined as a MC package or whether it is defined as top part of package"
	
	"self debug: #testisDefinedAsSubPackageInMC"
	"self debug: #testisDefinedAsPackageOrSubPackageInMC"
	
	self assert: (self organizer isDefinedAsPackageOrSubPackageInMC: #'Compression').
	self deny: (self organizer isDefinedAsPackageOrSubPackageInMC: #'Compression-Archives').
	"Indeed compression-archives is a category but not a MC package"
	
	self assert: (self organizer isDefinedAsPackageOrSubPackageInMC: #'Collections').
	"#Collection is not defined as a package but as a package #'Collections-Unordered'"
	self assert: (self organizer isDefinedAsPackageOrSubPackageInMC: #'Collections-Unordered').
	self deny: (self organizer isDefinedAsPackageOrSubPackageInMC: #'Collections-Unordered-Test').! !

RPackageTestCase subclass: #RPackageOrganizerTest
	instanceVariableNames: 'createdClasses createdPackages organizer packageOrganizer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageOrganizerTest commentStamp: 'StephaneDucasse 4/24/2011 17:10' prior: 0!
RPackageOrganizerTest tests the behavior of PackageOrganizer. 
Note that it does not rely on announcement to be emitted to maintain invariants.
Therefore the new created PackageOrganizer is not registered to listen to event.

!

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-06-05T18:28:00+01:00'!
createNewClassNamed: aName
	
	| cls |
	cls := Object subclass: aName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: 'RPackageTest'.
	createdClasses add: cls.
	^ cls! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-06-05T18:28:00+01:00'!
createNewClassNamed: aName inCategory: cat
	
	| cls |
	cls := Object subclass: aName
		instanceVariableNames: ''
		classVariableNames: ''
		poolDictionaries: ''
		category: cat.
	createdClasses add: cls.
	^ cls! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-06-05T18:28:00+01:00'!
createNewClassNamed: aName inPackage: p
	
	| cls |
	cls := self createNewClassNamed: aName.
	p addClassDefinition: cls.
	^ cls! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-06-05T18:28:00+01:00'!
createNewPackageNamed: aName

	| pack |
	self removePackageIfExist: aName.
	pack := self packageClass named: aName.
	createdPackages add: pack.
	^ pack! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:46'!
p1Name
	^ 'RPackageTestP1'! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:46'!
p2Name
	^ 'RPackageTestP2'! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:46'!
p3Name
	^ 'RPackageTestP3'! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: 'StephaneDucasse 4/24/2011 17:13'!
packageOrganizer

	^ packageOrganizer ! !

!RPackageOrganizerTest methodsFor: 'tests extending' stamp: 'StephaneDucasse 6/3/2012 22:51'!
pointRectangleInGraphElement 
	| p |
	p := self packageClass named: #GraphElement.
	p addClassDefinition: Point.
	p addMethod: Point>>#x.
	p addMethod: Point>>#rotateBy:about:. 
	p addClassDefinition: Rectangle.
	p addMethod: Quadrangle>>#intersect:.
	^ p! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: '2010-07-29T21:54:00+01:00'!
removeClassNamedIfExists: aClassNameSymbol

	Smalltalk globals at: aClassNameSymbol asSymbol ifPresent: [ :c | c removeFromSystem ]! !

!RPackageOrganizerTest methodsFor: 'utility' stamp: 'cyrilledelaunay 5/30/2011 17:19'!
removePackageIfExist: aName

	self packageOrganizer basicUnregisterPackageNamed: aName asSymbol.
		
	! !

!RPackageOrganizerTest methodsFor: 'setup' stamp: 'StephaneDucasse 6/3/2012 23:25'!
setUp
	super setUp.
	createdClasses := OrderedCollection new.
	createdPackages := OrderedCollection new.
	packageOrganizer := self packageOrganizerClass basicNew initialize.
	packageOrganizer debuggingName: 'For PackageOrganizerTest'.
	Author fullName ifNil: [Author fullName: 'RPackage'].! !

!RPackageOrganizerTest methodsFor: 'tests extending' stamp: 'StephaneDucasse 6/3/2012 22:51'!
stringCharacterInCollPackage
	| p |
	p := self packageClass named: #CollPackage.
	p addClassDefinition: String.
	p addClassDefinition: Character.
	p addMethod: String>>#indexOf:.
	p addMethod: String>>#isAllDigits.
	p addMethod: String class>>#cr.
	p addMethod: Character>>#asInteger.
	p addMethod: Text>>#allBold.
	^ p! !

!RPackageOrganizerTest methodsFor: 'setup' stamp: 'StephaneDucasse 4/24/2011 17:12'!
tearDown 

	(createdClasses reject: [:c| c isObsolete])
		do: [:cls| 
				"(self packageClass organizer includesClass: cls)
					ifTrue: [self packageOrganizer unregisterClass: cls.]."
				cls removeFromSystem ].
	"createdPackages do:
		[:each | self packageOrganizer unregisterPackage: each]"! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:52'!
testAccessingPackage
	"self debug: #testAccessingPackage"

	| p1 |
	p1 := self createNewPackageNamed: 'P1'.
	self packageOrganizer registerPackage: p1.
	p1 addClassDefinition: Point.
	p1 addMethod: Point>>#x.
	p1 addMethod: Point class>>#x:y:. 
	self assert: (self packageOrganizer packageNamed: #P1) = p1.
	self should: [(self packageOrganizer packageNamed: #P22)] raise: Error! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:52'!
testDefinedClassesInstanceAndMetaSideAPI
	"self debug: #testDefinedClassesInstanceAndMetaSideAPI"
	| p1 |
	p1 := self createNewPackageNamed: 'P1'.
	self packageOrganizer registerPackage: p1.
	p1 addClassDefinition: Point.
	p1 addMethod: Point>>#x.
	p1 addMethod: Point class>>#x:y:. 
	self assert: self packageOrganizer packageNames size = 2.
	self assert: self packageOrganizer packages size = 2.
	self assert: (self packageOrganizer packageNamed: #P1) definedClasses size = 1! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 22:51'!
testEmpty
	"self debug: #testEmpty"
	self assert: self packageOrganizer packageNames size = 1.
	self assert: (self packageOrganizer packageNames includes: self packageClass defaultPackageName)
! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:50'!
testFullRegistration
	"self debug: #testFullRegistration"

	| p1 p2 p3 a1 a2 b1 b2 a3 |
	"taken from setup of RPackageReadOnlyCompleteSetup"
	
p1 := self createNewPackageNamed: self p1Name.
	p2 := self createNewPackageNamed: self p2Name.
	p3 := self createNewPackageNamed: self p3Name.
	
	a1 :=  self createNewClassNamed: #A1DefinedInP1 inPackage: p1.
	b1 := self createNewClassNamed: #B1DefinedInP1 inPackage: p1.
	a2 := self createNewClassNamed: #A2DefinedInP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2DefinedInP2 inPackage: p2.
	a3 := self createNewClassNamed: #A3DefinedInP3 inPackage: p3.
	
	a1 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#methodDefinedInP1).
	a1 compileSilently: 'anotherMethodDefinedInP1 ^ #anotherMethodDefinedInP1'.
	p1 addMethod: (a1>>#anotherMethodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).

	a2 class compileSilently: 'classSideMethodDefinedInP3 ^ #classSideMethodDefinedInP3'.
	p3 addMethod: (a2 class>>#classSideMethodDefinedInP3).
	

	self packageOrganizer registerPackage: p1.
	self packageOrganizer registerPackage: p2.
	self packageOrganizer registerPackage: p3.
	
	self deny: (p2 includesClass: b1).
	self assert: (p2 includesClass: b2).
	"a locally defined class not extended by other packages"
	
	self assert: (p2 includesClass: a2).  
	"a locally defined class extended by other packages"
	
	self assert: (p1 definesOrExtendsClass: a2).
	self deny: (p1 includesClass: a2).
! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 17:18'!
testFullUnregistration
	"self debug: #testFullRegistration"

	| p1 p2 p3 a1 a2 b1 b2 a3 |
	"taken from setup of RPackageReadOnlyCompleteSetup"
	
	p1 := self createNewPackageNamed: self p1Name.
	p2 := self createNewPackageNamed: self p2Name.
	p3 := self createNewPackageNamed: self p3Name.
	
	a1 :=  self createNewClassNamed: #A1DefinedInP1 inPackage: p1.
	b1 := self createNewClassNamed: #B1DefinedInP1 inPackage: p1.
	a2 := self createNewClassNamed: #A2DefinedInP2 inPackage: p2.
	b2 := self createNewClassNamed: #B2DefinedInP2 inPackage: p2.
	a3 := self createNewClassNamed: #A3DefinedInP3 inPackage: p3.
	
	a1 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a1>>#methodDefinedInP1).
	a1 compileSilently: 'anotherMethodDefinedInP1 ^ #anotherMethodDefinedInP1'.
	p1 addMethod: (a1>>#anotherMethodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP1 ^ #methodDefinedInP1'.
	p1 addMethod: (a2>>#methodDefinedInP1).
	
	a2 compileSilently: 'methodDefinedInP2 ^ #methodDefinedInP2'.
	p2 addMethod: (a2>>#methodDefinedInP2).
	
	a2 compileSilently: 'methodDefinedInP3 ^ #methodDefinedInP3'.
	p3 addMethod: (a2>>#methodDefinedInP3).

	a2 class compileSilently: 'classSideMethodDefinedInP3 ^ #classSideMethodDefinedInP3'.
	p3 addMethod: (a2 class>>#classSideMethodDefinedInP3).
	

	self packageOrganizer registerPackage: p1.
	self packageOrganizer registerPackage: p2.
	self packageOrganizer registerPackage: p3.
	
	self packageOrganizer unregisterPackage: p1.
	self packageOrganizer unregisterPackage: p2.
	self packageOrganizer unregisterPackage: p3.
	

	self deny: (self packageOrganizer includesPackageBackPointerForClass: a1).
	self deny: (self packageOrganizer includesPackageBackPointerForClass: a2).
	self deny: (self packageOrganizer includesPackageBackPointerForClass: b1).
	self deny: (self packageOrganizer includesPackageBackPointerForClass: b2).
	self deny: (self packageOrganizer includesPackageBackPointerForClass: a3).
! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:53'!
testRegisteredIsIncludedInPackageNames
	"self debug: #testRegisteredIsIncludedInPackageNames"
	| p1 p2 p3 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.

	self packageOrganizer registerPackage: p1.
	self packageOrganizer registerPackage: p2.
	self packageOrganizer registerPackage: p3.
	self assert: self packageOrganizer packageNames size = 4.
	self assert: (self packageOrganizer includesPackage: p1). 
	self assert: (self packageOrganizer includesPackageNamed: p1 name). 
	{p1 . p2 . p3} do: [:each | self assert:  (self packageOrganizer packageNames includes: each name)]

! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 16:25'!
testRegisteredIsThere
	"self debug: #testRegisteredIsThere"

	| p1 p2 p3 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.

	self packageOrganizer basicRegisterPackage: p1.
	self packageOrganizer basicRegisterPackage: p2.
	self packageOrganizer basicRegisterPackage: p3.
	self assert: self packageOrganizer packageNames size = 4.
	
	{p1 . p2 . p3} do: [:each | 
		self assert:  (self packageOrganizer packageNames includes: each name)]! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 17:10'!
testRegisteredNumberOfPackageIsOk
	"self debug: #testRegisteredNumberOfPackageIsOk"

	| p1 p2 p3 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.

	self packageOrganizer basicRegisterPackage: p1.
	self packageOrganizer basicRegisterPackage: p2.
	self packageOrganizer basicRegisterPackage: p3.
	self assert: self packageOrganizer packageNames size = 4.
	self packageOrganizer basicUnregisterPackage: p3.
	self assert: self packageOrganizer packageNames size = 3.! !

!RPackageOrganizerTest methodsFor: 'tests extending' stamp: 'StephaneDucasse 4/24/2011 17:18'!
testRegistrationExtendingPackages
	"self debug: #testRegistrationExtendingPackages"

	| p |
	self assert: (self packageOrganizer extendingPackagesOf: Quadrangle) isEmpty.
	p := self pointRectangleInGraphElement.
	(self packageOrganizer
					registerExtendingPackage:  p
					forClass: Quadrangle).
	self deny: (self packageOrganizer extendingPackagesOf: Quadrangle) isEmpty.
	self assert: (self packageOrganizer extendingPackagesOf: Quadrangle) anyOne name = #GraphElement.
	! !

!RPackageOrganizerTest methodsFor: 'tests' stamp: 'cyrilledelaunay 5/30/2011 17:19'!
testUnregisterBasedOnNames
	"self debug: #testUnregisterBasedOnNames"

	| p1 p2 p3 |
	p1 := self createNewPackageNamed: 'P1'.
	p2 := self createNewPackageNamed: 'P2'.
	p3 := self createNewPackageNamed: 'P3'.

	self packageOrganizer basicRegisterPackage: p1.
	self packageOrganizer basicRegisterPackage: p2.
	self packageOrganizer basicRegisterPackage: p3.
	self assert: self packageOrganizer packageNames size = 4.

	{p1 . p2 . p3} do: [:each | 
		(self packageOrganizer basicUnregisterPackageNamed: each name).
		self deny:  (self packageOrganizer packageNames includes: each name)]! !

!RPackageOrganizerTest methodsFor: 'tests extending' stamp: '2011-01-31T11:52:00+01:00'!
testUnregistrationExtendingPackages
	"self debug: #testUnregistrationExtendingPackages"

	| p |
	p := self pointRectangleInGraphElement.
	self packageOrganizer
		registerExtendingPackage: p
		forClass: Quadrangle.
	self deny: (self packageOrganizer extendingPackagesOf: Quadrangle) isEmpty.
	self assert: (self packageOrganizer extendingPackagesOf: Quadrangle) anyOne name = #GraphElement.
	self packageOrganizer
					unregisterExtendingPackage:  p
					forClass: Quadrangle.
	self assert: (self packageOrganizer extendingPackagesOf: Quadrangle) isEmpty.
	! !

!RPackageTestCase methodsFor: 'utils' stamp: 'StephaneDucasse 6/2/2012 19:43'!
allManagers

	^ MCWorkingCopy allManagers! !

!RPackageTestCase methodsFor: 'announcer handling' stamp: 'EstebanLorenzano 8/3/2012 14:24'!
initializeAnnouncers
	oldSystemAnnouncer := SystemAnnouncer uniqueInstance.

	SystemAnnouncer announcer: (announcerForTest := SystemAnnouncer new).! !

!RPackageTestCase methodsFor: 'accessing' stamp: 'StephaneDucasse 6/3/2012 22:44'!
organizer
	"This method will access the organizer that will temporarily swapped using the withOrganizer:do: method"
	^ self packageClass organizer! !

!RPackageTestCase methodsFor: 'accessing' stamp: 'StephaneDucasse 6/3/2012 22:44'!
packageClass 
	"returns the system class that represents Packages"
	^ RPackage ! !

!RPackageTestCase methodsFor: 'accessing' stamp: 'StephaneDucasse 6/3/2012 23:25'!
packageOrganizerClass 
	"returns the package organizer class"
	^ RPackageOrganizer! !

!RPackageTestCase methodsFor: 'announcer handling' stamp: 'EstebanLorenzano 8/3/2012 14:23'!
restoreAnnouncers
	SystemAnnouncer announcer: oldSystemAnnouncer.
! !

!RPackageTestCase methodsFor: 'running' stamp: 'GuillermoPolito 7/23/2012 13:45'!
runCase
	[
	self initializeAnnouncers.
	
	^ self packageClass 
		withOrganizer: self setupOrganizer
		do: [ 
			self resources do: [:each | each availableFor: self].
			self setUp.
			self performTest
			]
	] ensure: [ 
		self tearDown.
		self restoreAnnouncers.
		self cleanUpInstanceVariables
	]! !

!RPackageTestCase methodsFor: 'accessing' stamp: 'StephaneDucasse 6/3/2012 23:25'!
setupOrganizer
	^ self packageOrganizerClass basicNew initialize; debuggingName: 'Organizer for RPackageTest'; yourself! !

TestCase subclass: #RPackageWithDoTest
	instanceVariableNames: 'x'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!RPackageWithDoTest methodsFor: 'accessing' stamp: 'EstebanLorenzano 8/3/2012 14:24'!
announcer
	^ SystemAnnouncer uniqueInstance private! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 14:17'!
do: aBlock 

	x := 5.
	[aBlock value] ensure: [x :=3.]! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 12:26'!
doC: aBlock 
	
	x := 5.
	[aBlock value] ifCurtailed: [x :=3]! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 13:24'!
doOnDo: aBlock 
	
	x := 5.
	[aBlock value.
	self ensure] on: Error do:  [:ex | self ensure].! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 13:24'!
ensure

	x := 3! !

!RPackageWithDoTest methodsFor: 'tests' stamp: 'IgorStasenko 8/12/2011 16:37'!
info
	
	
	self announcer hasSubscriber: RPackageOrganizer default.
	Smalltalk garbageCollect.
	RPackageOrganizer allInstances collect: [:each | self announcer hasSubscriber: each ] ! !

!RPackageWithDoTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 22:49'!
packageClass
	^ RPackage! !

!RPackageWithDoTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 23:24'!
packageOrganizerClass
	^ RPackageOrganizer! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 14:19'!
testDo
	"self run: #testDo"
	
	[self do: [ Error signal]] on:Error do: [:ex|].
	"necessary else SUnit believe that the error is not handle"
	self assert: x = 3
! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 13:14'!
testDo2
	"self run: #testDo2"
	
	[self do: [ self error]
		] on: Error do: [:ex | ].
	self assert: x = 3
! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 14:20'!
testDoC
	"self run: #testDoC"
	
	[self doC: [ self error]] on: Error do: [:e|].
	"necessary for SUnit"
	self assert: x = 3
! !

!RPackageWithDoTest methodsFor: 'tests' stamp: 'StephaneDucasse 6/3/2012 23:24'!
testInvariant
	"The default invariant"
	"self run: #testInvariant"
	
	self assert: (self packageOrganizerClass default packageNames size > 50).
	"to be sure that this is real default one"
	self assert: (self announcer hasSubscriber: self packageOrganizerClass default).
	"note that this test is not precise enough because I could get the wrong one."
	Smalltalk garbageCollect.
	Smalltalk garbageCollect.
	self assert: (self packageOrganizerClass allInstances size = 1).
	
	self packageOrganizerClass allInstances collect: [:each | self announcer hasSubscriber: each ] 
	"To debug..."! !

!RPackageWithDoTest methodsFor: 'simple ensure tests' stamp: 'sd 4/24/2011 14:20'!
testOnDo
	"self run: #testOnDo"
	
	self doOnDo: [ self error].
	self assert: x = 3.
	x := 77.
	self doOnDo: [x = 21].
	self assert: x = 3
! !

!RPackageWithDoTest methodsFor: 'tests' stamp: 'EstebanLorenzano 8/3/2012 15:05'!
testWithDoIsCorrectlyReinstallingDefault
	"self debug: #testWithDoIsCorrectlyReinstallingDefault"
	
	| current empty |

	current := self packageOrganizerClass default.  
	empty := self packageOrganizerClass basicNew initialize.
	empty debuggingName: 'empty from PackageWithDoTest'.
	self packageClass 
		withOrganizer: empty
		do: [ 
			self assert: (self announcer hasSubscriber: empty).
			self deny: (self announcer hasSubscriber: current)].
	self assert: (self announcer hasSubscriber: current).
	self deny: (self announcer hasSubscriber: empty)! !

!RPackageWithDoTest methodsFor: 'tests' stamp: 'EstebanLorenzano 8/3/2012 14:51'!
testWithDoIsCorrectlyReinstallingDefaultEvenIfHalt
	"self debug: #testWithDoIsCorrectlyReinstallingDefaultEvenIfHalt"
	
	| current empty |
	current := self packageOrganizerClass default.  
	empty := self packageOrganizerClass basicNew initialize.
	[ self packageClass 
		withOrganizer: empty
		do: [ 		
			self assert: (self announcer hasSubscriber: empty).
			self deny: (self announcer hasSubscriber: current).
			self error ] ]
		on: Error do: [:ex|].
	
	self assert: (self announcer hasSubscriber: current).
	self deny: (self announcer hasSubscriber: empty)
		
		


! !

!ClassOrganizer methodsFor: '*rpackage-systemintegration' stamp: 'EstebanLorenzano 8/3/2012 15:28'!
silentlyRenameCategory: oldCatString toBe: newCatString
	| oldCat newCat oldElementsBefore oldElementsAfter index |
	oldCat := oldCatString asSymbol.
	newCat := newCatString asSymbol.
	oldElementsBefore := self listAtCategoryNamed: oldCat.
	(index := categoryArray indexOf: oldCat) = 0
		ifTrue: [^ self].	"old name not found, so no action"
	(categoryArray indexOf: newCat) > 0
		ifFalse: [
			categoryArray := categoryArray copy.  "need to change identity so smart list update will notice the change"
			categoryArray at: index put: newCat
			]
		ifTrue: [
			"if the category already exist, we move all elements inside and remove the old category"
			SystemAnnouncer uniqueInstance suspendAllWhile: [
				oldElementsBefore do: [:anElement |
					self classify: anElement under: newCat
					].
			self removeCategory:  oldCat   				
				].
			].! !

!Announcer methodsFor: '*RPackage-core' stamp: 'EstebanLorenzano 8/3/2012 15:01'!
hasSubscriber: anObject

	registry subscriptionsOf: anObject do: [:each | ^ true].
	^ false! !

!Announcer methodsFor: '*RPackage-core' stamp: 'StephaneDucasse 4/23/2011 12:43'!
subscriptions

	^ registry! !

!PackageInfo methodsFor: '*RPackage-Core' stamp: 'cyrille.delaunay 11/25/2010 16:40'!
classesAndMetaClassesNotDefinedInSubCategories

	|subCategoriesClasses|
	subCategoriesClasses := OrderedCollection new.
	self systemCategories do: [:aSymbol |
		aSymbol = self packageName asSymbol
			ifFalse: [
				subCategoriesClasses addAll: (PackageOrganizer default packageNamed: aSymbol ifAbsent: [PackageInfo new]) classesAndMetaClasses
				]
		].
	^ self classesAndMetaClasses difference: subCategoriesClasses! !

!PackageInfo methodsFor: '*RPackage-Core' stamp: 'cyrilledelaunay 2/9/2011 10:53'!
classesNotDefinedInSubCategories

	"return all classes that are defined in a category matching exactly the name of this package. Rpackage has to re-order each class in its right package. See RPackageOrganizer>>importFromPackageInfo:"
	|subCategoriesClasses|
	subCategoriesClasses := OrderedCollection new.
	self systemCategories do: [:aSymbol |
		aSymbol = self packageName asSymbol
			ifFalse: [
				subCategoriesClasses addAll: (PackageInfo named: aSymbol asString) classes
				]
		].
	^ self classes difference: subCategoriesClasses! !

!PackageInfo methodsFor: '*RPackage-Core' stamp: 'cyrille.delaunay 10/29/2010 10:31'!
coreMethodsNotDefinedInSubCategories

	^ self classesAndMetaClassesNotDefinedInSubCategories gather: [:class | self coreMethodsForClass: class]! !

!PackageInfo methodsFor: '*RPackage-Core' stamp: 'EstebanLorenzano 8/3/2012 11:08'!
extensionMethodsFromAllSystem
	^ Smalltalk allClassesAndTraits gather: [:classOrTrait | self extensionMethodsForClass: classOrTrait]! !

!PackageInfo methodsFor: '*RPackage-Core' stamp: 'cyrille.delaunay 10/29/2010 10:37'!
extensionMethodsNotDefinedInSubCategories
	^ self externalBehaviorsNotDefinedInSubCategories gather: [:classOrTrait | self extensionMethodsForClass: classOrTrait]! !

!PackageInfo methodsFor: '*RPackage-Core' stamp: 'cyrille.delaunay 10/29/2010 10:37'!
externalBehaviorsNotDefinedInSubCategories
	^self externalClassesNotDefinedInSubCategories , self externalTraitsNotDefinedInSubCategories! !

!PackageInfo methodsFor: '*RPackage-Core' stamp: 'cyrille.delaunay 10/29/2010 10:33'!
externalClassesNotDefinedInSubCategories
	| myClasses |
	myClasses := self classesAndMetaClassesNotDefinedInSubCategories.
	^ Array streamContents:
		[:s |
		ProtoObject withAllSubclassesDo:
			[:class |
			(myClasses includes: class) ifFalse: [s nextPut: class]]]! !

!PackageInfo methodsFor: '*RPackage-Core' stamp: 'cyrille.delaunay 10/29/2010 10:35'!
externalTraitsNotDefinedInSubCategories
	
	
	^ Array streamContents: [:s | | behaviors |
		behaviors := self classesAndMetaClassesNotDefinedInSubCategories.
		Smalltalk allTraits do: [:trait |
			(behaviors includes: trait) ifFalse: [s nextPut: trait].
			(behaviors includes: trait classSide) ifFalse: [s nextPut: trait classSide]]].			! !

!SystemNavigation methodsFor: '*RPackage-Core' stamp: 'StephaneDucasse 6/3/2012 23:23'!
packageFromPattern: pattern withCaption: aCaption
	"If there is a package whose name exactly given by pattern, return it.
	If there is only one package in the system whose name matches pattern, return it.
	Otherwise, put up a menu offering the names of all packages that match pattern, and return the class chosen, else nil if nothing chosen.
	This method ignores tab, space, & cr characters in the pattern"

	| toMatch potentialPackageNames packageNames exactMatch index |
	(toMatch := pattern
		copyWithoutAll:
			{(Character space).
			(Character cr).
			(Character tab)}) isEmpty
		ifTrue: [ ^ nil ].
	
	self packageOrganizerClass default packageNamed: toMatch ifAbsent: [ nil ].
	
	toMatch := (toMatch copyWithout: $.) asLowercase.
	potentialPackageNames := (self packageOrganizerClass default packages collect: [:each | each name]) asOrderedCollection.
	packageNames := pattern last = $.
		ifTrue: [ potentialPackageNames select: [ :nm | nm asLowercase = toMatch ] ]
		ifFalse: [ potentialPackageNames select: [ :n | n includesSubstring: toMatch caseSensitive: false ] ].
	packageNames isEmpty
		ifTrue: [ ^ nil ].
	exactMatch := packageNames detect: [ :each | each asLowercase = toMatch ] ifNone: [ nil ].
	index := packageNames size = 1
		ifTrue: [ 1 ]
		ifFalse: [ 
			exactMatch
				ifNil: [ UIManager default chooseFrom: packageNames lines: #() title: aCaption ]
				ifNotNil: [ 
					packageNames addFirst: exactMatch.
					UIManager default chooseFrom: packageNames lines: #(1) title: aCaption ] ].
	index = 0
		ifTrue: [ ^ nil ].
	^ self packageOrganizerClass default packageNamed: (packageNames at: index)"
	self default packageFromPattern: 'Nau' withCaption: ''
	self default packageFromPattern: 'orph' withCaption: ''
	self default packageFromPattern: 'TCompil' withCaption: ''
"! !

!SystemNavigation methodsFor: '*RPackage-Core' stamp: 'StephaneDucasse 6/3/2012 23:22'!
packageOrganizerClass
	^ RPackageOrganizer! !

!PackageOrganizer methodsFor: '*rpackage-core' stamp: 'cyrilledelaunay 1/31/2011 14:50'!
packagesDictionary

	^ packages! !

!MCPackage methodsFor: '*RPackage-SystemIntegration' stamp: 'BenjaminVanRyseghem 4/14/2011 15:57'!
correspondingRPackage

	| symbol |
	symbol := Symbol readFromString: '#', self name.
	^ RPackageOrganizer default packageNamed: symbol ifAbsent: [ nil ]! !

!TraitDescription methodsFor: '*rpackage-core' stamp: 'StephaneDucasse 6/3/2012 22:48'!
extendingPackages
	"the extending packages of a class are the packages that extend it."
	^ RPackage organizer extendingPackagesOf: self
	! !

!TraitDescription methodsFor: '*rpackage-core' stamp: 'cyrille.delaunay 11/26/2010 16:41'!
isDefinedInPackage: aPackage
	"returns true if aPackage contains the definitino of this class"
	
	^ aPackage includesClass: self.
	! !

!TraitDescription methodsFor: '*rpackage-core' stamp: 'cyrille.delaunay 11/26/2010 16:41'!
isExtended

	^ self extendingPackages isEmpty! !

!TraitDescription methodsFor: '*rpackage-core' stamp: 'cyrille.delaunay 11/26/2010 16:41'!
isExtendedInPackage: aPackage
	"returns true if aPackage defines an extension to this class"
	^ aPackage extendsClass: self.
	! !

!TraitDescription methodsFor: '*rpackage-core' stamp: 'StephaneDucasse 6/3/2012 22:48'!
package
	^ RPackage organizer packageOf: self.	! !

!TraitDescription methodsFor: '*rpackage-core' stamp: 'cyrille.delaunay 11/26/2010 16:41'!
packageFromOrganizer: anOrganizer
	"returns the package that defines this class"
	^ anOrganizer packageOf: self.
	! !

!TraitDescription methodsFor: '*rpackage-core' stamp: 'StephaneDucasse 6/3/2012 22:48'!
packageOrganizer
	^ RPackage organizer ! !

!TraitDescription methodsFor: '*rpackage-core' stamp: 'cyrille.delaunay 11/26/2010 16:41'!
packages
	"the extending packages of a class are the packages that extend it."
	
	^  self extendingPackages asSet copy add: self package; yourself! !

!CompiledMethod methodsFor: '*rpackage-core' stamp: 'EstebanLorenzano 6/1/2012 16:48'!
handleUnpackaged: anRPackageOrganizer
	| tmpTrait |
	tmpTrait := self methodClass traitComposition traitProvidingSelector: self selector.
	
	tmpTrait isNil ifFalse: [
		(tmpTrait packages select: [ :aRPackage | 
			aRPackage includesSelector: self selector ofClass: tmpTrait ]) isEmpty 
				ifFalse: [ ^ self ]].
 
	self error: 'Yes... method is unpackaged and I don''t know what to do with this.'.
"	self halt.
	self category isNil
		ifTrue: [ Error signal ].
		
	anRPackageOrganizer
		systemMethodAddedActionFrom:
			(AddedEvent
				method: self
				selector: self selector
				protocol: self category
				class: self methodClass) asSystemAnnouncement"! !

!CompiledMethod methodsFor: '*rpackage-core' stamp: 'tg 3/13/2010 15:13'!
isDefinedInPackage: anRPackage
	^ anRPackage includesDefinedSelector: self selector ofClass: self methodClass! !

!CompiledMethod methodsFor: '*rpackage-core' stamp: 'tg 3/13/2010 13:50'!
isExtensionInPackage: anRPackage
	^ anRPackage includesExtensionSelector: self selector ofClass: self methodClass! !

!CompiledMethod methodsFor: '*rpackage-core' stamp: 'CamilloBruni 4/27/2012 17:43'!
isProvidedByATrait

	^ self origin isTrait
	! !

!CompiledMethod methodsFor: '*rpackage-core' stamp: 'CamilloBruni 4/27/2012 17:07'!
package
	^ self packageFromOrganizer: RPackage organizer! !

!CompiledMethod methodsFor: '*rpackage-core' stamp: 'GuillermoPolito 6/3/2012 01:15'!
packageFromOrganizer: anRPackageOrganizer
	"This method returns the package this method belongs to.  It takes into account classes and traits.  If the method is in no package, returns nil by now"
	^self origin packages detect: [:each | each includesSelector: self selector ofClassName: self origin originalName ] ifNone: [ nil ].! !

!TPureBehavior methodsFor: '*Rpackage-Core' stamp: 'GuillermoPolito 5/29/2012 13:09'!
originalName
	^self isObsolete 
		ifTrue: [ (self name copyFrom:   'AnObsolete' size + 1 to: self name size ) asSymbol ]
		ifFalse:  [  self name asSymbol ].! !

Announcement subclass: #RPackageAnnouncement
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Core'!

!RPackageAnnouncement class methodsFor: 'instance creation' stamp: 'BenjaminVanRyseghem 4/1/2011 16:14'!
to: aPackage

	^ self new package: aPackage! !

!RPackageAnnouncement methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/1/2011 16:14'!
package

	^ package! !

!RPackageAnnouncement methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/1/2011 16:14'!
package: anObject

	package := anObject! !

RPackageAnnouncement subclass: #RPackageCreated
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Core'!

!RPackageCreated commentStamp: '<historical>' prior: 0!
I am a public announcement sent when a new RPackage is created!

RPackageAnnouncement subclass: #RPackageRenamed
	instanceVariableNames: 'oldName newName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Core'!

!RPackageRenamed commentStamp: '<historical>' prior: 0!
I am a public announcement sent when a new RPackage is renamed!

!RPackageRenamed class methodsFor: 'as yet unclassified' stamp: 'BenjaminVanRyseghem 4/1/2011 16:24'!
to: aPackage oldName: aSymbol newName: anotherSymbol

	^ (super to: aPackage) 
		oldName: aSymbol;
		newName: anotherSymbol;
		yourself! !

!RPackageRenamed methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/1/2011 16:22'!
newName

	^ newName! !

!RPackageRenamed methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/1/2011 16:22'!
newName: anObject

	newName := anObject! !

!RPackageRenamed methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/1/2011 16:22'!
oldName

	^ oldName! !

!RPackageRenamed methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/1/2011 16:22'!
oldName: anObject

	oldName := anObject! !

RPackageAnnouncement subclass: #RPackageUnregistered
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Core'!

!RPackageUnregistered commentStamp: '<historical>' prior: 0!
I am a public announcement sent when a new RPackage is unregistred ( kind  of removed from the system )!

!MCPackageManager class methodsFor: '*rpackage-systemintegration' stamp: 'CamilleTeruel 7/29/2012 18:45'!
unregisterForNotifications
	SystemAnnouncer uniqueInstance unsubscribe: self! !

Object subclass: #PackageChecker
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-SystemIntegration'!

!PackageChecker methodsFor: 'check' stamp: 'StephaneDucasse 7/30/2010 14:03'!
check
	"self new check"
	
	"only work for top level package overlapping.
	Foo and Foo-Core, but not Foo-Core and Foo-Core-Test"
	| packageNames dict overlappingPackages |
	overlappingPackages := OrderedCollection new.
	packageNames := MCWorkingCopy allManagers collect: [:each | each packageName].
	dict := packageNames groupedBy: [:each | each copyUpTo: $-].
	dict copy keysAndValuesDo: [:k :v | v size = 1 ifTrue: [ dict removeKey: k]].
	dict keysAndValuesDo: [:k :v | (v includes: k) 
									ifTrue: [
										overlappingPackages add: v.
										Warning signal: 'Overlapping packages: ', v printString]].
	^ overlappingPackages ! !

Object subclass: #RPackage
	instanceVariableNames: 'classDefinedSelectors metaclassDefinedSelectors classExtensionSelectors metaclassExtensionSelectors classes name classTags'
	classVariableNames: 'PackageGlobalOrganizer'
	poolDictionaries: ''
	category: 'RPackage-Core'!

!RPackage commentStamp: 'StephaneDucasse 7/25/2011 21:55' prior: 0!
A RPackage is a new implementation of package. Note that it does not touch classes but it is just a layer on top of classes therefore removing a method from a package does not change the underlying class. 


Instance Variables
	classDefinedSelectors:		Dictionary
	classExtensionSelectors:		Dictionary
	metaclassDefinedSelectors:		Dictionary
	metaclassExtensionSelectors:		Dictionary
	packageName:		String
	classes: OrderedCollection of Symbols
	classTags: is a mapping from tags to classNames

The reason we use four dictionaries is that this way we only store #Point in both as the class and the metaclass are involved. We do not have to with Point_class problem when comparing defined and extended classes. The idea is taken from the RBSelectorEnvironment. 					
		
Class Invariant one:
	Classes should not contain metaclass name, but only class names
	
	

Implementation notes 
====================
This class went over 3 internal representations implementation. 
	- first: 	a list of class + two dictionaries: class * methods
	This was not good since we add to go all the time over the list of classes.
	- second: 4 dictionaries class * selectors 
	This was not good since we want to have defined classes without methods. 
	- third: 4 dictionaries + definedClasses

Originally I wanted to avoid to have a defined class list and I wanted to avoid to have to declare the class as defined. But this is not really good since
	- we will want to know if a class definition (without method for example is defined in a given package)
	- second this is easier to hook the packageOf: behavior (we register the package class when the class is 	added to the package).

defined classes information is redundant with the dictionary keys of defined methods but we would have to check and register the class to the packageOrganizer the first time a method is defined then also check on remove to unregister the class from the packageOrganizer.

Adding a method does not define the class as a defined package class. This has to be done explictly. The reason for this choice is that a class should register to the packageOrganizer and that I do not want to do it each time a method is added and I do not want to test it each time a method is added. Now this is done only when the class is declared as defined. 
We could also give the complete freedom to the client to register the class but I thought it was a good compromise. 
	
	
ClassTag are tags that can be associated to classes. They help user organizing their class internal. 
So that we can have a package infrastructure as follows:
	Package1
		ClassA
		ClassB
	in case there is no tags associated to the package
	or
	Package2	
		Tag1
			ClassA
			ClassB
		Tag2
			ClassC
			ClassD
			ClassE
			ClassA		
	
Todo
====
	Next: 
	- finish 
	- build up a synchronizer that import PackageInfo.
	

	

	
!

RPackage subclass: #MCMockRPackage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Tests'!

!MCMockRPackage commentStamp: 'cyrilledelaunay 1/24/2011 16:16' prior: 0!
This class should be used instead of MCMockPackageInfo in the monticello tests!

!MCMockRPackage class methodsFor: 'initialize-release' stamp: 'StephaneDucasse 6/3/2012 23:29'!
initialize
	[self packageOrganizerClass default registerPackage: self new ] on: MessageNotUnderstood do: []! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:33:00+01:00'!
classNames
	^ #(	MCMockClassA
		 	MCMockASubclass
			MCMockClassB
			MCMockClassD
			MCMockClassE
			MCMockClassF
			MCMockClassG
			MCMockClassH
			MCMockClassI
		)! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:33:00+01:00'!
classes
	^ self classNames select: [ :tmpName | Smalltalk globals hasClassNamed: tmpName ] thenCollect: [ :tmpName | Smalltalk globals at: tmpName ]! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:34:00+01:00'!
includesClass: aClass
	^self classes includes: aClass! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:34:00+01:00'!
includesSystemCategory: categoryName
	^self systemCategories anySatisfy: [:cat | cat sameAs: categoryName]! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:50:00+01:00'!
name

	^ self packageName! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: '2011-01-24T15:34:00+01:00'!
packageName
	^ 'MonticelloMocks'! !

!MCMockRPackage methodsFor: 'as yet unclassified' stamp: 'GuillermoPolito 7/4/2012 21:07'!
systemCategories
	^ Array with: 'MonticelloMocks'! !

!RPackage class methodsFor: 'constants' stamp: 'StephaneDucasse 4/29/2011 21:04'!
defaultPackageName
	^ #'_UnpackagedPackage'! !

!RPackage class methodsFor: 'help' stamp: 'StephaneDucasse 6/3/2012 23:28'!
help
	<wikiStyleHelp: 'RPackage'>	
	|stream|
	stream := String new writeStream.
	stream 
		nextPut: $!!;
		nextPutAll: self name asString;
		cr;
		nextPutAll: self comment;
		cr;
		nextPut: $!!;
		nextPutAll: self packageOrganizerClass name asString;
		cr;
		nextPutAll: self packageOrganizerClass comment.		
	^stream contents
	
	! !

!RPackage class methodsFor: 'class initialization' stamp: 'StephaneDucasse 6/3/2012 23:28'!
initialize
	"self initialize"
	
	super initialize.
	self organizer: self packageOrganizerClass default.
! !

!RPackage class methodsFor: 'instance creation' stamp: 'StephaneDucasse 4/13/2011 22:43'!
named: aString

	| newPackage |
	newPackage := self new name: aString ;yourself.
	^ newPackage! !

!RPackage class methodsFor: 'protected only for tests' stamp: 'EstebanLorenzano 7/27/2012 20:30'!
organizer
	^ PackageGlobalOrganizer ifNil: [ RPackageOrganizer default ].! !

!RPackage class methodsFor: 'protected only for tests' stamp: 'cyrille.delaunay 10/29/2010 14:31'!
organizer: aPackageOrganizer

	PackageGlobalOrganizer := aPackageOrganizer! !

!RPackage class methodsFor: 'class initialization' stamp: 'StephaneDucasse 6/3/2012 23:27'!
packageOrganizerClass
	^ RPackageOrganizer
! !

!RPackage class methodsFor: 'protected only for tests' stamp: 'StephaneDucasse 4/24/2011 16:45'!
withOrganizer: aNewOrganizer do: aBlock
	"Perform an action locally to aNewOrganizer. Does not impact any other organizers."
	
	| old |
	[ old := self organizer.
	old unregister.
	self organizer: aNewOrganizer.
	aNewOrganizer register.
	aBlock cull: aNewOrganizer] ensure: [ 
		self organizer: old. 
		old register.
		aNewOrganizer unregister] ! !

!RPackage methodsFor: 'class addition' stamp: 'DamienPollet 10/1/2010 11:37'!
addClassDefinition: aClass
	"Add only the class definition of aClass, as a class defined by the receiver. The term classdefinition denotes the fact that we do not treat its methods. aClass methods are not added to the package. aClass can be either a class or a metaclass"
	
	self addClassDefinitionName: aClass theNonMetaClass name.
	! !

!RPackage methodsFor: 'class tags' stamp: 'CamilleTeruel 7/16/2012 16:46'!
addClassDefinition: aClass toClassTag: aSymbol
	"Tags the class aClass with the tag aSymbol"
	
	self addClassDefinitionName: aClass name toClassTag: aSymbol! !

!RPackage methodsFor: 'class addition' stamp: 'cyrilledelaunay 2/22/2011 13:32'!
addClassDefinitionName: aClassName
	"aClassName should only be a class (and not a metaclass name)"

	| aClassNameSymbol |
	('* class' match: aClassName)
		ifTrue: [ ^ self error: 'no metaclass name' ].
	aClassNameSymbol := aClassName asSymbol.
	(classes includes: aClassNameSymbol)
		ifTrue: [ ^ self ].
	classes add: aClassNameSymbol.
	self extendedMethodsShouldBecomeDefinedWhenAddingClassName: aClassNameSymbol.
	self registerClassName: aClassNameSymbol! !

!RPackage methodsFor: 'class tags' stamp: 'StephaneDucasse 7/25/2011 23:39'!
addClassDefinitionName: aClassName toClassTag: aSymbol
	"Tags the class aClass with the tag aSymbol"
	
	| res |
	res := classTags at: aSymbol ifAbsent: [nil].
	res isNil
		ifTrue: [classTags at: aSymbol put: (Set new add: aClassName; yourself)]
		ifFalse: [res add: aClassName].
	! !

!RPackage methodsFor: 'class tags' stamp: 'StephaneDucasse 7/26/2011 00:20'!
addClassTag: aSymbol
	"Add the class tag from the receiver, if already added do nothing."
	
	classTags at: aSymbol ifAbsentPut: [Set new] ! !

!RPackage methodsFor: 'compiled method handling' stamp: 'CamilloBruni 7/11/2012 09:27'!
addMethod: aCompiledMethod 
	"Add the method to the receiver as a defined method if the class is  defined in it, else as an extension."

	| methodClass |
	methodClass := aCompiledMethod methodClass. 
	(self includesClass: methodClass )
		ifFalse: [methodClass isMeta
					ifTrue: [(metaclassExtensionSelectors 
								at: methodClass theNonMetaClass name  
								ifAbsentPut: [Set new]) add: aCompiledMethod selector.]
					ifFalse: [(classExtensionSelectors 
								at: methodClass name 
								ifAbsentPut: [Set new]) add: aCompiledMethod selector].
				"we added a method extension so the receiver is an extending package of the class"
				self organizer registerExtendingPackage: self forClass: methodClass]
		ifTrue: [methodClass isMeta
					ifTrue: [(metaclassDefinedSelectors 
								at: methodClass theNonMetaClass name  
								ifAbsentPut: [Set new]) add: aCompiledMethod selector]
					ifFalse: [(classDefinedSelectors 
								at: methodClass name 
								ifAbsentPut: [Set new]) add: aCompiledMethod selector]].	
	^ aCompiledMethod.! !

!RPackage methodsFor: 'selector handling' stamp: 'StephaneDucasse 4/20/2010 22:56'!
addSelector: aSelector ofClassName: aClassName
	"Add the method to the receiver. If the class is not locally defined in that package then the method is defined as a method extension: ie extending another package. Note that this method does not add the method to the class, it just records in the package that the method is packaged."
	
	( self includesClassNamed: aClassName)
		ifFalse: [(classExtensionSelectors at: aClassName asSymbol ifAbsentPut: [Set new]) add: aSelector]
		ifTrue: [(classDefinedSelectors at: aClassName asSymbol ifAbsentPut: [Set new]) add: aSelector].
	^ aSelector.! !

!RPackage methodsFor: 'selector handling' stamp: 'StephaneDucasse 4/20/2010 22:56'!
addSelector: aSelector ofMetaclassName: aClassName
	"Add the method to the receiver. If the class is not locally defined in that package then the method is defined as a method extension: ie extending another package. Note that this method does not add the method to the class, it just records in the package that the method is packaged. aClassName is the sole instance class name and not its metaclass one: i.e. adding Point class>>new is done as addSelector: #new ofMetaclassName: #Point"
	
	( self includesClassNamed: aClassName) 
		ifFalse: [(metaclassExtensionSelectors at: aClassName asSymbol ifAbsentPut: [Set new]) add: aSelector]
		ifTrue: [(metaclassDefinedSelectors at: aClassName asSymbol ifAbsentPut: [Set new]) add: aSelector].
	^ aSelector.! !

!RPackage methodsFor: 'system compatibility' stamp: 'StephaneDucasse 4/27/2011 20:16'!
allDefinedClasses
	
	"this method should return the same thing than PackageInfo >> classes. 
	This raised another problem: When asking a PackageInfo for its classes , it returns all classes included in this packageInfo and in all sub-categories. We should provide such accessor to stay compatible.
	(RPackageOrganizer default packageNamed: 'HelpSystem-Core' asSymbol) allDefinedClasses.
	(PackageInfo named: 'HelpSystem-Core' asSymbol) classes.
	(PackageInfo named: 'HelpSystem-Core' asSymbol) classes reject: [:each | (RPackageOrganizer default packageNamed: 'HelpSystem-Core' asSymbol) allDefinedClasses includes: each]. 	(RPackageOrganizer default packageNamed: 'CollectionsTests' asSymbol) allDefinedClasses sort: [:a :b | a name < b name].
	(PackageInfo named: 'CollectionsTests' asSymbol) classes.
	"
	|tmpClasses|
	self flag: #stef. "no sender"
	tmpClasses := OrderedCollection new.
	self systemSubPackages do: [:tmpPackage |
		tmpClasses addAll: tmpPackage definedClasses.
		].
	^ tmpClasses addAll: self definedClasses; yourself! !

!RPackage methodsFor: 'system compatibility' stamp: 'MarianoMartinezPeck 8/3/2012 12:02'!
allDefinedExtensionMethods
	
	"this method should return the same thing than PackageInfo >> extensionMethods. 
	This raised another problem: When asking a PackageInfo for its extension methods , it returns all extension methods included in this packageInfo and in all sub-categories. We should provide such accessor to stay compatible."
	| tmpMethods |
	tmpMethods := OrderedCollection new.
	self systemSubPackages do: [:tmpPackage |
		tmpMethods addAll: tmpPackage extensionMethods.
		].
	^ tmpMethods addAll: self extensionMethods; yourself! !

!RPackage methodsFor: 'system compatibility' stamp: 'StephaneDucasse 4/27/2011 20:16'!
allMethodReferences
	
	"this method should return the same thing that PackageInfo >> methods. 
	This raised another problem: When asking a PackageInfo for its methods (it's the same for classes), it returns all methods included in this packageInfo and in all sub-categories. We should privide such accessor to stay compatible.
	(RPackageOrganizer default packageNamed: 'HelpSystem-Core' asSymbol) allMethodReferences.
	(PackageInfo named: 'HelpSystem-Core' asSymbol) methods
	"
	"(RPackageOrganizer default packageNamed: 'Settings-System' asSymbol) allMethodReferences.
	(PackageInfo named: 'Settings-System' asSymbol) methods"
	"
	(RPackageOrganizer default packageNamed: 'CollectionsTests' asSymbol) allMethodReferences.
	(PackageInfo named: 'CollectionsTests' asSymbol) methods
	"
	|tmpMethods|
	self flag: #stef. "no senders"
	tmpMethods := OrderedCollection new.
	self systemSubPackages do: [:tmpPackage |
		tmpMethods addAll: tmpPackage methodReferences.
		].
	^ tmpMethods addAll: self methodReferences; yourself! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:33'!
allOverriddenMethodsDo: aBlock
	"Evaluates aBlock with all the overridden methods in the system"
	^ ProtoObject withAllSubclassesDo: [:class | 
		self overriddenMethodsInClass: class do: aBlock]
! !

!RPackage methodsFor: 'selector handling' stamp: 'GuillermoPolito 5/29/2012 14:04'!
basicRemoveSelector: aSelector ofClassName: aClassName
	"Remove the method in the package but does not propagate to the class itself.  Note that this method does not remove the method from the class, it just records in the package that the method is not in the package anymore."
	
	( self includesClassNamed: aClassName)
		ifFalse: [(classExtensionSelectors  at: aClassName ifAbsent: [ ^ Set new]) remove: aSelector.]
		ifTrue: [(classDefinedSelectors  at: aClassName ifAbsent: [ ^ Set new]) remove: aSelector.].
	
	! !

!RPackage methodsFor: 'selector handling' stamp: 'GuillermoPolito 5/29/2012 14:04'!
basicRemoveSelector: aSelector ofMetaclassName: aClassName
	"Remove the method in the package. Note that this method does not remove the method from the class, it just records in the package that the method is not in the package anymore. aClassName is the sole instance class name and not its metaclass one: i.e. adding Point class>>new is done as removeSelector: #new ofMetaclassName: #Point"
	
	( self includesClassNamed: aClassName)
		ifFalse: [(metaclassExtensionSelectors  at: aClassName ifAbsent: [ ^ Set new]) remove: aSelector.]
		ifTrue: [(metaclassDefinedSelectors  at: aClassName ifAbsent: [ ^ Set new]) remove: aSelector.].
	
	! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:33'!
category: categoryName matches: prefix
	"self default category: 'Compression-Archives' matches: 'Compression'"
	"self default category: 'Compression' matches: 'Compression-Archives'"
	"self default category: 'Compression' matches: 'Compression'"
	"self default category: 'Compression-Arh' matches: 'Compression'"
	| prefixSize catSize |
	categoryName ifNil: [ ^false ].
	catSize := categoryName size.
	prefixSize := prefix size.
	catSize < prefixSize ifTrue: [ ^false ].
	(categoryName findString: prefix startingAt: 1 caseSensitive: false) = 1
		ifFalse: [ ^false ].
	^(categoryName at: prefix size + 1 ifAbsent: [ ^true ]) = $-! !

!RPackage methodsFor: 'system compatibility' stamp: 'cyrilledelaunay 2/2/2011 16:07'!
changeRecordForOverriddenMethod: aMethodReference
	| sourceFilesCopy method position |
	method := aMethodReference actualClass compiledMethodAt: aMethodReference methodSymbol.
	position := method filePosition.
	sourceFilesCopy := SourceFiles
		collect: [ :x | 
			x isNil
				ifTrue: [ nil ]
				ifFalse: [ x readOnlyCopy ] ].
	[ 
	| file prevPos prevFileIndex chunk stamp methodCategory tokens |
	method fileIndex == 0
		ifTrue: [ ^ nil ].
	file := sourceFilesCopy at: method fileIndex.
	[ position notNil & file notNil ]
		whileTrue: [ 
			file position: (0 max: position - 150).	"Skip back to before the preamble"
			[ file position < (position - 1) ] whileTrue: [ chunk := file nextChunk ].	"then pick it up from the front"	"Preamble is likely a linked method preamble, if we're in
			a changes file (not the sources file).  Try to parse it
			for prior source position and file index"
			prevPos := nil.
			stamp := ''.
			(chunk findString: 'methodsFor:' startingAt: 1) > 0
				ifTrue: [ tokens := Scanner new scanTokens: chunk ]
				ifFalse: [ tokens := Array new	"ie cant be back ref" ].
			((tokens size between: 7 and: 8) and: [ (tokens at: tokens size - 5) = #methodsFor: ])
				ifTrue: [ 
					(tokens at: tokens size - 3) = #stamp:
						ifTrue: [ 
							"New format gives change stamp and unified prior pointer"
							stamp := tokens at: tokens size - 2.
							prevPos := tokens last.
							prevFileIndex := sourceFilesCopy fileIndexFromSourcePointer: prevPos.
							prevPos := sourceFilesCopy filePositionFromSourcePointer: prevPos ]
						ifFalse: [ 
							"Old format gives no stamp; prior pointer in two parts"
							prevPos := tokens at: tokens size - 2.
							prevFileIndex := tokens last ].
					(prevPos = 0 or: [ prevFileIndex = 0 ])
						ifTrue: [ prevPos := nil ] ].
			((tokens size between: 5 and: 6) and: [ (tokens at: tokens size - 3) = #methodsFor: ])
				ifTrue: [ 
					(tokens at: tokens size - 1) = #stamp:
						ifTrue: [ 
							"New format gives change stamp and unified prior pointer"
							stamp := tokens at: tokens size ] ].
			methodCategory := tokens after: #methodsFor: ifAbsent: [ 'as yet unclassifed' ].
			(self includesMethodCategory: methodCategory ofClass: aMethodReference actualClass)
				ifTrue: [ 
					methodCategory = (Smalltalk globals at: #Categorizer ifAbsent: [ Smalltalk globals at: #ClassOrganizer ]) default
						ifTrue: [ methodCategory := methodCategory , ' ' ].
					^ ChangeRecord new
						file: file
						position: position
						type: #method
						class: aMethodReference classSymbol
						category: methodCategory
						meta: aMethodReference classIsMeta
						stamp: stamp ].
			position := prevPos.
			prevPos notNil
				ifTrue: [ file := sourceFilesCopy at: prevFileIndex ] ].
	^ nil ]
		ensure: [ 
			sourceFilesCopy
				do: [ :x | 
					x notNil
						ifTrue: [ x close ] ] ]! !

!RPackage methodsFor: 'slices' stamp: 'StephaneDucasse 3/11/2010 18:46'!
classDefinedSlicesDo: aBlock
	"This method iterates over the defined class and their associated selectors. a slice is a class * list of selectors. aBlock will be applied to all the extensions slices of the receiver. aBlok first argument is the class and the second argument a list of method selectors"
	
	classDefinedSelectors keysAndValuesDo: aBlock! !

!RPackage methodsFor: 'slices' stamp: 'DamienPollet 10/1/2010 11:48'!
classExtensionSlicesDo: aBlock
	"This method iterates over the class extensions and their associated selectors. A slice is a class * list of selectors. aBlock will be applied to all the extensions slices of the receiver. aBlock first argument is the class and the second argument a list of method selectors"
	
	classExtensionSelectors keysAndValuesDo: aBlock! !

!RPackage methodsFor: 'slices' stamp: 'StephaneDucasse 3/11/2010 18:40'!
classNamesAndExtensionSelectorsDo: aBlock
	"Iterate over the extended methods grouped by classes and apply the argument.
	The block will be passed a class name and each individual selectors.
	Only classes with methods are paired with their methods"
	
	classExtensionSelectors keysAndValuesDo: [ :classSymbol :methods |
			methods do: [ :sel |  aBlock value: classSymbol	value: sel]].
	
	metaclassExtensionSelectors keysAndValuesDo: [ :classSymbol :methods |
			methods do: [ :sel |  aBlock 
									value: (classSymbol, '_class') asSymbol
									value: sel]].	! !

!RPackage methodsFor: 'all accessing' stamp: 'sd 4/25/2010 16:03'!
classes
	"Return all the classes"
	
	^ self definedClasses, self extendedClasses 
	
	! !

!RPackage methodsFor: 'system compatibility' stamp: 'StephaneDucasse 4/27/2011 11:35'!
classesAndMetaClasses
	"Return a Set with all classes and metaclasses belonging to this package"
	self flag: #stef. "only used by goferCleanUp"
	^ OrderedCollection new
		addAll: self definedClasses;
		addAll: (self definedClasses collect: [:each | each classSide]);
		yourself.! !

!RPackage methodsFor: 'class tags' stamp: 'StephaneDucasse 7/25/2011 22:20'!
classesForClassTag: aSymbol
	"Returns the classes tagged using aSymbol"
	
	^ classTags at: aSymbol ifAbsent: [Array new]! !

!RPackage methodsFor: 'system compatibility' stamp: 'StephaneDucasse 4/27/2011 11:35'!
coreCategoriesForClass: aClass

	self flag: #stef. "only used by goferCleanUp"
	^ aClass organization categories reject: [ :cat | self isForeignClassExtension: cat ]! !

!RPackage methodsFor: 'all accessing' stamp: 'StephaneDucasse 3/11/2010 15:17'!
definedClassNames 
	"Return the class names having methods defined in the receiver."
	
	^ classes! !

!RPackage methodsFor: 'all accessing' stamp: 'CamilloBruni 4/27/2012 13:26'!
definedClasses 
	| definedClasses |
	definedClasses := Set new.
	classes do: [:each | 
		Smalltalk globals 
			at: each 
			ifPresent: [:aClass| definedClasses add: aClass ]].
	^ definedClasses
	! !

!RPackage methodsFor: 'iteration' stamp: 'StephaneDucasse 2/21/2010 17:25'!
definedClassesDo: aBlock

	classDefinedSelectors keysDo: aBlock.
	metaclassDefinedSelectors keysDo: aBlock.! !

!RPackage methodsFor: 'private' stamp: 'StephaneDucasse 4/25/2011 12:26'!
definedMethodsBecomeExtendedForClass: aClassName
	"the package may contain defined methods and their class is removed to the receiver. The status of such methods should now be extended"
	"Precondition: aClassName is in the defined list"
	
	| ext |
	(classDefinedSelectors keys includes: aClassName) ifFalse: [^ self].
	ext := classDefinedSelectors at: aClassName.
	classDefinedSelectors removeKey: aClassName ifAbsent: [self reportBogusBehaviorOf:   #definedMethodsBecomeExtendedForClass: ].
	(classExtensionSelectors keys includes: aClassName) ifTrue: [self error: aClassName , ' should not be defined in extension'.]. "we should remove this check later"
	classExtensionSelectors at: aClassName put: ext.! !

!RPackage methodsFor: 'private' stamp: 'StephaneDucasse 4/25/2011 12:27'!
definedMethodsBecomeExtendedForMetaclass: aClassName
	"the package may contain defined methods and their class is removed to the receiver. The status of such methods should now be extended"
	"Precondition: aClassName is in the defined list"
	
	| ext |
	(metaclassDefinedSelectors keys includes: aClassName) ifFalse: [^ self].
	ext := metaclassDefinedSelectors at: aClassName.
	metaclassDefinedSelectors removeKey: aClassName ifAbsent: [self reportBogusBehaviorOf: #definedMethodsBecomeExtendedForMetaclass:].
	(metaclassExtensionSelectors keys includes: aClassName) ifTrue: [self error: aClassName , ' should not be defined in extension'.]. "we should remove this check later"
	metaclassDefinedSelectors at: aClassName put: ext.! !

!RPackage methodsFor: 'accessing' stamp: 'StephaneDucasse 4/13/2011 22:17'!
definedMethodsForClass: aClass

	^ (self definedSelectorsForClass: aClass) asOrderedCollection collect: [ :each | aClass >> each ]! !

!RPackage methodsFor: 'private' stamp: 'sd 4/25/2010 15:41'!
definedMethodsShouldBecomeExtensionWhenRemovingClass: aClassName
	"the package may contain defined methods and their class is removed from the receiver. The status of such methods should now be extensions"
	
	self definedMethodsBecomeExtendedForClass: aClassName.
	self definedMethodsBecomeExtendedForMetaclass: aClassName.! !

!RPackage methodsFor: 'accessing' stamp: 'GuillermoPolito 8/5/2012 13:33'!
definedSelectorsForClass: aClass

	^ aClass isMeta
		ifTrue: [ metaclassDefinedSelectors at: aClass theNonMetaClass originalName ifAbsent: [ #() ] ]
		ifFalse: [ classDefinedSelectors at: aClass originalName ifAbsent: [ #() ] ]! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 4/20/2010 22:22'!
definesClass: aClass
	"Returns true if the class, aClass, is one of the locally defined classes"
	"should be probably removed since this is the same as includesClass: or the inverse"
	^ self includesClass: aClass! !

!RPackage methodsFor: 'testing' stamp: 'sd 4/25/2010 16:06'!
definesOrExtendsClass: aClass
	"Returns true whether the class, aClass, is one of the locally defined classes of the receiver or 
	if the receiver extends such class (that is defined in another package)"
	
	| canonizedName |
	canonizedName := aClass theNonMetaClass name.
	^ (classes includes: canonizedName) 
		or: [self extendedClassNames includes:  canonizedName]
! !

!RPackage methodsFor: 'accessing' stamp: 'sd 4/25/2010 16:06'!
extendedClassNames 
	"Return the name of the classes which are extended by the receiver package. if a metaclass is extended, just get its sole instance class name."
	
	^ classExtensionSelectors keys union: metaclassExtensionSelectors keys! !

!RPackage methodsFor: 'accessing' stamp: 'CamilloBruni 5/23/2012 17:08'!
extendedClasses 
	"Return classes and metaclasses that are extended in the receiver"
	^ (metaclassExtensionSelectors keys 
		select: [ :each| Smalltalk globals includesKey: each ]
		thenCollect: [:each | (Smalltalk globals at: each) class])
			union:  (classExtensionSelectors keys 
						select: [ :each| Smalltalk globals includesKey: each ]
						thenCollect: [:each | Smalltalk globals at: each])! !

!RPackage methodsFor: 'private' stamp: 'StephaneDucasse 4/25/2011 12:26'!
extendedMethodsBecomeDefinedForClass: aClassName
	"the package may contain extension methods and their class is added to the receiver. The status of such methods should now be defined"
	"Precondition: aClassName is in the defined list"
	
	| ext |
	(classExtensionSelectors keys includes: aClassName) ifFalse: [^ self].
	ext := classExtensionSelectors at: aClassName.
	classExtensionSelectors removeKey: aClassName ifAbsent: [self reportBogusBehaviorOf:   #extendedMethodsBecomeDefinedForClass: ].
	(classDefinedSelectors keys includes: aClassName) ifTrue: [self error: aClassName , ' should not be defined in extension'.]. "we should remove this check later"
	classDefinedSelectors at: aClassName put: ext.! !

!RPackage methodsFor: 'private' stamp: 'StephaneDucasse 4/25/2011 12:25'!
extendedMethodsBecomeDefinedForMetaclass: aClassName
	"the package may contain extension methods and their class is added to the receiver. The status of such methods should now be defined"
	"Precondition: aClassName is in the defined list"
	
	| ext |
	(metaclassExtensionSelectors keys includes: aClassName) ifFalse: [^ self].
	ext := metaclassExtensionSelectors at: aClassName.
	metaclassExtensionSelectors removeKey: aClassName  ifAbsent: [self reportBogusBehaviorOf:  #extendedMethodsBecomeDefinedForMetaclass: ].
	(metaclassDefinedSelectors keys includes: aClassName) 
			ifTrue: [self error: aClassName , ' should not be defined in extension'.]. "we should remove this check later"
	metaclassDefinedSelectors at: aClassName put: ext.! !

!RPackage methodsFor: 'private' stamp: 'sd 4/25/2010 15:29'!
extendedMethodsShouldBecomeDefinedWhenAddingClassName: aClassName
	"the package may contain extension methods and their class is added to the receiver. The status of such methods should now be defined"
	"Precondition: aClassName is in the defined list"
	
	self extendedMethodsBecomeDefinedForClass: aClassName.
	self extendedMethodsBecomeDefinedForMetaclass: aClassName.
	! !

!RPackage methodsFor: 'testing' stamp: 'sd 4/25/2010 16:05'!
extendsClass: aClass
	"Returns true if the receiver extends aClass (that is defined in another package)"
	
	| canonizedName |
	canonizedName := aClass theNonMetaClass name.
	^ self extendedClassNames includes:  canonizedName! !

!RPackage methodsFor: 'system compatibility' stamp: 'StephaneDucasse 4/27/2011 11:37'!
extensionCategoriesForClass: aClass
	self flag: #stef. "only used by goferCleanUp and PackageEnvironment of RB"
	^ aClass organization categories select: [:cat | self isYourClassExtension: cat]! !

!RPackage methodsFor: 'system compatibility' stamp: 'StephaneDucasse 4/27/2011 11:37'!
extensionClasses
	self flag: #stef. "only used by RB and Gofer"
	^ self extendedClasses! !

!RPackage methodsFor: 'accessing' stamp: 'cyrille.delaunay 10/27/2010 13:04'!
extensionMethods
	"Extension methods are methods defined on classes that are not defined in the receiver"
	
	| mthds |
	mthds := OrderedCollection new.
	classExtensionSelectors keysAndValuesDo: [ :classSymbol :methods |
			methods do: [ :sel | mthds add: ((Smalltalk at: classSymbol) >>	sel)]].
	metaclassExtensionSelectors
	 keysAndValuesDo: [ :classSymbol :methods |
			methods do: [ :sel | mthds add: ((Smalltalk at: classSymbol) class >>sel)]].	
	^ mthds				! !

!RPackage methodsFor: 'accessing' stamp: 'tg 3/13/2010 14:18'!
extensionMethodsForClass: aClass

	^ (self extensionSelectorsForClass: aClass) collect: [ :each | aClass >> each ]! !

!RPackage methodsFor: 'accessing' stamp: 'DamienPollet 9/28/2010 17:09'!
extensionSelectors
	"Extension methods are methods defined on classes that are not defined in the receiver"
	
	| classSels |
	classSels := Set new.
	classExtensionSelectors values do: [:each | classSels addAll: each].
	metaclassExtensionSelectors values do: [:each | classSels addAll: each].
	^ classSels.
	! !

!RPackage methodsFor: 'accessing' stamp: 'GuillermoPolito 8/5/2012 13:33'!
extensionSelectorsForClass: aClass

	^ aClass isMeta
		ifTrue: [ metaclassExtensionSelectors at: aClass theNonMetaClass originalName ifAbsent: [ #() ] ]
		ifFalse: [ classExtensionSelectors at: aClass originalName ifAbsent: [ #() ] ]! !

!RPackage methodsFor: '*RPackage-SystemIntegration' stamp: 'StephaneDucasse 4/13/2011 22:45'!
importCategory
	"import all the classes of the class categories matching the receiver name (following package info semantics)." 
	
	| cat classesInCat |
	cat := Smalltalk globals organization categories select: [:each | each beginsWith:  self name ]. 
	classesInCat := cat gather: [:c | Smalltalk globals organization listAtCategoryNamed: c].
	classesInCat do: [:each | 
						self importClass: (Smalltalk globals at: each).
						self importClass: (Smalltalk globals at: each) class]! !

!RPackage methodsFor: '*RPackage-SystemIntegration' stamp: 'StephaneDucasse 7/29/2010 21:14'!
importCategory: aCat forClass: aClass 
	"import all the methods of a category as defined in the receiver." 
	
		(aClass organization listAtCategoryNamed: aCat)
			do: [:each | self addMethod: (aClass >> each)]
	
	! !

!RPackage methodsFor: '*RPackage-SystemIntegration' stamp: 'cyrilledelaunay 5/31/2011 15:56'!
importClass: aClass 
	"import a class already created but not attached to a package to the receiver. 
	Handle also *- convention. Methods defined in *category are not added to the package.
	Pay attention that it will not import anything from the metaClass side
	"
	
	| protocols |
	self addClassDefinition: aClass.
	protocols := aClass organization categories 
		reject: [:each | (each first = $*) and: [ ( '*', self name asLowercase match: each asLowercase) not] ].
		"we reject all extensions except the ones that have the same name as the package - highly improbable but who knows"
	protocols do: [:each | self importProtocol: each forClass: aClass]
	
	! !

!RPackage methodsFor: '*RPackage-SystemIntegration' stamp: 'StephaneDucasse 7/29/2010 21:16'!
importProtocol: aProtocol forClass: aClass 
	"import all the methods of a protocol as defined in the receiver." 
	
		(aClass organization listAtCategoryNamed: aProtocol)
			do: [:each | self addMethod: (aClass >> each)]
	
	! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 2/21/2010 17:56'!
includesClass: aClass	
	"Returns true if the receiver includes aClass in the classes that are defined within it: only class definition are considered - not class extensions"
	
	^ self includesClassNamed: aClass theNonMetaClass name! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 4/20/2010 22:53'!
includesClassNamed: aSymbol
	"Returns true if the receiver includes class named aSymbol in the classes that are defined within it: only class definition are considered - not class extensions"
	
	| aRealSymbol |
	aRealSymbol := aSymbol asSymbol.
	^ classes includes: aSymbol
	! !

!RPackage methodsFor: 'testing' stamp: 'tg 3/13/2010 15:13'!
includesDefinedSelector: aSelector ofClass: aClass
	"Return true if the receiver includes the method of selector aSelector. Only checks methods defined in this package"
	
	| sels |
	sels := self definedSelectorsForClass: aClass.
	^ sels includes: aSelector.! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 2/21/2010 18:53'!
includesDefinedSelector: aSelector ofClassName: aClassName
	"Return true if the receiver includes the method of selector aSelector. Only checks methods defined (not extended by other packages or package extensions)"
	
	| sels |
	sels := classDefinedSelectors at: aClassName ifAbsent: [^ false].
	^ sels includes: aSelector.! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 2/21/2010 18:53'!
includesDefinedSelector: aSelector ofMetaclassName: aClassName
	"Return true if the receiver includes the method of selector aSelector. Only checks methods defined (not extended by other packages or package extensions)"
	
	| sels |
	sels := metaclassDefinedSelectors at: aClassName ifAbsent: [^ false].
	^ sels includes: aSelector.! !

!RPackage methodsFor: 'testing' stamp: 'tg 3/13/2010 13:47'!
includesExtensionSelector: aSelector ofClass: aClass
	"Return true if the receiver includes the method of selector aSelector. Only checks methods extending other packages"
	
	| sels |
	sels := self extensionSelectorsForClass: aClass.
	^ sels includes: aSelector.! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 2/21/2010 18:54'!
includesExtensionSelector: aSelector ofClassName: aClassName
	"Return true if the receiver includes the method of selector aSelector. Only checks methods extending other packages"
	
	| sels |
	sels := classExtensionSelectors at: aClassName ifAbsent: [^ false].
	^ sels includes: aSelector.! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 2/21/2010 18:54'!
includesExtensionSelector: aSelector ofMetaclassName: aClassName
	"Return true if the receiver includes the method of selector aSelector. Only checks methods extending other packages"
	
	| sels |
	sels := metaclassExtensionSelectors at: aClassName ifAbsent: [^ false].
	^ sels includes: aSelector.! !

!RPackage methodsFor: 'system compatibility' stamp: 'cyrilledelaunay 5/4/2011 15:38'!
includesMethod: aSymbol ofClass: aClass

	self flag: #stef. "only used by RB"
	self flag: #cyrille. "looks like a bogus implementation because category have nothing to do with the fact that a method is in package or not."
	"CD: Indeed, it looks strange. 
	With RPackage we have 'includesSelector:ofClass:. I guess it should return the same result (?)'
	"
	aClass ifNil: [^ false].
	^ self
		includesMethodCategory: ((aClass organization categoryOfElement: aSymbol)
										ifNil: [' '])
		ofClass: aClass! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:33'!
includesMethodCategory: categoryName ofClass: aClass
	^ (self isYourClassExtension: categoryName)
		or: [(self includesClass: aClass)
				and: [(self isForeignClassExtension: categoryName) not]]! !

!RPackage methodsFor: 'system compatibility' stamp: 'StephaneDucasse 4/27/2011 11:44'!
includesMethodReference: aMethodRef

	self flag: 'includesMethod:ofClass: is not implemented for RPackage. Should fine fine a corresponding one '.
	self flag: #stef. "We can inline this one and replace it by methodSymbol and others."
	^ self includesMethod: aMethodRef methodSymbol ofClass: aMethodRef actualClass
	"^ self includesDefinedSelector: aMethodRef methodSymbol ofClass: aMethodRef actualClass"! !

!RPackage methodsFor: 'testing' stamp: 'tg 3/13/2010 16:42'!
includesSelector: aSelector ofClass: aClass
	"Return true if the receiver includes the method of selector aSelector. Checks methods defined locally as well as extending other packages"
	
	^ aClass isMeta
		ifTrue: [ self includesSelector: aSelector ofMetaclassName: aClass theNonMetaClass name  ]
		ifFalse: [ self includesSelector: aSelector ofClassName: aClass name  ]
	
! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 2/21/2010 20:50'!
includesSelector: aSelector ofClassName: aClassName
	"Return true if the receiver includes the method of selector aSelector. Checks methods defined locally as well as extending other packages"
	
	^ (self includesDefinedSelector: aSelector ofClassName: aClassName)
		or: [(self includesExtensionSelector: aSelector ofClassName: aClassName)]! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 3/11/2010 17:38'!
includesSelector: aSelector ofMetaclassName: aClassName
	"Return true if the receiver includes the method of selector aSelector. Checks methods defined locally as well as extending other packages"
	
	^ (self includesDefinedSelector: aSelector ofMetaclassName: aClassName)
		or: [(self includesExtensionSelector: aSelector ofMetaclassName: aClassName)]! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:33'!
includesSystemCategory: categoryName
	^ self category: categoryName matches: self systemCategoryPrefix! !

!RPackage methodsFor: 'initialize-release' stamp: 'StephaneDucasse 7/25/2011 21:47'!
initialize
	super initialize.	
	classes := Set new.
	metaclassExtensionSelectors := Dictionary new.
	classExtensionSelectors := Dictionary new.
	classDefinedSelectors := Dictionary new.
	metaclassDefinedSelectors := Dictionary new.
	classTags := Dictionary new.! !

!RPackage methodsFor: 'testing' stamp: 'StephaneDucasse 4/18/2011 12:14'!
isDefault
	"Return whether the receiver is the default package, i.e. the one used when nothing else is specified."
	^ self name = self class defaultPackageName! !

!RPackage methodsFor: 'system compatibility' stamp: 'BenjaminVanRyseghem 3/30/2011 12:41'!
isDirty

	| modifiedPackages packages |
	modifiedPackages := MCWorkingCopy allManagers select: [ :each | each modified ].
	packages := modifiedPackages collect: [:each | each package name].
	^ packages includes: self name.! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:33'!
isForeignClassExtension: categoryName
	^ categoryName first = $* and: [(self isYourClassExtension: categoryName) not]! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:34'!
isOverrideCategory: aString
	^ aString endsWith: '-override'! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:34'!
isOverrideOfYourMethod: aMethodReference
	"Answers true if the argument overrides a method in this package"
	^ (self isYourClassExtension: aMethodReference category) not and:
		[(self changeRecordForOverriddenMethod: aMethodReference) notNil]! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:34'!
isYourClassExtension: categoryName
	^ categoryName notNil and: [self category: categoryName asLowercase matches: self methodCategoryPrefix]! !

!RPackage methodsFor: 'slices' stamp: 'StephaneDucasse 3/11/2010 18:47'!
metaclassDefinedSlicesDo: aBlock
	"This method iterates over the defined class and their associated selectors. a slice is a class * list of selectors. aBlock will be applied to all the extensions slices of the receiver. aBlok first argument is the class and the second argument a list of method selectors"
	
	metaclassDefinedSelectors keysAndValuesDo: aBlock! !

!RPackage methodsFor: 'slices' stamp: 'StephaneDucasse 4/20/2010 21:42'!
metaclassExtensionSlicesDo: aBlock
	"This method iterates over the metaclass extensions and their associated selectors. A slice is a class * list of selectors. aBlock will be applied to all the extensions slices of the receiver. aBlok first argument is the class and second argument a list of selectors"
	
	metaclassExtensionSelectors keysAndValuesDo: aBlock
	
! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:34'!
methodCategoryPrefix
	^ '*', self name asLowercase! !

!RPackage methodsFor: 'system compatibility' stamp: 'cyrilledelaunay 2/9/2011 13:46'!
methodReferences
	
	^ self methods collect: [:each | each methodReference] thenSelect: [:each| each isValid and: [each isLocalSelector]].! !

!RPackage methodsFor: 'all accessing' stamp: 'sd 4/21/2010 16:36'!
methods

	| mths |
	mths := OrderedCollection new.
	metaclassExtensionSelectors keysAndValuesDo: [:key :val | val do: [:sel | mths add: ((Smalltalk at: key) class >> sel)]].
	classExtensionSelectors keysAndValuesDo: [:key :val |val do: [:sel | mths add: ((Smalltalk at: key) >> sel)]].
	metaclassDefinedSelectors keysAndValuesDo: [:key :val | val do: [:sel | mths add: ((Smalltalk at: key) class >> sel)]].
	classDefinedSelectors keysAndValuesDo: [:key :val | val do: [:sel | mths add: ((Smalltalk at: key) >> sel)]].
	^ mths! !

!RPackage methodsFor: 'accessing' stamp: 'DamienPollet 9/28/2010 17:10'!
methodsForClass: aClass
	"Returns all compiled methods for a class in the receiver without distinction of extensions or not"
	
	^ (self includesClass: aClass)
		ifFalse: [self extensionMethodsForClass: aClass]
		ifTrue: [self definedMethodsForClass: aClass]
	! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:34'!
methodsInCategory: aString ofClass: aClass do: aBlock
	((aClass organization listAtCategoryNamed: aString) ifNil: [^self])
		do: [:sel | aBlock value: (self referenceForMethod: sel ofClass: aClass)]! !

!RPackage methodsFor: 'accessing' stamp: 'sd 4/25/2010 15:52'!
name

	^ name! !

!RPackage methodsFor: 'accessing' stamp: 'EstebanLorenzano 8/3/2012 14:30'!
name: aSymbol

	| oldName |
	oldName := name.
	name := aSymbol asSymbol.
	oldName ifNotNil: [ 
		SystemAnnouncer uniqueInstance 
			announce: (RPackageRenamed 
				to: self 
				oldName: oldName 
				newName: aSymbol) ]! !

!RPackage methodsFor: 'accessing' stamp: 'DamienPollet 10/1/2010 11:52'!
organizer
	^ self class organizer! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:34'!
overriddenMethods
	^ Array streamContents: [:stream |
		self overriddenMethodsDo: [:each | stream nextPut: each]]
! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:34'!
overriddenMethodsDo: aBlock
	"Enumerates the methods the receiver contains which have been overridden by other packages"
	^ self allOverriddenMethodsDo: [:ea |
		(self isOverrideOfYourMethod: ea)
			ifTrue: [aBlock value: ea]]! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:35'!
overriddenMethodsInClass: aClass do: aBlock
	"Evaluates aBlock with the overridden methods in aClass"
	^ self overrideCategoriesForClass: aClass do: [:cat |
		self methodsInCategory: cat ofClass: aClass do: aBlock]! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:35'!
overrideCategoriesForClass: aClass do: aBlock
	"Evaluates aBlock with all the *foo-override categories in aClass"
	^ aClass organization categories do: [:cat |
		(self isOverrideCategory: cat) ifTrue: [aBlock value: cat]]! !

!RPackage methodsFor: 'accessing' stamp: 'cyrilledelaunay 5/13/2011 13:23'!
packageName

	^ name! !

!RPackage methodsFor: 'printing' stamp: 'StephaneDucasse 5/9/2011 17:03'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut: $(.
	aStream nextPutAll: self name.
	aStream nextPut: $)! !

!RPackage methodsFor: 'system compatibility' stamp: 'GuillermoPolito 5/1/2012 12:25'!
referenceForMethod: aSymbol ofClass: aClass
	^ (aClass >> aSymbol) asRingDefinition! !

!RPackage methodsFor: 'private-register' stamp: 'StephaneDucasse 4/22/2011 23:25'!
registerClass: aClass
	"Private method that declares the mapping between a class and its package."
	self organizer
		registerPackage: self forClass: aClass
	! !

!RPackage methodsFor: 'private-register' stamp: 'StephaneDucasse 4/22/2011 23:25'!
registerClassName: aClassNameSymbol
	"Private method that declares the mapping between a class and its package."
	self organizer
		registerPackage: self forClassName: aClassNameSymbol
	! !

!RPackage methodsFor: 'private-register' stamp: 'GuillermoPolito 8/5/2012 13:22'!
removeAllMethodsFromClassNamed: aClassNameSymbol
	"Remove all the methods (defined and extensions) that are related to class aClassNameSymbol. aClassNameSymbol is the name of a class and not a metaclass - see class comment."

	classDefinedSelectors removeKey: aClassNameSymbol ifAbsent: [nil].
	classExtensionSelectors removeKey: aClassNameSymbol ifAbsent: [nil].
	metaclassDefinedSelectors removeKey: aClassNameSymbol ifAbsent: [nil].
	metaclassExtensionSelectors removeKey: aClassNameSymbol ifAbsent: [nil].! !

!RPackage methodsFor: 'accessing' stamp: 'cyrilledelaunay 5/4/2011 15:56'!
removeClass: aClass
	"Remove the class and all its methods from the receiver"

	"This is the line you should uncomment if you want to debug the strange problem with the test: RPackageMCSynchronisationTest>>testRecategorizeClassUnregisterTheClassMethodsFromTheOldPackage. 
	The problem came from that at this point, two methods from the class were equals (whereas they should not). For now I just modified definedMethodsForClass:  to return an OrderedCollection instead of a Set, To be sure I don't forget any method to remove"
	
	"self haltIf: [(aClass methodDict at: #method1) = (aClass methodDict at: #method2)]."
	(self definedMethodsForClass: aClass instanceSide) do: [ :aCompiledMethod |
		"(self removeDefinedMethod: aCompiledMethod forClass: aClass instanceSide)."
		self removeMethod: aCompiledMethod 
		].
	"we also have also have to remove methods from class side"
	(self definedMethodsForClass: aClass classSide) do: [ :aCompiledMethod |
		"(self removeDefinedMethod: aCompiledMethod forClass: aClass classSide)."
		self removeMethod: aCompiledMethod 
		].
	self removeClassDefinitionWithoutCheckingMethods: aClass.! !

!RPackage methodsFor: 'class addition' stamp: 'StephaneDucasse 4/13/2011 21:57'!
removeClassDefinition: aClass
	"Remove the class definition from the package but not its methods."
	
	| removed aClassName|
	aClassName := aClass theNonMetaClass name.
	removed := classes remove: aClassName ifAbsent: [nil].
	removed ifNotNil: [
			self definedMethodsShouldBecomeExtensionWhenRemovingClass: aClassName.
			self unregisterClass: aClass.] 
	! !

!RPackage methodsFor: 'class tags' stamp: 'StephaneDucasse 7/25/2011 22:11'!
removeClassDefinition: aClass fromClassTag: aSymbol
	"Detags the class aClass with the tag aSymbol"
	
	self removeClassDefinitionName: aClass name fromClassTag: aSymbol! !

!RPackage methodsFor: 'class addition' stamp: 'sd 4/25/2010 15:46'!
removeClassDefinitionName: aClassName
	"remove the class definition from the package but not its method"
	
	| removed aClassNameSymbol |
	('* class' match: aClassName) ifTrue: [^ self error: 'no metaclass name'].
	aClassNameSymbol := aClassName asSymbol.
	removed := classes remove: aClassNameSymbol ifAbsent: [nil].
	removed ifNotNil: [
				self definedMethodsShouldBecomeExtensionWhenRemovingClass: aClassName.
				self unregisterClassName: aClassNameSymbol.] 
	! !

!RPackage methodsFor: 'class tags' stamp: 'StephaneDucasse 7/26/2011 00:15'!
removeClassDefinitionName: aClassName fromClassTag: aSymbol
	"Detags the class aClass with the tag aSymbol"
	
	| res |
	res :=  classTags at: aSymbol ifAbsent: [^ self].
	res remove: aClassName ifAbsent: nil.
	! !

!RPackage methodsFor: 'private-register' stamp: 'StephaneDucasse 5/26/2012 16:53'!
removeClassDefinitionNamed: aClassNameSymbol
	"aClassNameSymbol should be the name of a class and not a metaclass to be coherent with the class invariant that classes are only class names and not metaclass ones. 
	
	This method removes the class definition from the receiver and its organizer"

	| removed |
	removed := classes remove: aClassNameSymbol ifAbsent: [nil].
	removed ifNotNil: [ self unregisterClassName: aClassNameSymbol.] 
	! !

!RPackage methodsFor: 'accessing' stamp: 'cyrilledelaunay 1/5/2011 13:05'!
removeClassDefinitionWithoutCheckingMethods: aClass
	"Same than 'removeClassDefinition', excepts that it does not make any check to set defined methods as extensions"
	
	| removed aClassName|
	aClassName := aClass theNonMetaClass name.
	removed := classes remove: aClassName ifAbsent: [nil].
	removed ifNotNil: [
			self unregisterClass: aClass.] 
	! !

!RPackage methodsFor: 'class tags' stamp: 'StephaneDucasse 7/26/2011 00:10'!
removeClassTag: aSymbol
	"Remove the class tag from the receiver."
	
	classTags removeKey: aSymbol ifAbsent: [nil].! !

!RPackage methodsFor: 'accessing' stamp: 'cyrilledelaunay 5/4/2011 16:02'!
removeDefinedMethod: aCompiledMethod forClass: aClass 
	"Remove the method to the receiver as a defined method."
	
	self flag: #cyrille. "no need for this method since we have removeMethod and normally 
	given a compiledMethod and a package we know if it is extending or not the package."
	"CD: Indeed, I changed the code where this method was called (removeClass:) , and it does not raise more errors when running the tests.There is no longer senders of this method"
	aClass isMeta
		ifTrue: [(metaclassDefinedSelectors 
			at: aClass theNonMetaClass name  
			ifAbsent: [^nil]) remove: aCompiledMethod selector]
		ifFalse: [(classDefinedSelectors 
			at: aClass name 
			ifAbsent: [^nil]) remove: aCompiledMethod selector].	
	^ aCompiledMethod.! !

!RPackage methodsFor: 'compiled method handling' stamp: 'GuillermoPolito 5/29/2012 14:20'!
removeMethod: aCompiledMethod 
	"Remove the method to the receiver as a defined method."

	| mr mthClass |
	mthClass := aCompiledMethod methodClass. 
	mthClass isMeta
		ifTrue: [
			self removeSelector: aCompiledMethod selector ofMetaclassName: mthClass theNonMetaClass originalName.
		]
		ifFalse: [
			self removeSelector: aCompiledMethod selector ofClassName: mthClass originalName.
		].
	^ aCompiledMethod.! !

!RPackage methodsFor: 'selector handling' stamp: 'GuillermoPolito 5/29/2012 14:12'!
removeSelector: aSelector ofClassName: aClassName
	"Remove the method in the package but does not propagate to the class itself.  Note that this method does not remove the method from the class, it just records in the package that the method is not in the package anymore."
	
	self basicRemoveSelector: aSelector ofClassName: aClassName.
	(classExtensionSelectors at: aClassName ifAbsent: [ #() ]) ifEmpty: [
		classExtensionSelectors removeKey: aClassName ifAbsent: [].
	].
	(classDefinedSelectors at: aClassName ifAbsent: [ #() ]) ifEmpty: [
		classDefinedSelectors removeKey: aClassName ifAbsent: [].
	].

	((metaclassExtensionSelectors at: aClassName ifAbsent: [#()]) isEmpty and: [(classExtensionSelectors at: aClassName ifAbsent: [#()]) isEmpty])
		ifTrue: [
				self organizer unregisterExtendingPackage: self forClassName: aClassName
	]! !

!RPackage methodsFor: 'selector handling' stamp: 'GuillermoPolito 5/29/2012 14:12'!
removeSelector: aSelector ofMetaclassName: aClassName
	"Remove the method in the package. Note that this method does not remove the method from the class, it just records in the package that the method is not in the package anymore. aClassName is the sole instance class name and not its metaclass one: i.e. adding Point class>>new is done as removeSelector: #new ofMetaclassName: #Point"
	
	self basicRemoveSelector: aSelector ofMetaclassName: aClassName.
	(metaclassExtensionSelectors at: aClassName ifAbsent: [ #() ]) ifEmpty: [
		metaclassExtensionSelectors removeKey: aClassName ifAbsent: [].
	].
	(metaclassDefinedSelectors at: aClassName ifAbsent: [ #() ]) ifEmpty: [
		metaclassDefinedSelectors removeKey: aClassName ifAbsent: [].
	].

	((metaclassExtensionSelectors at: aClassName ifAbsent: [#()]) isEmpty and: [(classExtensionSelectors at: aClassName ifAbsent: [#()]) isEmpty])
		ifTrue: [
				self organizer unregisterExtendingPackage: self forClassName: aClassName
	]! !

!RPackage methodsFor: 'private' stamp: 'cyrilledelaunay 5/30/2011 16:22'!
reportBogusBehaviorOf: aSelector

	self logCr: 'RPackage log: Something wrong around ', aSelector asString , 'since the removeKey: is called on not present information.'.! !

!RPackage methodsFor: 'all accessing' stamp: 'sd 4/21/2010 16:12'!
selectors

	| sel |
	sel := Set new.
	metaclassExtensionSelectors valuesDo: [:each | sel addAll: each].
	classExtensionSelectors valuesDo: [:each | sel addAll: each].
	metaclassDefinedSelectors valuesDo: [:each | sel addAll: each].
	classDefinedSelectors valuesDo: [:each | sel addAll: each].
	^ sel
	! !

!RPackage methodsFor: 'accessing' stamp: 'DamienPollet 9/28/2010 17:11'!
selectorsForClass: aClass
	"Returns all selectors for a class in the receiver without distinction of extensions or not"
	
	^ (self includesClass: aClass)
		ifFalse: [self extensionSelectorsForClass: aClass]
		ifTrue: [self definedSelectorsForClass: aClass]
	! !

!RPackage methodsFor: 'system compatibility' stamp: 'cyrilledelaunay 2/4/2011 14:12'!
systemCategories

	"(RPackageOrganizer default packageNamed: 'HelpSystem-Core' asSymbol) systemCategories"
	"(PackageInfo named: 'HelpSystem-Core' asSymbol) systemCategories"
	^ self systemOrganization categories select: [:cat | self includesSystemCategory: cat]! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:35'!
systemCategoryPrefix
	^ self name! !

!RPackage methodsFor: 'system compatibility' stamp: 'RPackage 1/20/2011 13:35'!
systemOrganization 

	^ Smalltalk globals organization! !

!RPackage methodsFor: 'system compatibility' stamp: 'MarianoMartinezPeck 8/4/2012 18:01'!
systemSubPackages

	"return all RPackages matching with systemCategories of this RPackage"
	|tmpPackages|
	tmpPackages := OrderedCollection new.
	self systemCategories do: [:aString |
		(aString asSymbol = self name) ifFalse: [
			|tmpPackage|
			"Maybe a RPackage matching the subcategory name does not yet exist in the organizer (Because packageInfo lazily register category from system). In this case, We should also lazily register a new RPackage with the right contents inside:"
			tmpPackage := self organizer packageNamed: aString asSymbol ifAbsent: [self organizer importFromPackageInfo: (PackageInfo named: aString)].
			tmpPackages add: (tmpPackage).
			].
		].
	^ tmpPackages! !

!RPackage methodsFor: 'class tags' stamp: 'StephaneDucasse 7/25/2011 22:28'!
tags
	"Returns the tags of the receiver"
	
	^ classTags keys! !

!RPackage methodsFor: 'private-register' stamp: 'StephaneDucasse 4/22/2011 23:25'!
unregisterClass: aClass
	"Private method that declares the mapping between a class and its package."
	self organizer
		unregisterPackage: self forClass: aClass.! !

!RPackage methodsFor: 'private-register' stamp: 'StephaneDucasse 4/22/2011 23:26'!
unregisterClassName: aClassNameSymbol
	"Private method that declares the mapping between a class and its package."
	self organizer unregisterPackage: self forClassName: aClassNameSymbol! !

!RPackage methodsFor: 'updating' stamp: 'EstebanLorenzano 7/27/2012 19:40'!
updateDefinedClassNamed: oldString withNewName: newString
	"this method should only be used with class names , and not metaclass names"
	(oldString substrings size > 1 or: [newString substrings size > 1]) ifTrue: [
		Error signal: 'You should not use metaclass names'
		].
	
	"=> update the 'classDefinedSelectors' dictionary (replace the old key by the new one)
       => update the 'metaclassDefinedSelectors' dictionary (replace the old key by the new one)"
	classes remove: oldString.
	classes add: newString.
	self flag: #cyrille. "what happens if this is a metaclass: it breaks the invariant of the package"
	"worse so far the second block below breaks"
	"the name of the method should be updateDefinedClassNamed: withNewName:"
	"CD: i only use this method when a class is renamed in the system (systemClassRenamedActionFrom:). Normally we are not able to rename a metaclass in the system (?) so we should never end up in a case with metaclass names ?  "
	
	(classDefinedSelectors at: oldString ifAbsent: [nil]) ifNotNil: [
		classDefinedSelectors at: newString put: (classDefinedSelectors at: oldString).
		classDefinedSelectors removeKey: oldString  ifAbsent: [self reportBogusBehaviorOf: #updateDefinedClassNamed:withNewName:   ]
		].
	
	(metaclassDefinedSelectors at: oldString ifAbsent: [nil]) ifNotNil: [
		metaclassDefinedSelectors at: newString put: (metaclassDefinedSelectors at: oldString).
		metaclassDefinedSelectors removeKey: oldString  ifAbsent: [self reportBogusBehaviorOf: #updateDefinedClassNamed:withNewName:   ]
		].! !

!RPackage methodsFor: 'updating' stamp: 'StephaneDucasse 4/13/2011 22:02'!
updateDefinedSelector: oldSelector inClass: aClass withNewSelector: newSelector

	aClass isMeta
		ifTrue: [
			(metaclassDefinedSelectors at: aClass instanceSide name asSymbol) remove: oldSelector. 
			(metaclassDefinedSelectors at: aClass instanceSide name asSymbol) add: newSelector. ]
		ifFalse: [
			(classDefinedSelectors  at: aClass name asSymbol) remove: oldSelector. 
			(classDefinedSelectors  at: aClass name asSymbol) add: newSelector. ]! !

!RPackage methodsFor: 'updating' stamp: 'StephaneDucasse 4/25/2011 12:29'!
updateExtensionForClassNamed: oldString withNewName: newString

	"=> update the 'classExtensionsSelectors' dictionary (replace the old key by the new one)
        => update the 'metaclassclassExtensionsSelectors' dictionary (replace the old key by the new one)"
	"classes remove: oldString.
	classes add: newString."
	
	(metaclassExtensionSelectors at: oldString ifAbsent: [nil]) ifNotNil: [
		metaclassExtensionSelectors at: newString put: (metaclassExtensionSelectors at: oldString).
		metaclassExtensionSelectors removeKey: oldString  ifAbsent: [self reportBogusBehaviorOf: #updateExtensionForClassNamed:withNewName:   ]
		].
	
	(classExtensionSelectors at: oldString ifAbsent: [nil]) ifNotNil: [
		classExtensionSelectors at: newString put: (classExtensionSelectors at: oldString).
		classExtensionSelectors removeKey: oldString ifAbsent: [self reportBogusBehaviorOf: #updateExtensionForClassNamed:withNewName:   ]
		].! !

!RPackage methodsFor: 'updating' stamp: 'cyrille.delaunay 11/16/2010 14:41'!
updateExtensionSelector: oldSelector inClass: aClass withNewSelector: newSelector

	aClass isMeta
		ifTrue: [
			(metaclassExtensionSelectors at: aClass instanceSide name asSymbol) remove: oldSelector. 
			(metaclassExtensionSelectors at: aClass instanceSide name asSymbol) add: newSelector. 
			]
		ifFalse: [
			(classExtensionSelectors  at: aClass name asSymbol) remove: oldSelector. 
			(classExtensionSelectors  at: aClass name asSymbol) add: newSelector. 
			]! !

!RPackage methodsFor: 'updating' stamp: 'cyrille.delaunay 11/16/2010 15:08'!
updateSelector: oldSelector inClass: aClass withNewSelector: newSelector

	"here we check if the old seletor is defined in the package or if it is an extension. Then we dispatch the work to the corresponding method.
	For one specific class, a selector is either a defined selector or an extension selector, there is no way to have a couple of class->selector present in both dictionary"
	
	(self includesDefinedSelector: oldSelector ofClass: aClass) 
		ifTrue: [^ self updateDefinedSelector: oldSelector inClass: aClass  withNewSelector: newSelector].
	(self includesExtensionSelector: oldSelector ofClass: aClass)
		ifTrue: [^ self updateExtensionSelector: oldSelector inClass: aClass  withNewSelector: newSelector].
		
		! !

Object subclass: #RPackageBenchmark
	instanceVariableNames: ''
	classVariableNames: 'OrganizerToBenchmark'
	poolDictionaries: ''
	category: 'RPackage-Core'!

!RPackageBenchmark commentStamp: '<historical>' prior: 0!
A dummy class to run some benchmarcks!

!RPackageBenchmark class methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 7/16/2010 15:58'!
organizerToBenchmark
	"self organizerToBenchmark"
	OrganizerToBenchmark 
		ifNil: [ OrganizerToBenchmark := RPackageOrganizer new initializeFromSystem].
	^ OrganizerToBenchmark! !

!RPackageBenchmark class methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 7/16/2010 15:53'!
resetOrganizerToBenchmark

	OrganizerToBenchmark := nil! !

!RPackageBenchmark class methodsFor: 'as yet unclassified' stamp: 'StephaneDucasse 7/29/2010 23:00'!
runForLog
	"To run the benchmark you may have to reset the organizer
	self resetOrganizerToBenchmark"	
	" self runForLog  "
	
	
	"17 July 2010
		class package access: 10
		extending package access: 13
		selector for class: 39
		extending package access +: 19
		method package access: 1173
	"
	

	
	| classes |
	RPackage 
		withOrganizer: self organizerToBenchmark
		do: [ :anOrganizer | 
			classes := Object withAllSubclasses.
			classes remove: UndefinedObject.
			classes remove: ClassTrait.
			classes remove: ClassTrait class.
			classes := classes reject: [:each | #('BogusInfo*' 'GRPackage*' 'MC*') 
												anySatisfy: [:pat | pat match: each name]].
			classes := classes reject: [:each | each package isNil].
			
			^ String streamContents: [:st |
					
					st nextPutAll: 'class package access: ',	(Time millisecondsToRun: [classes do: [:each | each package]]) printString ;cr.
					st nextPutAll: 'extending package access: ',	(Time millisecondsToRun: [classes do: [:each | each extendingPackages]]) printString ;cr.
		     			st nextPutAll: 'selector for class: ',	(Time millisecondsToRun: [classes do: [:each | each package selectorsForClass: each]]) printString ;cr.
					st nextPutAll: 'extending package access +: ',	(Time millisecondsToRun: 
																	[classes do: [:each | each extendingPackages 
																							do: [ :package | 
																								package selectorsForClass: each]]]) printString ;cr.
					st nextPutAll: 'method package access: ',	(Time millisecondsToRun: 
																	[classes do: [:each | each methods do: [:method | 
																				method packageFromOrganizer: anOrganizer ]]]) printString ;cr.
			
			
			
			]].
					
	
	! !

Object subclass: #RPackageOrganizer
	instanceVariableNames: 'classPackageMapping packages classExtendingPackagesMapping debuggingName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RPackage-Core'!

RPackageOrganizer class
	instanceVariableNames: 'default'!

!RPackageOrganizer commentStamp: '<historical>' prior: 0!
A RPackageOrganizer is responsible for providing all the package currently defined in the system.
In addition it provides a back pointer from the class to its package.

The classPackageMapping and the classExtendingPackageMapping should be moved in the future to the classes themselves. 


For tests or actions that could destroy the package organizer,  do not access directly the singleton of RPackageOrganizer.
Use instead 
		RPackage withOrganizer: aNewOrganizer do: ablock
			or via RPackage organizer
		
	
RPackageOrganizer fillUp will fill up the system from the current PackageOrganizer
	"self fillUp"
	
-----------------------------------------------------------------------------------------------------------------------------------------------	
	
	
A rpackageOrganizer update itself when some changes are made in the system. It does that by registering to a systemAnnoucer, specifying an action when an annoucement is triggered.
Here is what I (Cyrille Delaunay) propose to do for each annocuement triggered:

SystemCategoryAddedAnnouncement 	
	=> I would just register a new RPackage (if it does not already exist) in the RPackageOrganizer
	
SystemCategoryRemovedAnnouncement 
     => I would just unregister the RPackage concerned from the organizer

SystemCategoryRenamedAnnouncement
     => I would update the RPackage concerned, by changing its name
     => I would update the 'packages' dictionary of the organizer, putting the new name as key

SystemClassAddedAnnouncement 
    => Import the class in the RPackage concerned (RPackage >> importClass:)
    => Register the class in the 'classPackageMapping' dictionary of the organizer (RPackageOrganizer >> registerPackage:forClass)
    (=> maybe we should pay attention if both the class and the metaclass launch this kind of event ?)

SystemClassRecategorizedAnnouncement
    => I would update the old RPackage concerned:
            => unregister the class
            => unregister all defined methods of the class
    => I would update the new RPackage:
            => Import the class in the RPackage (importClass:)
    => I would update the organizer:
            => update the 'classPackageDictionary' to point on the new RPackage

 
SystemClassRemovedAnnouncement
    => I would update the RPackake concerned
             => unregister the class
             => unregister all defined methods of the class
    => I would update the organizer:
             => update the 'classPackageDictionary' to remove the class

SystemClassRenamedAnnouncement
    => I would update the RPackage in which the class is defined:
             => update the 'classDefinedSelectors' dictionary (replace the old key by the new one)
             => update the 'metaclassDefinedSelectors' dictionary (replace the old key by the new one)
    => I would update all RPackages extending this class
             => update the 'classExtensionsSelectors' dictionary (replace the old key by the new one)
             => update the 'metaclassclassExtensionsSelectors' dictionary (replace the old key by the new one)
    => I would update the organizer
             => update the 'classPackageDictionary' to replace the key with the new class name
             => update the 'classExtendingPackagesMapping' to replace the key with the new class name
                          
SystemClassReorganizedAnnouncement 
    (=> I guess we should check if extensions have not been added or removed ? 
      (to retrieve this information, the only thing I found is ClassDescription >> organization, and then check each category begining with '*' and compare with the organizer. seems to be painful, no?))
	=> when an extension is removed, all methods inside are removed. Therefore, the MethodRemovedAnnounecement will do the job. Not sur this one still usefull

SystemProtocolAddedAnnouncement
    => I don't see anything to do for this annoucement

SystemProtocolRemovedAnnoucement
    => If the category is an extension from a package, I would move all the methods concerned, from the extending RPackage to the class RPackage

SystemMethodAddedAnnouncement
       => I would check the category in which the method has been defined
               => if it correspond to an extending package -> add the method to the extending RPackage
               => if not, add the method to the class parentPackage

SystemMethodModifiedAnnouncement
       this annoucement can correspond to several kind of modifications:
	       *  a method has been renamed
                       => I would update the rPackage in which the method is defined to replace the old selector by the new one
		* a method has been move to another category 
			-maybe from a classic category to an extending package
                             => we should move the method from the  method class parentPackage to extendingPackage package
			-maybe from an extending package to another extending package
                             => we should move the method from the  extendingPackage package to the other extendingPackage package
			-maybe from an extending package to a classic category
                             =>  we should move the method from the  extendingPackage to the method class parentPackage
		        -maybe from a classic category to another classic category
                             => we have nothing to do
			

SystemMethodRecategorizedAnnouncement
          same thing than above

SystemMethodRemovedAnnouncement
       => I would simply remove the method from the RPackage in which it is register!

RPackageOrganizer class
	instanceVariableNames: 'default'!

!RPackageOrganizer class methodsFor: 'utils' stamp: 'StephaneDucasse 6/2/2012 19:39'!
allManagers

	^ MCWorkingCopy allManagers! !

!RPackageOrganizer class methodsFor: 'utils' stamp: 'cyrille.delaunay 11/3/2010 18:26'!
computeDiffWithMC
	"self computerDiffWithMC"
	
	^ self rpackageNames difference: self packageInfoNames ! !

!RPackageOrganizer class methodsFor: 'singleton' stamp: 'TudorGirba 11/25/2010 23:51'!
default
	
	default isNil ifTrue: [
		default := self new.
		default ].
	^ default! !

!RPackageOrganizer class methodsFor: 'singleton' stamp: 'GuillermoPolito 8/4/2012 14:42'!
fillUp
	"self fillUp"
	self default initializeFromSystemStartingFromPackageOrganizer.
	"initializing from system might have generated some new packageInfo (because Package Inof lazily register system categories). Therefore, we should iterate a second time over all package infos:"
	self default initializeFromSystemStartingFromPackageOrganizer.
	"We register to system announcement here (and not from the instance side), because we don't want that to be dome each time we create a PackageOrganizer. Only  an updated Organizer (that means that it is synchronized with all current packages of the system (doen throught 'initializeFromSystem')) should register. If it is not the case, it could generate big problems for your image"
	self default register. ! !

!RPackageOrganizer class methodsFor: 'class initialization' stamp: 'GuillermoPolito 8/4/2012 14:42'!
initialize
	self initializeDefault.! !

!RPackageOrganizer class methodsFor: 'initialize-release' stamp: 'GuillermoPolito 8/4/2012 14:42'!
initializeDefault

	"self initializeDefault"
	default := nil.
	self fillUp.! !

!RPackageOrganizer class methodsFor: '*RPackage-SystemIntegration' stamp: 'StephaneDucasse 6/3/2012 22:36'!
isPackageDefinedForClass: aClass

	^ (self default packageOf: aClass) notNil! !

!RPackageOrganizer class methodsFor: '*RPackage-SystemIntegration' stamp: 'GuillermoPolito 8/3/2012 14:20'!
methodAdded: anEvent
	"precondition: package exist, class exist"
	
	| methodCategory |
	methodCategory := anEvent protocol.
	(methodCategory isEmptyOrNil or:[ methodCategory first ~= $* ]) 
		ifFalse: [
			(self isPackageDefinedForClass: anEvent methodClass)
					ifFalse: [self packageClass new named: (Smalltalk organization categoryOfElement: anEvent methodClass theNonMetaClass asSymbol) ].
		].! !

!RPackageOrganizer class methodsFor: 'private' stamp: 'StephaneDucasse 6/3/2012 22:39'!
packageClass

	^ RPackage! !

!RPackageOrganizer class methodsFor: 'utils' stamp: 'StephaneDucasse 6/2/2012 19:38'!
packageInfoNames
	"self packageInfoNames"
	
	^ self allManagers collect: [:each | each package name]
	
	! !

!RPackageOrganizer class methodsFor: '*RPackage-SystemIntegration' stamp: 'sd 4/23/2011 23:31'!
registerInterestToSystemAnnouncement

	self default unregisterInterestToSystemAnnouncement.
	"To make sure that we do not have it twice registered"
	self default registerInterestToSystemAnnouncement! !

!RPackageOrganizer class methodsFor: 'initialize-release' stamp: 'StephaneDucasse 6/3/2012 22:40'!
removeMockPackagesFromOldOrganizer

	"the next line is a bit 'hacky'. It will remove the mock packages used by monticello test in packageInfo-Organizer. Those packages will now be subclasses of RPackage and should no longer be present in the packageInfo-organizer"
	|mockPackages|
	"mockPackages := PackageOrganizer default packages select: [:info | ((((info packageName = 'MCDirtyPackage') or: [info packageName = 'MCEmptyPackage']) or: [info packageName = 'MonticelloMocks']) 	or: [info isKindOf:  MCDirtyPackageInfo])]."
	mockPackages := self default packages select: [:info | (({'MCDirtyPackageInfo'. 'MCEmptyPackage'. 'MonticelloMocks'} includes: info packageName) 	or: [info isKindOf:  MCDirtyPackageInfo])].
	mockPackages do: [:each |
		self default unregisterPackage: each.
	].
	self default packagesDictionary removeKey: #'Monticello-Mocks' ifAbsent: [].! !

!RPackageOrganizer class methodsFor: 'singleton' stamp: 'StephaneDucasse 6/3/2012 22:39'!
resetDefault

	"self resetDefault"
	default  ifNotNil: [
		"When an Organizer is not used anymore, we should always pay attention that these two actions are corretly done."
		default unregisterInterestToSystemAnnouncement.
		MCWorkingCopy removeDependent: default].
	default := self new.
	self packageClass initialize! !

!RPackageOrganizer class methodsFor: 'utils' stamp: 'cyrille.delaunay 11/3/2010 18:24'!
rpackageNames
	"self computeDiffWithMC"
	
	^ default packages collect: [:each | each name]
	
	! !

!RPackageOrganizer class methodsFor: '*RPackage-SystemIntegration' stamp: 'cyrille.delaunay 11/26/2010 10:23'!
unregisterInterestToSystemAnnouncement

	self default unregisterInterestToSystemAnnouncement! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'StephaneDucasse 6/2/2012 19:39'!
allManagers

	^ self class allManagers ! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'EstebanLorenzano 8/3/2012 14:22'!
announcer 
	^SystemAnnouncer uniqueInstance private! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'cyrilledelaunay 5/30/2011 17:34'!
basicRegisterPackage: aPackage
	"A new package is now available and declared in the receiver. Note that it is a low level implementation method since it does not deal with package contained information and does not update the related mapping tables."
	
	packages at: aPackage name asSymbol put: aPackage.
	^ aPackage! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'cyrilledelaunay 5/30/2011 17:38'!
basicUnregisterPackage: aPackage
	"Unregister the specified package from the list of registered packages. Raise the announcement RPackageUnregistered. This is a low level action. It does not unregister the back pointer from classes to packages or any other information managed by the organizer"
	
	| symbol |
	symbol := aPackage name asSymbol.
	(self includesPackageNamed: symbol)
		ifTrue: [ packages removeKey: symbol ifAbsent: []]
		ifFalse: [self reportExtraRemovalOf: aPackage  ]
	! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'cyrilledelaunay 5/30/2011 17:38'!
basicUnregisterPackageNamed: aSymbolName
	"Unregister the specified package from the list of registered packages. Raise the RPackageUnregistered announcement. This is a low level action. It does not unregister the back pointer from classes to packages or any other information managed by the organizer"
	
	| symbol |
	symbol := aSymbolName asSymbol.
	(self includesPackageNamed: symbol) 
		ifTrue: [
			| aPackage | 
			aPackage := packages at: symbol. 
			packages removeKey: symbol ifAbsent: []].
	! !

!RPackageOrganizer methodsFor: 'mc synchronization tofix' stamp: 'cyrilledelaunay 2/1/2011 14:25'!
category: categoryName matches: prefix
	"self default category: 'Compression-Archives' matches: 'Compression'"
	"self default category: 'Compression' matches: 'Compression-Archives'"
	"self default category: 'Compression' matches: 'Compression'"
	"self default category: 'Compression-Arh' matches: 'Compression'"
	"self default category: 'CateGory' matches: 'category'"
	| prefixSize catSize |
	categoryName ifNil: [ ^false ].
	catSize := categoryName size.
	prefixSize := prefix size.
	catSize < prefixSize ifTrue: [ ^false ].
	(categoryName findString: prefix startingAt: 1 caseSensitive: false) = 1
		ifFalse: [ ^false ].
	^(categoryName at: prefix size + 1 ifAbsent: [ ^true ]) = $-! !

!RPackageOrganizer methodsFor: 'private' stamp: 'StephaneDucasse 4/24/2011 17:32'!
debuggingName

	^ debuggingName ! !

!RPackageOrganizer methodsFor: 'private' stamp: 'StephaneDucasse 4/24/2011 17:32'!
debuggingName: aString

	debuggingName := aString! !

!RPackageOrganizer methodsFor: 'initialize-release' stamp: 'StephaneDucasse 6/3/2012 22:42'!
defineUnpackagedClassesPackage
	^ self ensureExistAndRegisterPackageNamed: self packageClass defaultPackageName! !

!RPackageOrganizer methodsFor: 'public registration' stamp: 'StephaneDucasse 6/3/2012 22:55'!
ensureExistAndRegisterPackageNamed: aSymbol
	"A new package is now available and declared in the receiver."
	
	| aPackage |
	aPackage := packages at: aSymbol asSymbol ifAbsentPut: [self packageClass named: aSymbol].
	aPackage extendedClasses do: [ :extendedClass|
			self registerExtendingPackage: aPackage forClass: extendedClass].
	aPackage definedClasses do: [ :definedClass|
			self registerPackage: aPackage forClass: definedClass].
	self announcer announce: (RPackageCreated to: aPackage).
	^ aPackage! !

!RPackageOrganizer methodsFor: 'package access from class' stamp: 'sd 5/21/2010 14:56'!
extendingPackagesOf: aClass
	"Returns the packages extending the class aClass"
	^ classExtendingPackagesMapping at: aClass theNonMetaClass name ifAbsent: [#()]! !

!RPackageOrganizer methodsFor: 'package access from class' stamp: 'cyrille.delaunay 11/24/2010 14:24'!
extendingPackagesOfClassNamed: aName
	"Returns the packages extending the class named a Symbol"
	^ classExtendingPackagesMapping at: aName asSymbol ifAbsent: [#()]! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'GuillermoPolito 8/5/2012 13:34'!
fullyRemoveClassNamed: className
	"Remove the class, the class backpointer, the extensions and the extension backPointer from the receiver and the class involved with the class named: className. className is a class name and should not be a metaclass one. "	

	| rPackage |	
	rPackage := self packageOfClassNamed: className.
	rPackage ifNil: [^self].
	rPackage removeClassDefinitionNamed: className.
	rPackage removeAllMethodsFromClassNamed: className. 
	(self extendingPackagesOfClassNamed: className)
		do: [:each | each removeAllMethodsFromClassNamed: className. ].
	
	! !

!RPackageOrganizer methodsFor: 'package access from class' stamp: 'cyrilledelaunay 2/22/2011 13:54'!
globalPackageOf: aClass
	"this method should return the 'global' parent package of aClass, that means the package holding the (possible) subcategory in which aClass is concretely defined. For example, 'Object package' returns Kernel-Object, whereas 'PackageOrganizer packageOf: Object' returns Kernel. So I guess that all use of 'packageOf' should be replaced by this method  "

	"RPackageOrganizer default globalPackageOf: Object"

	| globalPackage classPackage |
	classPackage := self packageOf: aClass.
	globalPackage := self packages
		detect: [ :aRPackage | aRPackage ~= classPackage and: [ aRPackage systemCategories includes: classPackage name ] ]
		ifNone: [ ^ classPackage ].
	^ globalPackage! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'GuillermoPolito 6/3/2012 01:35'!
hasPackageExactlyMatchingExtensionName: anExtensionName
	^packages keys anySatisfy: [ :aSymbol | (aSymbol sameAs: anExtensionName asSymbol)]! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'GuillermoPolito 6/3/2012 02:24'!
hasPackageForProtocol: aProtocolName inClass: aClass
	"According aProtocolName is an extension protocol, will look for a matching package. If no matching package is found ,  return nil. If aProtocolName is not an extension protocol, return the parent package of aClass"
	
	|tmpProtocol|
	tmpProtocol := aProtocolName ifNil: [''].
	^ (tmpProtocol beginsWith: '*') not or: [ self hasPackageMatchingExtensionName:  (tmpProtocol copyWithout: $*) ]! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'GuillermoPolito 6/3/2012 01:36'!
hasPackageMatchingExtensionName: anExtensionName

	|tmpPackage tmpPackageName|
	
	(self hasPackageExactlyMatchingExtensionName: anExtensionName)
		ifTrue: [ ^true ].
	
	^packages keys anySatisfy: [:aSymbol | aSymbol asString,'*'  match: anExtensionName ].
	! !

!RPackageOrganizer methodsFor: 'testing' stamp: 'IgorStasenko 8/12/2011 16:35'!
hasRegistered
	"return true if this package organizer has already registered interest to system events and Monticello changes "
	
	^ self announcer hasSubscriber: self
	
	"|actionSequence|
	self announcer subscriptions ifNil: [^ true].
	actionSequence := self announcer subscriptions values 
								detect: [:each | each anySatisfy: [:anAction | anAction receiver = RPackage organizer]] ifNone: [nil].
	self flag: #cyril.
	^ (actionSequence isNil not) and: [(MCWorkingCopy myDependents includes: self)]"! !

!RPackageOrganizer methodsFor: 'initialize-release' stamp: 'cyrilledelaunay 5/30/2011 17:30'!
importFromPackageInfo: info

	"PackageInfo lazy-initialize itself from all existing categories in the system. It can happen that we ask him for a non registered PackageInfo, and in this case it will just have to create a new PackageInfo with the right name. Then accessing the classes, methods is done throught the system interface, so no cache to update. It is not the same for RPackage. As rpackage initialize itself from package info, some categories can not been yet registered in RPackageOrganizer, which can be more problematic. For now we could create a packageInfo and import a new RPackage using the packageInfo interface (which is simplier than accessing categories then classes then methods, check what are extensions , ... )"
	|package|
	package := self ensureExistAndRegisterPackageNamed: info packageName.
			"My problem here: If a package appear here after one of its subcategories, all classes and methods would be re-affected to this package instead of the subcatagory. That's why I focus only on classes and methods that are not defined in subcategories, to avoid to override information set before"
			info classesNotDefinedInSubCategories  
				do: [ :each | package addClassDefinition: each ].
			info coreMethodsNotDefinedInSubCategories do: [ :each |
				"it seems that PackageInfo does not count methods from a trait inside the class package. We should do the same, as monticello expect this behavior"
				(each isValid and: [each isLocalSelector])
					ifTrue: [ package addMethod: each compiledMethod ] ].
			info extensionMethodsFromAllSystem  do: [ :each |
				"it seems that PackageInfo does not count methods from a trait inside the class package. We should do the same, as monticello expect this behavior"
				(each isValid and: [each isLocalSelector])
					ifTrue: [ package addMethod: each compiledMethod ]
					].
				
		^ package! !

!RPackageOrganizer methodsFor: 'deprecated' stamp: 'BenjaminVanRyseghem 4/17/2011 16:37'!
includesClass: aClass
	self deprecated: 'use includesPackageBackPointerForClass:'. 
	^ self includesPackageBackPointerForClass: aClass! !

!RPackageOrganizer methodsFor: 'deprecated' stamp: 'StephaneDucasse 4/13/2011 20:10'!
includesClassNamed: aSymbol
	self deprecated: 'Use includesPackageBackPointerForClassNamed: aSymbol'.
	
	^ self includesPackageBackPointerForClassNamed: aSymbol ! !

!RPackageOrganizer methodsFor: 'testing' stamp: 'StephaneDucasse 4/13/2011 20:14'!
includesPackage: aPackage
	"Answer whether the receiver get a package as registered."
	^ self includesPackageNamed: aPackage name! !

!RPackageOrganizer methodsFor: 'private testing' stamp: 'BenjaminVanRyseghem 4/17/2011 16:50'!
includesPackageBackPointerForClass: aClass

	^ classPackageMapping includesKey: aClass instanceSide name asSymbol! !

!RPackageOrganizer methodsFor: 'private testing' stamp: 'BenjaminVanRyseghem 4/17/2011 16:46'!
includesPackageBackPointerForClassNamed: aSymbol

	^ classPackageMapping includesKey: aSymbol asSymbol! !

!RPackageOrganizer methodsFor: 'testing' stamp: 'StephaneDucasse 4/13/2011 22:57'!
includesPackageNamed: aSymbol
	"Answer whether the receiver get a package named aSymbol as registered."
	^ packages includesKey:  aSymbol asSymbol! !

!RPackageOrganizer methodsFor: 'initialize-release' stamp: 'StephaneDucasse 4/24/2011 17:31'!
initialize
	super initialize.
	packages := IdentityDictionary new.
	classPackageMapping := IdentityDictionary new.
	classExtendingPackagesMapping := IdentityDictionary new.
	debuggingName := ''.
	self defineUnpackagedClassesPackage! !

!RPackageOrganizer methodsFor: 'initialize-release' stamp: 'StephaneDucasse 6/2/2012 19:45'!
initializeFromSystem
	""
	| package |
	self allManagers 
		do: [ :workingCopy |
			| info |
			info := workingCopy packageInfo.
			package := self ensureExistAndRegisterPackageNamed: info packageName.
			"My problem here: If a package appear here after one of its subcategories, all classes and methods would be re-affected to this package instead of the subcatagory. That's why I focus only on classes and methods that are not defined in subcategories, to avoid to override information set before"
			info classesNotDefinedInSubCategories  
				do: [ :each | package addClassDefinition: each ].
			info coreMethodsNotDefinedInSubCategories do: [ :each |
				each isValid
					ifTrue: [ package addMethod: each compiledMethod ] ].
			info extensionMethods  do: [ :each |
				each isValid
					ifTrue: [ package addMethod: each compiledMethod ] ] ]
		displayingProgress: 'Importing from MC managers'
	"strange PackageOrganizer default packages size is not equal to MCWorkingCopy allManagers size
	MCWorkingCopy allManagers size = PackageOrganizer default packages size.
	But MCWorkingCopy allManagers size is equal to RPackageOrganizer size (minus the defaylt package):
	MCWorkingCopy allManagers size = (RPackageOrganizer default packages reject: [:each | each name = '_DefaultPackage']) size.
	
	Let see what are the packages that are not registered in RPackage.
	PackageOrganizer default packages reject: [:each | RPackageOrganizer default includesPackageNamed: each packageName asSymbol].
	"
	
! !

!RPackageOrganizer methodsFor: 'initialize-release' stamp: 'cyrilledelaunay 5/30/2011 17:30'!
initializeFromSystemStartingFromPackageOrganizer
	"this method will do the same job than initializeFromSystem except that it will start from all packages in the package organizer, instead of the ones of Monticello. Even when starting from the workingCopies of monticello, we ask to the corresponding package info to retrrieve information. Moreover, monticello does not refer all packages in packageOrganizer (surely because of some sub-categories not yet taken into account)"
	| package |
	PackageOrganizer default packages copy
		do: [ :aPackageInfo |
			| info |
			info := aPackageInfo.
			"PackageOrganizer contains a quite special packageInfo used by monticello test. It is subclass of MCDirtyPackageInfo. Its instance variable is initialized as #'Monticello-Mocks' but MCDirtyPackageInfo>> packageName return another name. The tests expect to have #'Monticello-Mocks' as name: "
			info methodCategoryPrefix = '*mcdirtypackage' ifTrue: [
				self ensureExistAndRegisterPackageNamed:   #'Monticello-Mocks'
				].
			self importFromPackageInfo: info]
		displayingProgress: 'Importing from PackageOrganizer'
	"strange PackageOrganizer default packages size is not equal to MCWorkingCopy allManagers size
	MCWorkingCopy allManagers size = PackageOrganizer default packages size.
	But MCWorkingCopy allManagers size is equal to RPackageOrganizer size (minus the defaylt package):
	MCWorkingCopy allManagers size = (RPackageOrganizer default packages reject: [:each | each name = '_DefaultPackage']) size.
	
	Let see what are the packages that are not registered in RPackage.
	PackageOrganizer default packages reject: [:each | RPackageOrganizer default includesPackageNamed: each packageName asSymbol].
	"
	
	! !

!RPackageOrganizer methodsFor: 'mc synchronization tofix' stamp: 'StephaneDucasse 6/2/2012 19:37'!
isDefinedAsPackageOrSubPackageInMC: aSymbol
	"a category has been added. 
	#'AST-Core'
	Now the question is to know whether AST-Core already exists as a package.
	"
	"self default isDefinedAsPackageOrSubPackageInMC: #Compression"
	"self default isDefinedAsPackageOrSubPackageInMC: #'Compression-Archives'"
	"self default isDefinedAsPackageOrSubPackageInMC: #'Collections'"
	"self default isDefinedAsPackageOrSubPackageInMC: #'Collections-Unordered'"
	"self default isDefinedAsPackageOrSubPackageInMC: #'Collections-Unordered-Test'"
	^ self allManagers 
			anySatisfy: [:each | self category: each packageName asSymbol matches: aSymbol ] ! !

!RPackageOrganizer methodsFor: 'mc synchronization tofix' stamp: 'StephaneDucasse 6/2/2012 19:38'!
isDefinedPackageInMC: aSymbol
	"Answer whether a package is already defined with the exact name"
	"self default isDefinedAsSubPackageInMC: #Compression"
	"self default isDefinedAsSubPackageInMC: #'Compression-Archives'"
	^ self allManagers anySatisfy: [:each | each packageName asSymbol = aSymbol]! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'StephaneDucasse 6/3/2012 22:42'!
packageClass
	"Return the system class that represent packages."
	
	^ RPackage
	! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'tg 3/13/2010 16:39'!
packageDefiningOrExtendingMethod: aCompiledMethod
	^ self packageDefiningOrExtendingSelector: aCompiledMethod selector inClass: aCompiledMethod methodClass
! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'cyrilledelaunay 5/10/2011 12:26'!
packageDefiningOrExtendingSelector: aSelector inClass: aClass
	"this implementation is slower
		aClass packages detect: [:each | each includesSelector: aSelector ofClass: aClass ]"

	
	^ (aClass packages) detect: [:each | each includesSelector: aSelector ofClass: aClass ] ifNone: [
		"if we do not find in the packages of the class, it means that the method is coming from a trait: "
		|tmpTrait|
		tmpTrait := (aClass traitComposition traitProvidingSelector: aSelector).
		(aClass traitComposition traitProvidingSelector: aSelector) packages detect: [:each |
			each includesSelector: aSelector ofClass: tmpTrait.   
			].
		]
	
"	self packages detect: [:each | 
		each includesSelector: aSelector ofClass: aClass ].
"	
	! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'GuillermoPolito 5/29/2012 13:47'!
packageDefiningOrExtendingSelector: aSelector inClassNamed: aClassNameSymbol
	"this implementation is slower
		aClass packages detect: [:each | each includesSelector: aSelector ofClass: aClass ]"
	| classPackage |
	
	classPackage := self packageOfClassNamed: aClassNameSymbol.
	(classPackage includesSelector: aSelector ofClassName: aClassNameSymbol)
		ifTrue: [ ^classPackage ].
		
	^(self extendingPackagesOfClassNamed: aClassNameSymbol)
		detect: [ :p | p includesSelector: aSelector ofClassName: aClassNameSymbol ]
		ifNone: [ self error: ('No package found for selector {1} in class {2}' 
									format: { aSelector . aClassNameSymbol }) ]! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'GuillermoPolito 5/29/2012 14:00'!
packageDefiningOrExtendingSelector: aSelector inMetaclassNamed: aClassNameSymbol
	"this implementation is slower
		aClass packages detect: [:each | each includesSelector: aSelector ofClass: aClass ]"
	| classPackage |
	
	classPackage := self packageOfClassNamed: aClassNameSymbol.
	(classPackage includesSelector: aSelector ofMetaclassName: aClassNameSymbol)
		ifTrue: [ ^classPackage ].
		
	^(self extendingPackagesOfClassNamed: aClassNameSymbol)
		detect: [ :p | p includesSelector: aSelector ofMetaclassName: aClassNameSymbol ]
		ifNone: [ self error: ('No package found for selector {1} in class {2}' 
									format: { aSelector . aClassNameSymbol }) ]! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'StephaneDucasse 4/13/2011 20:18'!
packageExactlyMatchingExtensionName: anExtensionName
	"only look for a package for which the name match 'anExtensionName', making no difference about case. Return nil if no package is found"
	
	|tmpPackage tmpPackageName|
	packages keys do: [:aSymbol |
		(aSymbol sameAs: anExtensionName asSymbol)
			ifTrue: [ tmpPackage := self packageNamed: aSymbol ]].
	^ tmpPackage! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'cyrilledelaunay 5/13/2011 13:46'!
packageForProtocol: aProtocolName inClass: aClass
	"According aProtocolName is an extension protocol, will look for a matching package. If no matching package is found ,  return nil. If aProtocolName is not an extension protocol, return the parent package of aClass"
	
	|tmpProtocol|
	tmpProtocol := aProtocolName ifNil: [''].
	^ (tmpProtocol beginsWith: '*')
		ifTrue: [  (self packageMatchingExtensionName:  (tmpProtocol copyWithout: $*)) ]
		ifFalse: [ aClass package ]! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'cyrille.delaunay 11/25/2010 13:40'!
packageMatchingExtensionName: anExtensionName

	"return nil if no package i found"
	|tmpPackage tmpPackageName|
	"we first look if their is a package matching exactly the name specified"
	packages keys do: [:aSymbol |
		(aSymbol sameAs: anExtensionName asSymbol)
			ifTrue: [^ self packageNamed: aSymbol]
		].
	
	"if no package was found, we try to find one matching the begining of the name specified"
	tmpPackageName := ''.
	packages keys do: [:aSymbol |
		(aSymbol asString,'*'  match: anExtensionName)
			ifTrue: [
				"we keep the longest package name found"
				(aSymbol size > tmpPackageName size) ifTrue: [
					tmpPackageName := aSymbol.
					tmpPackage := self packageNamed: aSymbol
					].
				]
		].
	^ tmpPackage! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'BenjaminVanRyseghem 4/17/2011 16:54'!
packageNamed: aSymbol

	^ packages at: aSymbol asSymbol! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'cyrilledelaunay 2/3/2011 17:27'!
packageNamed: aSymbol  ifAbsent: errorBlock

	^ packages at: aSymbol ifAbsent: errorBlock! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'stephane.ducasse 7/16/2009 23:17'!
packageNames
	^ packages keys! !

!RPackageOrganizer methodsFor: 'package access from class' stamp: 'StephaneDucasse 6/3/2012 22:42'!
packageOf: aClass

	^ classPackageMapping 
		at: aClass theNonMetaClass originalName
		ifAbsent: [self packageNamed: self packageClass defaultPackageName]! !

!RPackageOrganizer methodsFor: 'package access from class' stamp: 'StephaneDucasse 4/29/2011 21:04'!
packageOfClassNamed: aName

	self flag: self. "shouldProbablyReturnUnunpackagedPackage instead of nil"
	^ classPackageMapping at: aName asSymbol ifAbsent: [nil]! !

!RPackageOrganizer methodsFor: 'accessing' stamp: 'stephane.ducasse 7/10/2009 11:27'!
packages
	
	^ packages values! !

!RPackageOrganizer methodsFor: 'printing' stamp: 'StephaneDucasse 4/24/2011 17:33'!
printOn: aStream

	super printOn: aStream.
	debuggingName ifNotNil: [aStream nextPutAll: debuggingName ].  ! !

!RPackageOrganizer methodsFor: 'initialize-release' stamp: 'EstebanLorenzano 5/21/2012 17:50'!
register

	"self registerInterestToMC."
	self registerInterestToSystemAnnouncement.! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'sd 5/21/2010 14:44'!
registerExtendingPackage: aPackage forClass: aClass 

	| cur |
	cur := classExtendingPackagesMapping at: aClass theNonMetaClass name ifAbsent: [nil].
	cur isNil
		ifTrue: [classExtendingPackagesMapping at: aClass theNonMetaClass name put: (Set with: aPackage)]
		ifFalse: [cur add: aPackage]! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'cyrille.delaunay 11/24/2010 14:06'!
registerExtendingPackage: aPackage forClassName: aClassName 

	| cur |
	cur := classExtendingPackagesMapping at: aClassName asSymbol ifAbsent: [nil].
	cur isNil
		ifTrue: [classExtendingPackagesMapping at: aClassName asSymbol put: (Set with: aPackage)]
		ifFalse: [cur add: aPackage]! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'EstebanLorenzano 8/3/2012 14:09'!
registerInterestToAnnouncer: anAnnouncer	
	"There should be only one"
	anAnnouncer unsubscribe: self.
	
	" Announcer initialize"
	self flag: #todo. "Fiinish monticello integration (commented below)"
	
	anAnnouncer weak
		on: CategoryAdded send: #systemCategoryAddedActionFrom: to: self;
		on: CategoryRemoved send: #systemCategoryRemovedActionFrom: to: self;
		on: CategoryRenamed send: #systemCategoryRenamedActionFrom: to: self;
		on:  ClassAdded send: #systemClassAddedActionFrom: to: self;
		on:  ClassCommented do: [:ann | 
				 "Only re-emit public corresponding announcement"
			"Not yet implemented?"
			];
		on:  ClassRecategorized send: #systemClassRecategorizedActionFrom: to: self;
		on:  ClassRemoved send: #systemClassRemovedActionFrom: to: self;
		on:  ClassRenamed send: #systemClassRenamedActionFrom: to: self;
		on:  ClassReorganized send: #systemClassReorganizedActionFrom: to: self;
		on:  MethodAdded send: #systemMethodAddedActionFrom: to: self;
		on:  MethodModified send: #systemMethodModifiedActionFrom: to: self;
		on:  MethodRecategorized send: #systemMethodRecategorizedActionFrom: to: self;
		on:  MethodRemoved send: #systemMethodRemovedActionFrom: to: self;
		on:  ProtocolAdded send: #systemProtocolAddedActionFrom: to: self;
		on:  ProtocolRemoved send: #systemProtocolRemovedActionFrom: to: self;
		"Monticello announcements (old protocol)"
"		on: MCVersionCreated send: #update: to: self;
		on: MCPackageModified send: #update: to: self;"
		on: MCWorkingCopyCreated send: #updateAfterNewMCPackageRegistred: to: self;
		on: MCWorkingCopyDeleted send: #updateAfterNewMCPackageUnregistred: to: self	
		! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'GuillermoPolito 7/31/2012 11:59'!
registerInterestToSystemAnnouncement
	"self registerInterestToSystemAnnouncement"
	<systemEventRegistration>
	
	self registerInterestToAnnouncer: self announcer! !

!RPackageOrganizer methodsFor: 'public registration' stamp: 'IgorStasenko 8/12/2011 16:36'!
registerPackage: aPackage
	"A new package is now available and declared in the receiver. "
	
	
	self basicRegisterPackage: aPackage.
	aPackage extendedClasses do: [ :extendedClass|
			self registerExtendingPackage: aPackage forClass: extendedClass].
	aPackage definedClasses do: [ :definedClass|
			self registerPackage: aPackage forClass: definedClass].
	self announcer announce: (RPackageCreated to: aPackage).
	^ aPackage! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'cyrille.delaunay 11/25/2010 15:08'!
registerPackage: aPackage forClass: aClass 
	(aPackage includesClass: aClass) 
		ifFalse: 
			[self error: aPackage name , ' does not includes the class ' , aClass name].
	^classPackageMapping at: aClass theNonMetaClass name put: aPackage! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'StephaneDucasse 4/13/2011 18:50'!
registerPackage: aPackage forClassName: aClassNameSymbol
	"Register aPackage as the package of the class aClassNameSymbol. The package should contain the class in its class definitions."
	
	(aPackage includesClassNamed: aClassNameSymbol asSymbol) 
		ifFalse: 
			[self error: aPackage name , ' does not include the class ' , aClassNameSymbol].
	^classPackageMapping at: aClassNameSymbol put: aPackage! !

!RPackageOrganizer methodsFor: 'renaming' stamp: 'MarianoMartinezPeck 6/16/2012 23:59'!
renamePackage: aPackage in: aString

	| classes oldPackageName |
	(packages includesKey: aString asSymbol)
		ifTrue: [ ^ self openAlreadyExistingError ].

	oldPackageName := aPackage name.
	classes := aPackage definedClasses.
	classes do: [:class |
		class category: aString ].	
	self unregisterPackage: aPackage.
	aPackage name: aString.
	self registerPackage: aPackage.
	aPackage extensionMethods do: [ :aMethod | 
		| aProtocol |
		aProtocol := aMethod methodClass organization categoryOfElement: aMethod selector.
		aMethod methodClass organization renameCategory: aProtocol asSymbol 
					toBe: (aProtocol copyReplaceAll: oldPackageName with: aString) asSymbol.
	].
	
	classes do: [:class |
		class category: aString ].
	
	^ aPackage! !

!RPackageOrganizer methodsFor: 'private' stamp: 'cyrilledelaunay 5/30/2011 16:22'!
reportBogusBehaviorOf: aSelector

	self logCr: 'RPackage log: Something wrong around ', aSelector asString , 'since the removeKey: is called on not present information.'.! !

!RPackageOrganizer methodsFor: 'private' stamp: 'cyrilledelaunay 5/30/2011 16:15'!
reportExtraRemovalOf: aClass

	self logCr:  'The class ',  aClass name printString, 'is removed twice'; cr.! !

!RPackageOrganizer methodsFor: 'mc synchronization tofix' stamp: 'StephaneDucasse 4/29/2011 20:59'!
shouldDefineAPackage: aSymbol
	"we should define a package if it is not created and it correspond to an MC package"
	"now this is not clear that we need that since an MC package is only created after creating a category"
	"Watch out!! Not tested"
	
	^ (self includesPackageNamed: aSymbol)
			ifTrue: [false]
			ifFalse: [ (self isDefinedPackageInMC: aSymbol) 
						ifTrue: [ true]
						ifFalse: [ (self isDefinedAsPackageOrSubPackageInMC: aSymbol)]]! !

!RPackageOrganizer methodsFor: 'private' stamp: 'CamilleTeruel 7/29/2012 18:47'!
stopNotification
	"(self instVarNamed: #default) stopNotification"
	
	"pay attention that we can break the system using this method"
	
	SystemAnnouncer uniqueInstance unsubscribe: self.
	MCWorkingCopy removeDependent: self.! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'EstebanLorenzano 8/7/2012 11:24'!
systemCategoryAddedActionFrom: ann

	| rPackage packageSymbol |
	self flag: #fixMe. "a categoryName should always be a symbol, but for some reason it is keeping a string some times" 
	packageSymbol := ann categoryName asSymbol.
	(self includesPackageNamed: packageSymbol)
		ifFalse: [ 
			rPackage := self packageClass named: packageSymbol.
			self registerPackage: rPackage ]! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'EstebanLorenzano 8/7/2012 11:10'!
systemCategoryRemovedActionFrom: ann

	| rPackage categoryNameSymbol |
	categoryNameSymbol := ann categoryName asSymbol.
	"here we check that a corresponding MCPackage does not still exist. In this case we should keep the RPackage"
	self allManagers detect: [:each | self category: each packageName matches: categoryNameSymbol asString] ifNone: [
		rPackage := packages at: categoryNameSymbol ifAbsent: [^ self].
		"if no MCPackage exist, we unregister the package from the RPackageOrganizer"
		self basicUnregisterPackageNamed: categoryNameSymbol.	
		].
	
! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'GuillermoPolito 8/3/2012 14:39'!
systemCategoryRenamedActionFrom: ann

	| rPackage classesAndProtocolsToRename|
	"we update the rpackage itself with the new name"
	rPackage := self packageNamed: ann oldCategoryName asSymbol ifAbsent: [self packageClass new].
	rPackage name: ann newCategoryName.
	
	"we update the organizer"
	packages at: ann newCategoryName asSymbol put: rPackage.
	packages removeKey: ann oldCategoryName asSymbol ifAbsent: [self reportBogusBehaviorOf:   #systemCategoryRenamedActionFrom: ].
	self flag: #cyrille. "Should we not update the backPointer mapping too?"
	"CD: What do you mean by backpointerMapping? By telling a RPackage to rename itself, it should update itself all its internal. 
	Then it just left all references in the organizer to update. For now I see the 'packages' variable. "
	
	"we also rename all the extension protocols in the system with the new name"
	classesAndProtocolsToRename := (rPackage extensionMethods collect: [:aCompiledMethod |
		aCompiledMethod methodClass -> aCompiledMethod category
		]) asSet.
	classesAndProtocolsToRename do: [:anAssociation |
		anAssociation  key organization silentlyRenameCategory:  anAssociation  value toBe: '*', ann newCategoryName
		].
		
! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'GuillermoPolito 8/3/2012 14:25'!
systemClassAddedActionFrom: ann

	| class rPackage categoryNameSymbol |
	class := ann classAffected.
	categoryNameSymbol := class category.
	rPackage := packages at: categoryNameSymbol ifAbsent: [
		"a class may be defined for a package that does not yet exist. In this case we have to create first the new package"
		self registerPackage: (self packageClass named: categoryNameSymbol).
		].		
	"when we add the class, the parent category should normally already be register correctly at the RPackageOrganizer"
	"this next line should import the class and all its methods: "
	rPackage importClass: class.
	rPackage importClass: class theMetaClass
	"maybe the last update should be (is?) automatically done when adding or removing from a RPackage."
	"self default registerPackage: rPackage forClass: class"
	"maybe have to check for class and metaClass that will maybe both throw an event?
	=> seems to be correctly handled by RPackage"! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'GuillermoPolito 8/3/2012 14:29'!
systemClassRecategorizedActionFrom: ann

	| class newRPackage oldRPackage newCategoryName oldCategoryName|
	"self flag: 'seems to be ok'."
	class := ann classAffected.	
	newCategoryName := ann newCategory asSymbol.
	oldCategoryName := ann oldCategory asSymbol.
	oldRPackage := self packageNamed: oldCategoryName.
	newRPackage := self packageNamed: newCategoryName ifAbsent: [
		"temporary code. For now adding a new category in the system does not emit correctly the corresponding event. The organizer is therefore not able to update itself. So here, if we don't find a matching package, we create a new one"
		self registerPackage: (self packageClass named: newCategoryName)
		].
	"we have to update the old package"
	oldRPackage removeClass: class.	
	"we have to update the new package"
	newRPackage importClass: class.
	"we should also import the metaClass"
	newRPackage importClass: class theMetaClass	
	
	
	"we have to update the RPackageOrganizer.
	maybe the last update should be automatically done when adding or removing from a RPackage
	"
	"self default unregisterPackage: oldRPackage forClass: class.
	self default registerPackage: newRPackage forClass: class"! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'GuillermoPolito 8/5/2012 13:27'!
systemClassRemovedActionFrom: ann
	"A class has been removed, we should update the package adequately."
	
	| class className rPackage categoryName |	
	class := ann classRemoved.
	className  := class originalName.
		
	self fullyRemoveClassNamed: className.
	! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'GuillermoPolito 8/3/2012 14:27'!
systemClassRenamedActionFrom: ann
	"When a class is renamed, we update its package as well as the organizer"
	
	| newName oldName class rPackage extendingRPackages packageName |
	class := ann classAffected.
	packageName := ann category.
	oldName := ann oldName.
	newName := ann newName.
	rPackage := self packageNamed: packageName.
	extendingRPackages := self extendingPackagesOfClassNamed: oldName.
	
	rPackage updateDefinedClassNamed: oldName withNewName: newName.
	"we have to update all RPackages extending this class"
	extendingRPackages do: [:aRPackage | 
		aRPackage updateExtensionForClassNamed: oldName withNewName: newName].
		
	"we have to update the RPackageOrganizer.
	update the 'classPackageDictionary' to replace the key with the new class name"
	self unregisterPackage: rPackage forClassName: oldName.
	self registerPackage: rPackage forClassName: newName.	
		
	"update the 'classExtendingPackagesMapping' to replace the key with the new class name"
	extendingRPackages do: [:aRPackage |
		self unregisterExtendingPackage: aRPackage forClassName: oldName.
		self registerExtendingPackage:  aRPackage forClassName: newName   
		].
	self flag: #cyrille. "we will see that."
	"maybe we should remove also the key from the extendedPackages dictionary"
	"CD: This is what are doing the lines above I think"

	! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'cyrilledelaunay 5/10/2011 13:46'!
systemClassReorganizedActionFrom: ann
	"when a class is reorganized, we have to check if an extension has not been added"
	
	|class|
	self flag: 'Not sure this method is usefull. If we remove a category, it seems that we will remove the methods inside, therefore the remove method announcement will do the job. Then all other modifications does not impact the packages'.
	"CD: All tests pass with this version"
	"The event ReorganizedEvent is lauched for several cases:
		- we rename a protocol (see 'renameCategory:toBe: '). if The category is not empty, SystemMethodRecategorizedAnnouncement will also be emitted // THE WORK WILL BE DONE BY  SystemMethodRecategorizedAnnouncement
		- we sort (modify the order of) protocols (see 'sortCategories') // WE DON'T CARE HERE
		- we add a protocol (see 'addCategory:before:') // WE DON'T CARE HERE'
		- we remove a protocol (see 'removeCategory:' 'removeEmptyCategories') // THE WORK SHOULD BE DONE BY  SystemMethodRemovedAnnouncement
	".
! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'GuillermoPolito 8/3/2012 14:18'!
systemClassReorganizedActionFromBis: ann
	"only to keep old code somewhere"
	"when a class is reorganized, we have to check if an extension has not been added"
	
	|class|
	self flag: 'Not sure this method is usefull. If we remove a category, it seems that we will remove the methods inside, therefore the remove method announcement will do the job. Then all other modifications does not impact the packages'.
	"The event ReorganizedEvent is lauched for several cases:
		- we rename a protocol (see 'renameCategory:toBe: '). if The category is not empty, SystemMethodRecategorizedAnnouncement will also be emitted // THE WORK WILL BE DONE BY  SystemMethodRecategorizedAnnouncement
		- we sort (modify the order of) protocols (see 'sortCategories') // WE DON'T CARE HERE
		- we add a protocol (see 'addCategory:before:') // WE DON'T CARE HERE'
		- we remove a protocol (see 'removeCategory:' 'removeEmptyCategories') // THE WORK SHOULD BE DONE BY  SystemMethodRemovedAnnouncement
		
		
	So the work here is quite big :) The event only provide a reference to the class that has been modified. So I guess we have to:
		=> we check that each extending rPackage contain all methods from the corresponding extension category (as extension methods)
		=> the parentPackage of the class includes all methods defined in classic categories
	".
	class := ann methodClass.
	class organization categories do: [:aString |
		(aString beginsWith: '*')
			ifTrue: [
				"here we deal with extension-categories"
				|extendingPackageName extendingPackage|
				extendingPackageName := aString copyWithout: $*.
				extendingPackage := self packageMatchingExtensionName: extendingPackageName.
				extendingPackage ifNotNil: [
					"we check that all extension method for this classs in the rpackage correspond to all methods in the extension category"
					(class methodsInCategory: aString) do: [:aMethodsSelector |
					
					"If the method origin is not the one of the event, we do not care about that method"
					(class >> aMethodsSelector) origin = ann methodClass ifFalse: [^self].
						((extendingPackage extensionMethodsForClass: class) includes: (class methodDict at: aMethodsSelector))
							ifFalse: [
								"if a method has not been yet registered in the rPackage, we add it"
								((class methodDict at: aMethodsSelector) packageFromOrganizer: self ) removeMethod: (class methodDict at: aMethodsSelector).
								extendingPackage addMethod: (class methodDict at: aMethodsSelector).
								]  
						]
					]
				]
			ifFalse: [
				"here we deal with classic categories"
				(class methodsInCategory: aString) do: [:aMethodSelector |
					"aMethodSelector can come from a trait used by class. Such a method should always belong to to the trait and therefore to the parent package of the trait"
					(class traitOrClassOfSelector: aMethodSelector) = class ifFalse: [^self].
					((class package definedMethodsForClass: class) includes: (class methodDict at: aMethodSelector ) )
						ifFalse: [
							((class methodDict at: aMethodSelector) packageFromOrganizer: self) removeMethod: (class methodDict at: aMethodSelector).
							class package addMethod: (class methodDict at: aMethodSelector)
							]
					]
				]
			
		].
	! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'GuillermoPolito 8/3/2012 14:18'!
systemMethodAddedActionFrom: ann

	|class selector protocol method rPackage |

	class := ann methodClass.
	protocol := ann protocol ifNil: [ '' ].
	selector := ann selector.
	method := ann method.
	
	"If the method origin is not the one of the event, we do not care about that method"
	method origin = ann methodClass ifFalse: [^ self].
	
	"we have to register the method in the parent RPackage of the class. 
	to do that, we first have to look if the method is an extension from an external package:"
	"1) in some cases, it can happen that protocol is nil (I do not know yet when). That's why we first check if protocol is nil. If it is, we just add the method worrying about anything. 
	This case can happen for exemple when running MCMethodDefinitionTest >> #testLoadAndUnload. Comment the nil check and should get an error."
	"This case come from CompiledMethod >> packageFromOrganizer:"
	
	rPackage := (self hasPackageForProtocol: protocol inClass: method methodClass) 
			ifTrue: [ self packageForProtocol: protocol inClass: method methodClass ]
			ifFalse: [ self registerPackage: (self packageClass named: (protocol copyWithout: $*)) ].
	rPackage addMethod: method.
	
	
	! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'GuillermoPolito 8/3/2012 14:18'!
systemMethodModifiedActionFrom: ann

	"this annoucement can correspond to several kind of modifications:
		=> a method has been renamed
		=> a method has been move to another category // SHOULD BE TREATED WITH SystemMethodRecategorizedEvent
		(
			-maybe from the classic category to an extending package
			-maybe from an extending package to another extending package
			-maybe from an extending package to a classic category
			- maybe from a classic category to another classic category
			)
	"
	| oldMethod newMethod methodPackage |
	newMethod := ann newMethod.
	oldMethod := ann oldMethod.
	self flag: #cyrille. 
	"This is not clear that we need to do soemthing here since the method is removed and added so the other events should be handled correctly
	We should remove this method to see if this is working."
	
	"If the method origin is not the one of the event, we do not care about that method"
	newMethod origin = ann methodClass ifFalse: [^ self].

	methodPackage := newMethod packageFromOrganizer: self.
	"maybe the name of the method has changed"
	oldMethod selector = newMethod selector
		ifFalse: [ methodPackage updateSelector: oldMethod selector inClass: oldMethod methodClass withNewSelector: newMethod selector].
		

	! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'GuillermoPolito 8/3/2012 13:38'!
systemMethodRecategorizedActionFrom: ann
	"a protocol has been renamed
	a method has been removed. // WILL BE TREATED WITH SystemMethodRemovedAnnouncement
	a method has been moved to another category 
		-maybe from the classic category to an extending package
		-maybe from an extending package to another extending package
		-maybe from an extending package to a classic category
		- maybe from a classic category to another classic category"
		
	|oldProtocol newProtocol method methodPackage destinationPackage|
	self flag: #cyrille.
	oldProtocol := ann oldProtocol.
	"old protocol might be nil:"
	oldProtocol asString ifNil: [oldProtocol := ''].
	newProtocol := ann  newProtocol.
	method := ann methodRecategorized.
	
	"1). See compiledMethod >> packageFromOrganizer:"
	
	"we have to pay attention that this announcement can come from TraitDescription>>updateOrganizationSelector:oldCategory:newCategory: . In this context, it can happen that the method referenced by the event is nil. In this case I think we should change nothing"
	
	
	method isNil ifFalse: [
		"If the method origin is not the one of the event, we do not care about that method"
		method origin = ann methodClass ifFalse: [^ self].
		
		methodPackage := method packageFromOrganizer: self.
		"if newProtocol is nil, it means that we are in a 'methodRemoved' case. Nothing should be modified (all the work will be done when catching methodRemovedAnnouncement) " 
		newProtocol isNil ifTrue: [^self].
		"it can happen that oldProtocol is Nil. in this case we should do nothing"
		oldProtocol ifNil: [^ self].
		"maybe the category has changed"
		newProtocol asLowercase = oldProtocol asLowercase
			ifFalse: [
				"according the extension specified is valid or not, the method will be defined as an extension of an external package or in the class parent package"
				destinationPackage := (self hasPackageForProtocol: newProtocol inClass: method methodClass)
					ifTrue: [ self packageForProtocol: newProtocol inClass: method methodClass ]
					ifFalse: [ method methodClass package ].
				methodPackage := (self hasPackageForProtocol: oldProtocol inClass: method methodClass)
					ifTrue: [ self packageForProtocol: oldProtocol inClass: method methodClass ]
					ifFalse: [ method methodClass package ].

				"then, we will remove the method from the method package, and add it to the destination package (we check before that the source package and the destination package are different)."
				methodPackage = destinationPackage
					ifFalse: [
						methodPackage removeMethod: method.
						destinationPackage addMethod: method
						]
				]
		]
	
	! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'GuillermoPolito 8/5/2012 13:28'!
systemMethodRemovedActionFrom: ann

	| method methodPackage |
	method := ann methodAffected.
	"If the method origin is not the one of the event, we do not care about that method"
	method origin = ann methodClass ifFalse: [^ self].

	ann methodClass isMeta
		ifFalse: [ 
			methodPackage := self packageDefiningOrExtendingSelector: ann selector inClassNamed: ann methodClass theNonMetaClass originalName.
			methodPackage removeSelector: ann selector ofClassName: ann methodClass theNonMetaClass originalName.
		]
		ifTrue: [ 
			methodPackage := self packageDefiningOrExtendingSelector: ann selector inMetaclassNamed: ann methodClass theNonMetaClass originalName.
			methodPackage removeSelector: ann selector ofMetaclassName: ann methodClass theNonMetaClass originalName.
		]! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'cyrille.delaunay 11/18/2010 11:42'!
systemProtocolAddedActionFrom: ann

	"for now I don't see anything to do'"! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'cyrilledelaunay 5/13/2011 13:53'!
systemProtocolRemovedActionFrom: ann
	"to be unregistered"
	
	! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'StephaneDucasse 4/13/2011 21:16'!
systemTraitDefinitionModifiedActionFrom: ann
	"this kind of anounecement will be used when:
		=> we create a new trait.
		=> we declare new traits to use in a trait"
	|trait|
	trait := ann itemTrait.
	! !

!RPackageOrganizer methodsFor: 'initialize-release' stamp: 'EstebanLorenzano 8/3/2012 14:09'!
unregister
	SystemAnnouncer uniqueInstance unsubscribe: self.! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'sd 5/19/2010 16:13'!
unregisterExtendingPackage: aPackage forClass: aClass
	
	| cur |
	cur := classExtendingPackagesMapping at: aClass theNonMetaClass name ifAbsent: [nil].
	cur isNil
		ifFalse: [cur remove: aPackage ifAbsent: [] "not happy with this one"]! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'cyrille.delaunay 11/24/2010 14:06'!
unregisterExtendingPackage: aPackage forClassName: aClassName
	
	| cur |
	cur := classExtendingPackagesMapping at: aClassName asSymbol ifAbsent: [nil].
	cur isNil
		ifFalse: [cur remove: aPackage ifAbsent: [] "not happy with this one"]! !

!RPackageOrganizer methodsFor: '*RPackage-SystemIntegration' stamp: 'EstebanLorenzano 8/3/2012 14:09'!
unregisterInterestToSystemAnnouncement
	"self unregisterInterestToSystemAnnouncement"

	SystemAnnouncer uniqueInstance unsubscribe: self! !

!RPackageOrganizer methodsFor: 'public registration' stamp: 'IgorStasenko 8/12/2011 16:36'!
unregisterPackage: aPackage
	"Unregister the specified package from the list of registered packages. Raise the announcement RPackageUnregistered."
	
	| symbol |
	self basicUnregisterPackage: aPackage.
	aPackage extendedClasses do: [ :extendedClass|
			self unregisterExtendingPackage: aPackage forClass: extendedClass].
	aPackage definedClasses do: [ :definedClass|
			self unregisterPackage: aPackage forClass: definedClass].
	self announcer announce: (RPackageCreated to: aPackage).
	^ aPackage! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'StephaneDucasse 4/18/2011 11:37'!
unregisterPackage: aPackage forClass: aClass 
	"unregister the back pointer mapping from classes to packages."
		
	^classPackageMapping 
			removeKey: aClass theNonMetaClass name 
			ifAbsent: [Transcript show: 'here' ; cr. 
						self reportExtraRemovalOf: aClass ]! !

!RPackageOrganizer methodsFor: 'private registration' stamp: 'StephaneDucasse 4/25/2011 12:30'!
unregisterPackage: aPackage forClassName: aClassName
	"Unregister the package back pointer for a given class. The class should not belong to the package anymore before removing the back pointer."

	(aPackage includesClassNamed: aClassName asSymbol) 
		ifTrue: 
			[self error: aPackage name , ' still includes the class ' , aClassName asSymbol].
	^classPackageMapping removeKey: aClassName asSymbol ifAbsent: [self reportBogusBehaviorOf: #unregisterPackage:forClassName:  ]! !

!RPackageOrganizer methodsFor: 'public registration' stamp: 'cyrilledelaunay 5/30/2011 17:38'!
unregisterPackageNamed: symbol
	"Unregister the specified package from the list of registered packages. Raise the announcement RPackageUnregistered."
	
	| aPackage |
	aPackage := packages at: symbol asSymbol ifAbsent: [ nil].
	aPackage 
		ifNotNil: [self unregisterPackage: aPackage].
	^ aPackage! !

!RPackageOrganizer methodsFor: 'mc synchronization tofix' stamp: 'cyrilledelaunay 5/30/2011 17:30'!
update: anArray
	"User create a new package, MCWorkingCopy propagates changes. We react accordingly."
	
	super update: anArray.
	(anArray isArray and: [ anArray first = #registered ])
		ifTrue: [ | newPackage |
			"we first look if a RPackage has not yet been registered (by creating a category in the system).
			 In this case we don't want to register a new RPackage, but refer to this existing category"
			(self packageExactlyMatchingExtensionName: anArray second name) isNil
				ifTrue: [
					"if no package already exist, we add a new one"
					newPackage := self ensureExistAndRegisterPackageNamed: anArray second name.
					"a rpackage is matching exactly a sytem category. So all classes should be registered to their parent category. 
					We should not import categories" ]		
			"Probably can get a bug since we can have a package named AST and the category named AST-Core so should probably 
	pass the category as parameter"].

	(anArray isArray and: [ anArray first = #unregistered ])
		ifTrue: [ 
			"Not sure if we should remove the corresponding RPackage from the organizer. Monticello will notify a #unregistered change when we 'delete' a working copy, or when we 'unload' a workingCopy. 'Delete'  will only delete the MCWorkingCopy representing the package, but will let the category and classes existing in the system. 'Unload' will also remove all classes inside the category but will also let the category. So, for now,  in both cases it seems meaningfull to keep a RPackage pointing to the existing category. At least Monticello tests were expecting this behavior"
			"self unregisterPackageNamed: anArray second name."
			self flag: #cyrille. "shouldDoSomethingHere."
			"SD: my impression is that we should redo part of the MC browser. Delete package may move the classes to unpackaged" 
			"CD: When you 'delete' a MCPackage, it only remove the MC working copy, but let all the included classes in the system (in the same category). So now the question is: should we keep those classes in the same RPackage or move them to the #_UnpackagedPackage. As those classes are not moved to any other category for now , we could keep them in the same RPackage. 
			In any case, if deleting a MCPackage would move the classes to 'Unclassified' category, some announcement should be emitted , and RPackage should update itself ?  "
			].! !

!RPackageOrganizer methodsFor: 'mc synchronization tofix' stamp: 'EstebanLorenzano 5/21/2012 18:08'!
updateAfterNewMCPackageRegistred: anAnnouncement
	"User create a new package, MCWorkingCopy propagates changes. We react accordingly."
	| newPackage name |
	
	name := anAnnouncement package name.
"super update: anArray."
			"we first look if a RPackage has not yet been registered (by creating a category in the system).
			 In this case we don't want to register a new RPackage, but refer to this existing category"
			(self packageExactlyMatchingExtensionName: name) isNil
				ifTrue: [
					"if no package already exist, we add a new one"
					newPackage := self ensureExistAndRegisterPackageNamed:  name.
					"a rpackage is matching exactly a sytem category. So all classes should be registered to their parent category. 
					We should not import categories" ]		
			"Probably can get a bug since we can have a package named AST and the category named AST-Core so should probably 
	pass the category as parameter"! !

!RPackageOrganizer methodsFor: 'mc synchronization tofix' stamp: 'EstebanLorenzano 5/21/2012 18:05'!
updateAfterNewMCPackageUnregistred: anAnnouncement

			"Not sure if we should remove the corresponding RPackage from the organizer. Monticello will notify a #unregistered change when we 'delete' a working copy, or when we 'unload' a workingCopy. 'Delete'  will only delete the MCWorkingCopy representing the package, but will let the category and classes existing in the system. 'Unload' will also remove all classes inside the category but will also let the category. So, for now,  in both cases it seems meaningfull to keep a RPackage pointing to the existing category. At least Monticello tests were expecting this behavior"
			"self unregisterPackageNamed: anArray second name."
			self flag: #cyrille. "shouldDoSomethingHere."
			"SD: my impression is that we should redo part of the MC browser. Delete package may move the classes to unpackaged" 
			"CD: When you 'delete' a MCPackage, it only remove the MC working copy, but let all the included classes in the system (in the same category). So now the question is: should we keep those classes in the same RPackage or move them to the #_UnpackagedPackage. As those classes are not moved to any other category for now , we could keep them in the same RPackage. 
			In any case, if deleting a MCPackage would move the classes to 'Unclassified' category, some announcement should be emitted , and RPackage should update itself ?  "! !

!ClassDescription methodsFor: '*rpackage-core' stamp: 'sd 10/29/2009 20:31'!
compileSilently: code 
	"Compile the code and classify the resulting method in the given category, leaving no trail in the system log, nor in any change set, nor in the 'recent submissions' list. This should only be used when you know for sure that the compilation will succeed."

	^ self compileSilently: code classified: 'not defined category' notifying: nil.! !

!ClassDescription methodsFor: '*rpackage-core' stamp: 'StephaneDucasse 6/3/2012 22:35'!
extendingPackages
	"the extending packages of a class are the packages that extend it."
	^ RPackage organizer extendingPackagesOf: self
	! !

!ClassDescription methodsFor: '*rpackage-core' stamp: 'StephaneDucasse 4/20/2010 22:10'!
isDefinedInPackage: aPackage
	"returns true if aPackage contains the definitino of this class"
	
	^ aPackage includesClass: self.
	! !

!ClassDescription methodsFor: '*rpackage-core' stamp: 'StephaneDucasse 5/15/2010 19:54'!
isExtended

	^ self extendingPackages isEmpty! !

!ClassDescription methodsFor: '*rpackage-core' stamp: 'tg 3/16/2010 17:53'!
isExtendedInPackage: aPackage
	"returns true if aPackage defines an extension to this class"
	^ aPackage extendsClass: self.
	! !

!ClassDescription methodsFor: '*rpackage-core' stamp: 'StephaneDucasse 6/3/2012 22:35'!
package
	^ RPackage organizer packageOf: self.	! !

!ClassDescription methodsFor: '*rpackage-core' stamp: 'tg 3/16/2010 17:36'!
packageFromOrganizer: anOrganizer
	"returns the package that defines this class"
	^ anOrganizer packageOf: self.
	! !

!ClassDescription methodsFor: '*rpackage-core' stamp: 'StephaneDucasse 6/3/2012 22:34'!
packageOrganizer
	"Returns the organizer of this class"
	^ RPackage organizer ! !

!ClassDescription methodsFor: '*rpackage-core' stamp: 'sd 5/19/2010 16:31'!
packages
	"the extending packages of a class are the packages that extend it."
	
	^  self extendingPackages asSet copy add: self package; yourself! !
RPackage initialize!
MCMockRPackage initialize!
RPackageOrganizer initialize!
